// charts.js

function CT_PageLoad(ctObjectParent, ctQueryID, ctTableName) {

	// make the call for the chart
	this.CT_Submit = function ( ctObject ) {
		var ct_fieldX = this.getElementByClassName(ctObject, 'dax_ct_field_x');
		var ct_type = this.getElementByClassName(ctObject, 'dax_ct_typeselect');
		var ct_fieldsY = this.getElementsByClassName(ctObject, 'dax_ct_field_y');

		var ctTableID = tableObject.tableid;
		var chartURL = '/DAX/chart?sessionid=' + top.dax_bridge.sessionId + '&queryid=' + ctQueryID + '&tableid=' + ctTableID;
		chartURL += '&charttype=' + ct_type.value + '&fieldx=' + ct_fieldX.value + '&fieldy=';
		
		for ( var i = 0 ; i < ct_fieldsY.length ; i++ ) {
			chartURL += ct_fieldsY[i].value + ',';
		}

		top.debugAlert('<b>Chart:</b>'+'<a href="'+chartURL+'" target="_blank">'+chartURL+'</a>');
		new top.DDW( chartURL, 'static_url', STR['qe_chart'] );
	}


// add another y axis line
	this.CT_AddYAxis = function (yAxisLine) {
		var newYAxisLineDiv = yAxisLine.cloneNode(true);
		
		var i = 1;
		while (this.$('dax_ct_y_line' + i) != null) {
			i++;
		}
		newYAxisLineDiv.id = 'dax_ct_y_line' + i;
		newYAxisLineDiv.parent = yAxisLine.parent;
	
		var nodesLength = newYAxisLineDiv.parent.childNodes.length;

	// rename the y select object
		var fieldsSelectY = this.getElementByClassName(newYAxisLineDiv, 'dax_ct_field_y');
		fieldsSelectY.name = fieldsSelectY.name + ( nodesLength + '');

	// get the duplicated select object and disable it
		var previousSelect = yAxisLine.getElementsByTagName("select").item(0);
		previousSelect.disabled = true;
		var previousAddButton = yAxisLine.getElementsByTagName("input").item(0);
		previousAddButton.disabled = true;

		var chosenValue = previousSelect.value;
		var currentSelect = newYAxisLineDiv.getElementsByTagName("select").item(0);

	//	remove already selected item from new select
		for ( i = 0 ; i < currentSelect.options.length ; i++ ) {
			if ( currentSelect.options[i].value ==  chosenValue ) {
				currentSelect.removeChild( currentSelect.options[i] );
			}
		}

	// assign the add button click
		var addLineButton = this.getElementByClassName(newYAxisLineDiv, 'dax_ct_add_y');
		if ( currentSelect.options.length == 1 ) {
			addLineButton.disabled = true;
		} else {
			addLineButton.disabled = false;
			addLineButton.onclick = function () { CT_AddYAxis(newYAxisLineDiv) };
		}

	// assign the remove button click
		var removeLineButton = this.getElementByClassName(newYAxisLineDiv, 'dax_ct_remove_y');
		removeLineButton.disabled = false;
		removeLineButton.onclick = function () { CT_RemoveYAxis(newYAxisLineDiv.parent, newYAxisLineDiv) };
		
		yAxisLine.parent.appendChild(newYAxisLineDiv);
	}

// remove a y axis line
	this.CT_RemoveYAxis = function (ctParentObject, removeLine) {
		var removeSelect = removeLine.getElementsByTagName("select").item(0);
		var currentOption = removeSelect.options[removeSelect.selectedIndex]; 
		var currentSelects = ctParentObject.getElementsByTagName("select");
		
		for ( var i = 0 ; i < currentSelects.length ; i++ ) {
			if ( currentSelects[i].disabled == false ) {
				var selected = currentSelects[i].selectedIndex;
				currentSelects[i].appendChild(currentOption);
				currentSelects[i].selectedIndex = selected;
			}
		}

		ctParentObject.removeChild(removeLine);
		
		var currentLines = this.getElementsByClassName(ctParentObject, 'dax_ct_y_line');
		var lastLine = currentLines[(currentLines.length)-1];
		
		var addRemoveButtons = lastLine.getElementsByTagName("input");
		for ( i = addRemoveButtons.length-1 ; i >= 0 ; i-- ) {
			if ( addRemoveButtons.item(i).value == '+' ) {
				addRemoveButtons.item(i).disabled = false;
				addRemoveButtons.item(i).onclick = function () { CT_AddYAxis(lastLine) };
				break;
			}
		}
				
		currentSelects = ctParentObject.getElementsByTagName("select");
		currentSelects[currentSelects.length-1].disabled = false;
	}


// *** start of main function
	ctObjectParent.innerHTML = '';

// get the html template code and clone it
	var ctObjectTemplate = this.getTemplate('dax_chart_engine');
	var ctObject = ctObjectTemplate.cloneNode(true);
	ctObject.style.display = 'block';

// get a unique id for the cloned template
	var i = 1;
	while (this.$('dax_chart_engine' + i) != null) {
		i++;
	}
	ctObject.id = 'dax_chart_engine' + i;

//	get the selected table object
	var tableObject = top.getTable(ctTableName);

// cache the fields for the selected table
	top.dax_bridge.cacheFields( tableObject );

// get the x select object
	var fieldsSelectX = this.getElementByClassName(ctObject, 'dax_ct_field_x');
	fieldsSelectX.name = fieldsSelectX.name + '1';

// load the fields for the x select object
	var selectOption = this.getElementByClassName(ctObject, 'dax_ct_fieldoption_x');
	for ( var i = 0 ; i < tableObject.fields.length ; i++ ) {
		if ( tableObject.fields[i].fieldtype != 'picture' ) {
			selectOption.text = tableObject.fields[i].fieldalias;
			selectOption.value = tableObject.fields[i].fieldid;
			fieldsSelectX.appendChild( selectOption );
			selectOption = selectOption.cloneNode(true);
		}
	}

	var yAxisLines = this.getElementByClassName(ctObject, 'dax_ct_y_lines');
	var yAxisLine = this.getElementByClassName(ctObject, 'dax_ct_y_line');
	yAxisLine.parent = yAxisLines;
	
// get the y select object
	var fieldsSelectY = this.getElementByClassName(yAxisLine, 'dax_ct_field_y');
	fieldsSelectY.name = fieldsSelectY.name + '1';

// load the fields for the y select object
	selectOption = this.getElementByClassName(yAxisLine, 'dax_ct_fieldoption_y');
	for ( var i = 0 ; i < tableObject.fields.length ; i++ ) {
		if (( tableObject.fields[i].fieldtype == 'integer' ) || 
			( tableObject.fields[i].fieldtype == 'real' ) ||
			( tableObject.fields[i].fieldtype == 'longint' )) {
			selectOption.text = tableObject.fields[i].fieldalias;
			selectOption.value = tableObject.fields[i].fieldid;
			fieldsSelectY.appendChild( selectOption );
			selectOption = selectOption.cloneNode(true);
		}
	}

// assign the add and remove line clicks
	var addLineButton = this.getElementByClassName(yAxisLine, 'dax_ct_add_y');
	var removeLineButton = this.getElementByClassName(yAxisLine, 'dax_ct_remove_y');
	addLineButton.onclick = function () { CT_AddYAxis(yAxisLine) };
	removeLineButton.disabled = true;

// get the type select object
	var typeSelect = this.getElementByClassName(ctObject, 'dax_ct_typeselect');
	typeSelect.name = typeSelect.name + '1';

// build the type select options

//	currently unused types: area-1, picture-3, scatter-5, polar-7, 2D XY-8, 
//	3D Column-100, 3D Line-101, 3D Area-102, 3D Surface-103, 3D Triangle-104, 3D Spike-105
	var typeOptions = STR['ct_charttypes'].slice(); 
	var typeValues = new Array('2', '4', '6');

	selectOption = this.getElementByClassName(ctObject, 'dax_ct_typeoption');
	for ( var i = 0 ; i < typeOptions.length ; i++ ) {
		selectOption.text = typeOptions[i];
		selectOption.value = typeValues[i];
		typeSelect.appendChild( selectOption );
		selectOption = selectOption.cloneNode(true);
	}

//	set up the submit button
	var queryGraphButton = this.getElementByClassName(ctObject, 'dax_ct_chart', true);
	queryGraphButton.innerHTML = STR['qe_chart'];
	queryGraphButton.onclick = function() { CT_Submit(ctObject); return false; };		

	if (( fieldsSelectX.value == '' ) || 
		( fieldsSelectY.value == '' )) {
		queryGraphButton.disabled = true;
	}

// append the ct object to the passed div
	ctObjectParent.appendChild(ctObject);
}
