//connect.js by Jonathan Le

function Connection()
{
	this.sessionId = "";
	this.language = "";
	
	this.address = new Object();
	this.address.url = "DAX/";
	this.address.login = this.address.url + "Login";
	this.address.gettablelist = this.address.url + "GetTableList";
	this.address.getfieldlist = this.address.url + "GetFieldList";
	this.address.allrecords = this.address.url + "AllRecords";
	this.address.query = this.address.url + "Query";
	this.address.clearquery = this.address.url + "ClearQuery";
	this.address.getrecord = this.address.url + "GetRecord";
	this.address.deleterecord = this.address.url + "DeleteRecord";
	this.address.modifyrecord = this.address.url + "ModifyRecord";
	this.address.addrecord = this.address.url + "AddRecord";
	this.address.getrelatedlist = this.address.url + "GetRelatedList";
	this.address.executecallback = this.address.url + "ExecuteCallBack";
	this.address.getcallback = this.address.url + "GetCallBack";
	this.address.getDDWInfo = this.address.url + "GetDDWInfo";
	this.address.getgeneralprefs = this.address.url + "GetPreferences";
	this.address.getgrouplist = this.address.url + "AdminGetGroupList";
	this.address.admingettablepreferences = this.address.url + "AdminGetTablePreferences";
	this.address.admingetfieldpreferences = this.address.url + "AdminGetFieldPreferences";
	this.address.adminsettablepreferences = this.address.url + "AdminSetTablePreferences";
	this.address.adminsetfieldpreferences = this.address.url + "AdminSetFieldPreferences";
	this.address.adminsetselectionview = this.address.url + "AdminSetSelectionView";
	this.address.adminsetfieldbreakpoint = this.address.url + "AdminSetBreakPoint";
	this.address.admincreatenewview = this.address.url + "AdminCreateVirtualTable";
	this.address.admindeleteview = this.address.url + "AdminDeleteVirtualTable";
	this.address.admingetrelatedtables = this.address.url + "AdminGetRelatedTable";
	this.address.admingetgeneralprefs = this.address.url + "AdminGetPreferences";
	this.address.adminsetgeneralprefs = this.address.url + "AdminSetPreferences";
	this.address.admingetcallback = this.address.url + "AdminGetCallBack";
	this.address.adminsetcallback = this.address.url + "AdminSetCallBack";
	this.address.adminsettableposition = this.address.url + "AdminSetTablePosition";
	this.address.adminsetfieldposition = this.address.url + "AdminSetFieldPosition";
	this.address.admincreateDDWinfo = this.address.url + "AdminCreateDDWInfo";
	this.address.admindeleteDDWinfo = this.address.url + "AdminDeleteDDW";
	this.address.adminsetDDWtoobject = this.address.url + "AdminSetDDWToObject";
	this.address.admingetQueryList = this.address.url + "AdminGetQueriesList";
	this.address.adminsetQueryInfo = this.address.url + "AdminSetQueryInfo";
	this.address.admindeleteQuery = this.address.url + "AdminDeleteQuery";
	this.address.admingetquerytemplates = this.address.url + "AdminGetQueryTemplates";
	this.address.adminSetQueryTemplate = this.address.url + "AdminSetQueryTemplate";
	this.address.adminSetQueryPosition = this.address.url + "AdminSetQueryPosition";
	this.address.AdminSetAllRecords = this.address.url + "AdminSetAllRecords";
	this.address.AdminGetAllRecords = this.address.url + "AdminGetAllRecords";
	
	
	this.command = function(aSelector) {
		return this.address.url + aSelector + "?sessionid="+this.sessionId;
	};
		
	this.setAddress =
		function(url)
		{
			this.address.url = url;
		};
	this.admin = false;
}

function getXMLHttpRequest()
{
    var http_request = false;

    if (window.XMLHttpRequest) { // Mozilla, Safari,...
        http_request = new XMLHttpRequest();
        if (http_request.overrideMimeType) {
            http_request.overrideMimeType('text/xml');
         }
    } else if (window.ActiveXObject) { // IE
    /*@cc_on
    	@if (@_jscript_version >= 5)
	        try {
	            http_request = new ActiveXObject("Msxml2.XMLHTTP");
	        } catch (e) {
	            try {
	                http_request = new ActiveXObject("Microsoft.XMLHTTP");
	            } catch (e) {}
	        }
        @end
   	@*/
    }

	return http_request;
}

// url - string (url to request)
// handler - function (how to handle the request)
// postdata - string of postdata
function makeRequest(url, handler, postdata) {
	var http_request = getXMLHttpRequest();
	
	if (!http_request)
		return;
      
    http_request.onreadystatechange = function() { handler(http_request); };
    
    var command = "GET";
    
    if (postdata)
    	command = "POST"
       
    try {
		http_request.open(command, url, true);
		
		if (postdata)
		   	http_request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
		
  	  	http_request.send(postdata);
    } catch(e) {
    	alert(e);
    
    }
}

///////////////////////////////
// Database Functions
///////////////////////////////

function buildFieldList(table_id)
{
	// make another request
	var http_request = getXMLHttpRequest();
	
	if (http_request) {
		// http_request.onreadystatechange = function() {  };

		try {
			var url = connection.address.getfieldlist + "?tableid=" + table_id + "&sessionid=" + connection.sessionId;

			http_request.open("GET", url, false);
  	  		http_request.send(null);
			drawFields(http_request, table_id);
   		} catch(e) {
	    }
	}
}

function drawFields(http_request, table_id) {
	if (http_request.readyState != 4 || http_request.status != 200)
   		return;
   	
	// now build the fields
	var table = http_request.responseXML.getElementsByTagName("fields").item(0);
	var fieldList = table ? table.getElementsByTagName("field") : null;
		
	var tp = structure;
	var table = null;
	
	for (var i in tp.tables) {
		if (tp.tables[i].tableid == table_id) {
			table = tp.tables[i];
			table.fields = new Array();
		}
	}
	
	if (!fieldList) {
		table.updating = false;
		http_request.onreadystatechange = null;
		delete http_request;
		return;
	}
	
	// now we update the structure
	for (var i = 0; i < fieldList.length; i++) {
		field_name = fieldList.item(i).getAttribute("alias");
		field_id = fieldList.item(i).getAttribute("id");
		field_type = fieldList.item(i).getAttribute("type");
		field_unique = fieldList.item(i).getAttribute("unique");
		field_mandatory = fieldList.item(i).getAttribute("mandatory");
		field_nonmodifiable = fieldList.item(i).getAttribute("nonModifiable");
		field_nonenterable = fieldList.item(i).getAttribute("nonEnterable");
		field_breaklevel = fieldList.item(i).getAttribute("breaklevel");
		field_format = fieldList.item(i).getAttribute("format");
		field_ddw = fieldList.item(i).getAttribute("ddw");
		field_fieldrecordid = fieldList.item(i).getAttribute("fieldrecordid");
		
		if (table) {
			var field = {
				fieldname : field_name,
				fieldid : field_id,
				fieldtype : field_type,
				fieldunique : field_unique,
				fieldmandatory : field_mandatory,
				fieldnonModifiable : field_nonmodifiable,
				fieldnonEnterable : field_nonenterable,
				fieldbreaklevel : field_breaklevel,
				fieldformat : field_format,
				fieldddw : field_ddw,
				fieldrecordid : field_fieldrecordid
			}
			table.fields.push(field);
		}
	}
	
	// free
	if (table) {
		table.cached = true;
		table.updating = false;
	}
	
	http_request.onreadystatechange = null;
	delete http_request;
}

/**
 * Builds a table in the table pane object.  the table pane object gets the following
 * properties:
 *
 * 
 **/
function buildTableList(http_request)
{
    if (http_request.readyState != 4)
		return;
	
	var database = http_request.responseXML.getElementsByTagName("tables").item(0);
	var tableList = database ? database.getElementsByTagName("table") : null;
	
	if (!tableList)
		return;
	
	structure.tables.length = 0;
	
	// now we are going to update the structure
	for (i = 0; i < tableList.length; i++) {
		var table_id = tableList.item(i).getAttribute("id");
		var table_name = tableList.item(i).getAttribute("alias");

		// add to list of tables
		var table = {
			tableid : table_id,
			tablename : table_name,
			updating : true,
			cached : false
		}

		table.updating = false;	
		
		// update the struct
		structure.tables.push(table);
				
		// build field list.
		// buildFieldList(table_id);
	}
	structure.updating = false;
	structure.cached = true;
	
	// free
	http_request.onreadystatechange = null;
	delete http_request;
	
}

function errorCheck(response)
{
	try {
		var errors = response.getElementsByTagName("error");
		if (errors)
			errors = errors.item(0);
		else
			return false;
			
		var errorCode = errors.getElementsByTagName("errorCode");
		if (errorCode)
			errorCode = errorCode.item(0);
		else
			return false;
			
		var text = getTextNode(errorCode);
		err = text.nodeValue;
		
		on_error(err);
		
		return true;
	} catch (e) {
	}
	
	return false;
}

function login(http_request)
{
	// state 3 LOADING
	// state 4 is DONE
	if (http_request.readyState != 4)
		return;

	$('loginspinner').style.display = 'none';

	var result = http_request.responseXML;

	if (checkResponse(http_request)) {
		on_login_error();
		return;
	}
	
	result = result.getElementsByTagName("loginresult").item(0);
	
	if (!result)
		return;
		
	var success = result.getAttribute("success") == "true";
	
	if (success) {
		// save the session id
		var sessionId = result.getElementsByTagName("sessionId").item(0);
		connection.language = result.getAttribute('language');

		if (sessionId) {
			connection.sessionId = sessionId.firstChild.nodeValue;
			connection.admin = sessionId.getAttribute("AdminFlag") != "no";
			// structure.update();
			
			on_login_success();
		} else {
			// network error?
			on_login_error();
		}
	} else {
		// failed, alert the user
		on_login_error();
	}
	
	http_request.onreadystatechange = null;
	delete http_request;
}

/*
function showRecords(event)
{
	var tablerow = this.parentNode;
	do_allRecords(tablerow.table_id, 0, 25);
}
*/

function query(http_request, element)
{
	if (http_request.readyState != 4) {
		return;
	}
	
//	alert(http_request.responseText);

	var result = http_request.responseXML.getElementsByTagName("queryResult").item(0);
	checkResponse(http_request);
	
	if (!result) {
		if (element.onafterload) {
			element.onafterload(false);
		}
		
		return;
	}
	
	var tableid = result.getAttribute("tableid");
	var queryid = result.getAttribute("queryid");
	var tablename = result.getAttribute("tablename");
	var total = result.getAttribute("recordsinselection");
	
	var rows = result.getElementsByTagName("row");
	var content = null;

	var grid = null;
	
	if (element.grid != null && element.grid != undefined) {
		grid = element.grid; // existing grid used
	} else {
		grid = new Grid(); // new grid created
		element.appendChild(grid.dom);
		element.grid = grid;
		
		var columnNames = new Array();
		grid.total = total;
	}
	
	for (var i = 0; i < rows.length; i++) {
		var row = new Array();
		
		var columns = rows.item(i).getElementsByTagName("field");
		for (var k = 0; k < columns.length; k++) {
			var value = getTextNode(columns.item(k));
			if (value != null || value != undefined) {
				row[k] = value.nodeValue;
			} else {
				row[k] = "";
			}
			
			if (i == 0 && isDefined(columnNames)) {
				columnNames[k] = columns.item(k).getAttribute("name");
			}
		}

		grid.insertRow(row);
	}
	
	if (isDefined(columnNames)) {
		for (var i = 0; i < columnNames.length; i++) {
			grid.column(i).setTitle(columnNames[i]);
		}
	
		var selectCol = new GridColumn();
		selectCol.type = 0;
		var rowCount = grid.length;
	} else {
		var selectCol = grid.column(0);
	}

	grid.refresh();
	
	// call event handler
	if (element.onafterload) {
		element.onafterload(true);
	}
	http_request.onreadystatechange = null;
	delete http_request;
}

function refresh_table(obj)
{
	// find the toolbar
	var toolbar = null;
	if (!(toolbar = getParentByClassName(obj, "window_toolbar")))
		return;
	
	var contentArea = toolbar.parent.contentArea;
	var grid = contentArea.grid;	
	grid.reload();
}

/*
function recordSingleClicked(event)
{
	var row = this;
	var tablebody = row.parentNode;
	
	if (!tablebody.expanded || tablebody.expander.parent != row) {
		// make another request
		var http_request = getXMLHttpRequest();
		
		if (http_request) {
			var tableid = row.tableid;
			var recordid = row.recordid;
				
			http_request.onreadystatechange = function() { expandRecord(http_request, row); };
			
			try {
				var url = connection.address.getrecord + "?tableid=" + tableid + "&recordid="+recordid+"&sessionid=" + connection.sessionId;
							
				http_request.open("GET", url, true);
	  	  		http_request.send(null);
	   		} catch(e) {
		   		http_request.onreadystatechange = null;
	   			delete http_request;
		    }
		}

	} else {
		tablebody.expander.style.display = "none";
		tablebody.expanded = false;
	}
	
}
*/

function expandRecord(http_request, row)
{
	if (http_request.readyState != 4)
		return;
	
	var result = http_request.responseXML.getElementsByTagName("queryResult").item(0);
	var errorResponse = checkResponse(http_request);
	var tableid = result.getAttribute("tableid");

	var tablebody = row.parentNode;
	var colcount = row.getElementsByTagName("td").length;

	var record = result.getElementsByTagName("row").item(0);
	var recordid = record.getAttribute("recordid");
	
	var fields = record.getElementsByTagName("field");
	
	// create the record input form
	tablebody = drawRecordInput(fields, tablebody, tableid);

	var inputs = tablebody.recordInput.getElementsByTagName("input");
	
	// ok now insert the record values
	for (var i = 0; i < fields.length; i++) {
		var fieldName = fields.item(i).getAttribute("name");
		var fieldid = fields.item(i).getAttribute("id");
		var fieldtype = structure.getField(tableid, fieldid).fieldtype;
		
		for (var k = 0; k < inputs.length; k++) {
			var input = inputs.item(i);
			if (input.name == fieldName) {
				var text = getTextNode(fields.item(i));
				
				switch (fieldtype) {
					case 'picture':
						input.img.src = text.nodeValue;
						input.href.href = input.img.src;
						break;
					default:
						if (text)
							input.value = text.nodeValue;
				}
				
				k = inputs.length;
			}
		}
	}
	
	tablebody.expander.parent = row;
	if (browser.ie)
		tablebody.expander.style.display = "block";
	else
		tablebody.expander.style.display = "table-row";
	
	tablebody.recordInput.recordid = recordid;
	tablebody.recordInput.tableid = tableid;
	tablebody.recordInput.style.visibility = "visible";
	tablebody.recordInput.style.display = "block";
	tablebody.expanded = true;
	
	tablebody.insertBefore(tablebody.expander, row.nextSibling);
	http_request.onreadystatechange = null;
	delete http_request;
}

function selectRecord(event)
{
	// parent of the checkbox
	var row = this.parentNode.parentNode.parentNode;
	
	// highlighting
	if (!row.selected) {
		row.className = "recordHighlight";
		row.selected = true;
	} else {
		if (row.selectionid % 2) {
			row.className = "recordLine";
		} else {
			row.className = "recordLineAlt";
		}
		row.selected = false;
	}
	
	event.cancelBubble = true;
	event.returnValue = false;
}

function delete_records(obj)
{
	var toolbar = null;
	if (!(toolbar = getParentByClassName(obj, "window_toolbar")))
		return;

	var win = toolbar.parent;
	var content = win.contentArea;
	var grid = content.grid;
	
	if (!isDefined(grid.selection) || !isDefined(grid.selection.selected))
		return;

	// ask the user	
	var rv = confirm(STR['confirm_delete_records']);
	
	if (!rv)
		return;
	
	var url = connection.command(DB.DELETE_RECORD);
	var postdata ="sessionid="+connection.sessionId+"&tableid=" + grid.selection.tableId + "&recordid=";
	
	for (recordId in grid.selection.selected) {
		if (grid.selection.selected[recordId])
			postdata += recordId+",";
	}
	
	var http_request = getXMLHttpRequest();
		
	if (!http_request)
		return;
		
	try {

		debugAlert('<b>delete_record url:</b>'+'<a href="'+url+'" target="_blank">'+url+'</a>');
		debugAlert('<b>delete_record post:</b>'+postdata);
		
		http_request.onreadystatechange = function() { deleteRecord(http_request, obj); };
		http_request.open("POST", url, true);
		http_request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	  	http_request.send(postdata);
	} catch (e) {
		alert(e);
		http_request.onreadystatechange = null;
		delete http_request;
	}
}

function deleteRecord(http_request, obj)
{
	if (http_request.readyState != 4)
		return;

	var result = http_request.responseXML.getElementsByTagName("result").item(0);
	var errorResponse = checkResponse(http_request);
	
	if (!isDefined(result)) {
		//alert('check response ' + http_request.responseText);
		var errorCode = http_request.responseXML.getElementsByTagName("errorCode");
		if ((errorCode) && (errorCode[0])) {
			// get error properties
			var errorElement = errorCode[0];
			alert (errorElement.getAttribute ('message'));
		}
		http_request.onreadystatechange = null;
		delete http_request;
		return;
	}
	
	var toolbar = null;
	if (!(toolbar = getParentByClassName(obj, "window_toolbar")))
		return;

	var win = toolbar.parent;
	var content = win.contentArea;
	var grid = content.grid;	
	
	// clear the selection
	if (grid.selection.selected)
		grid.selection.selected = new Array();
	
	// refresh the table
	inline_query(obj, null, "*");

	http_request.onreadystatechange = null;
	delete http_request;
}

function save_new_record(recordInput)
{
	//var recordInput = getParentByClassName(obj, "recordInput");
	
	if(!recordInput)
		return;
	
	var url = connection.address.addrecord + "?sessionid="+connection.sessionId+"&tableid=" + recordInput.tableid;
	var fields = getElementsByClassName(recordInput, "fieldValue");
	
	for (var i = 0; i < fields.length; i++) {
		url += "&field" + fields[i].fieldid + "=" + fields[i].value;
	}
	
	makeRequest(url, saveRecord, null);
}

/*

function clearQuery (queryid)
{
	if (!queryid)
		return;
	
	var url = connection.address.clearquery + "?sessionid="+connection.sessionId+"&queryid="+queryid;
	makeRequest(url, clearQuery_handler, null);		

}

function clearQuery_handler (http_reply)
{
}
*/




function save_record(obj)
{
	var recordInput = getParentByClassName(obj, "recordInput");
	
	if(!recordInput)
		return;
	
	var url = connection.address.modifyrecord + "?sessionid="+connection.sessionId+"&tableid=" + recordInput.tableid + "&recordid=" + recordInput.recordid;
	
	// TODO: switch to getElementsByClassName
	var fields = getElementsByClassName(recordInput, "fieldValue");
	
	for (var i = 0; i < fields.length; i++) {
		url += "&field" + fields[i].fieldid + "=" + fields[i].value;
	}
	
	makeRequest(url, saveRecord, null);
}

function saveRecord(http_request)
{
	if (http_request.readyState != 4)
		return;

	//alert(http_request.responseText);	
	http_request.onreadystatechange = null;
	delete http_request;
}

function close_record(obj)
{
	var recordInput = getParentByClassName(obj, "recordInput");
	
	var expander = recordInput.parentNode;
	var tablebody = expander.parerentNode;
	
	expander.style.display = "none";
	tablebody.expanded = false;
}

function create_record(obj)
{
	var toolbar = null;
	if (!(toolbar = getParentByClassName(obj, "window_toolbar")))
		return;

	// cover the content area
	var win = toolbar.parent;
	
	// find the editor if we have one, otherwise create a new one
	var editor = win.getEditor();
	// clear the editor, set its record to -1 to signify that it is a new record
	//if (isDefined(editor.record)) {
	//	editor.record.recordId = -1;
	//	editor.getDOM().deleteBtn.disabled = false; // make sure an empty record can't be deleted
	//	
	//} else {
	var grid = win.contentArea.grid;
	editor.record = { recordId : -1, tableId: grid.selection.tableId };
	editor.buildEditorByTable(grid.selection.tableId);
	//}
	
	// now we are ready to edit
	//editor.clear();
	editor.edit();
	
/*	
	var body = document.getElementsByTagName("body").item(0);
	var recordPopout = $('recordPopout');
	
	recordPopout = recordPopout.cloneNode(true);
	recordPopout.style.display = "block";
	
	recordPopout.className = "createRecord";
	recordPopout.id = "cr_" + getElementsByClassName(body, "createRecord").length + 1;
	
	var popoutInput = getElementByClassName(recordPopout, "popoutInput");
	
	// the record input
	var recordInput = getElementByClassName(contentArea, "recordInput");
	var tableid = recordInput.tableid;
	var fields = getElementsByClassName(recordInput, "fieldValue");
	
	if (recordInput) {
		recordInput = recordInput.cloneNode(true);
		recordInput.onclick = function(event) { event.cancelBubble = true; };
		recordInput.id = "ri_"+recordPopout.id;
		recordInput.tableid = tableid;
		
		popoutInput.appendChild(recordInput);
		
		// styles
		recordInput.style.visibility = "visible";
		recordInput.style.display = "block";
		
		recordInput.className = "";
		
		// clear the values
		var inputs = getElementsByClassName(recordInput, "fieldValue");
		for (var i = 0; i < inputs.length; i++) {
			inputs[i].value = "";
			inputs[i].onmousedown =
				function(event) {
					event.cancelBubble = true;
				};
			
			// TODO: change this to properly reflect field id
			inputs[i].fieldid = fields[i].fieldid;
			
			var fieldtype = structure.getField(tableid, inputs[i].fieldid).fieldtype;
	
			if (fieldtype == "picture") {
				inputs[i].previousSibling.style.display = "none"; 
				
				inputs[i].style.display = "block";
				inputs[i].type = "file";
			}
		}

		// add the window taskbar item
		var tbitem = do_addTaskbarItem($('window_tbitem').cloneNode(true));
	
		if (tbitem) {
			tbitem.style.display = 'block';
			tbitem.onclick = function() { $(recordPopout.id).style.zIndex = ++WindowManager.maxZIndex; };		
			tbitem.id = "tb_"+recordPopout.id;
		
			var tbitem_name = getElementByClassName(tbitem, "tbitem_name");
			if (tbitem_name)
				tbitem_name.innerHTML = "Create Record";
		}

		// set events for buttons		
		var cancelBtn = getElementByClassName(recordInput, "recordCancel");
		var saveBtn = getElementByClassName(recordInput, "recordSave");
		
		cancelBtn.onclick = 
			function() {
				var body = document.getElementsByTagName('body').item(0);
				body.removeChild(recordPopout);
				
				do_removeTaskbarItem($(tbitem.id));
				
			};
			
		saveBtn.onclick = 
			function() {
				save_new_record($(recordInput.id));
				cancelBtn.onclick();
			}
	}
	
	body.appendChild(recordPopout);
	recordPopout.style.zIndex = ++WindowManager.maxZIndex;
	
	do_enableDragging(recordPopout);
	*/
}

function save_query(obj, tableid, fieldid, queryname, queryId)
{

	// the obj expecting to save the query
	var toolbar = null;
//	var grid = null;
	if (!(toolbar = getParentByClassName(obj, "window_toolbar")))
		return;
		
	var win = toolbar.parent;
//	var grid = getElementByClassName(win.dom, "newgrid");	

	var tabsFrame = win.toolbars[1];
	if (tabsFrame != null && tabsFrame != undefined) {
		var tabs = tabsFrame.parent;
		var previousTooltip = tabs.current.tooltip;
		var tab = tabs.insert(queryname);
		
		tab.m.innerHTML = '<div style="display:inline; float: left">' + queryname + '</div><div class="dax_taskbar_close"></div>';

		if (previousTooltip)
			tab.tooltip = previousTooltip  + ' ' + STR['and'] + ' <br />';
		else
			tab.tooltip = '';

		var deleteButton = getElementByClassName(tab.m, 'dax_taskbar_close');
		
		if (deleteButton) {
			deleteButton.boundTo = tab;
			deleteButton.onclick = function() {
				var tabs = this.boundTo.parent;
				if (!tabs.lock) {
					tabs.lock = true;
					if (this.boundTo.tooltip)
						hideTooltip();
					tabs.remove(this.boundTo.index);
//					tabs.activate(0);
//					tabs.tab(0).dom.onclick();
					tabs.refresh();
					tabs.lock = false;
				}
			}		
		}
			
		tab.tooltip += '<b>' + getField(tableid, fieldid).fieldalias + '</b> ' + STR['starts_with'] + ' <b>' + queryname + '</b>';
			
		// update query id
		obj.owner.currentQueryId = obj.owner.grid.receivedQueryId;			
		obj.owner.grid.currentQueryId = obj.owner.grid.receivedQueryId;			
		obj.owner.search.inputBox.queryId = obj.owner.grid.receivedQueryId;
		obj.owner.grid.selection.queryId = obj.owner.grid.receivedQueryId;
		obj.inputBox.queryId = obj.owner.grid.receivedQueryId;
		
		tab.owner = obj.owner;
		tab.queryId = queryId;
		obj.owner.currentTab = tab;
		tab.onswitch = function()
		{
			if (this.owner.grid.selection)		
				this.owner.grid.selection.selected = new Array();
			// do an inline query
			this.owner.currentTab = this;
			inline_query(obj, fieldid, '*', this.queryId);
			this.owner.search.inputBox.value = '';
			getElementByClassName (this.owner.dom, 'queryname').queryId = this.queryId;
		}
		
		
		tab.userMouseOver = function (aEvent) {
			//this.className = 'dax_sidebar_button ' + this.defaultClass + '_o';
			if (this.tooltip) {
				objectPos = getObjectPosition (this.r);
				showTooltip(this.tooltip, objectPos.x, objectPos.y + this.r.offsetHeight);
			}
		}
		
		
		tab.userMouseOut = function (aEvent) {
			//this.className = 'dax_sidebar_button ' + this.defaultClass;
			if (this.tooltip)
				hideTooltip();
		}
		
		tabs.refresh();
	
	}
}

function activateTab(event, tab)
{
	// the actor is set to active
	tab.actor.className = "tabItemActive";
	
	var parent = tab.parent;
	parent.current = tab;
	
	// every other tab becomes inactive
	for (var i in parent.tabs) {
		if (parent.tabs[i] != tab)
			parent.tabs[i].actor.className = "tabItemInactive";
	}
	
	on_tab_switched(tab);
}


function drawRecordInput(fields, tablebody, tableid)
{
	if (!fields || !tablebody)
		return;
	
	// create another row, set the colspan
	// there should only be one per table
	if (!tablebody.expander) {
		tablebody.expander = document.createElement("tr");
		var area = document.createElement("td");
		area.colSpan = fields.length + 1;
	
		// TODO: change from framework to dax
		var doc = frames['framework'].document;
		tablebody.recordInput = getElementByClassName(doc, "recordInput").cloneNode(true);

		// fill out the labels
		for (var i = 0; i < fields.length; i++) {
			var fieldid = fields.item(i).getAttribute("id");
			var label = getElementByClassName(tablebody.recordInput, "fieldLabel");
			var fieldArea = getElementByClassName(tablebody.recordInput, "fieldArea")
			var fieldtype = structure.getField(tableid, fieldid).fieldtype;
			
			if (i > 0) {
				label = label.cloneNode(true);
				fieldArea = fieldArea.cloneNode(true);
			} else {
				var containerRow = fieldArea.parentNode;
				var parentTable = containerRow.parentNode;
				var saveRow = containerRow.nextSibling;
			}
			
			// now get the label
			var fieldName = fields.item(i).getAttribute("name");
			label.innerHTML = fieldName;
			
			// find the input so we can manipulate it
			var input = fieldArea.getElementsByTagName("input").item(0);
			
			switch (fieldtype) {
				case 'picture':
					var img = document.createElement("img");
					img.style.width = "125px";
					img.style.height = "125px";
					img.style.borderWidth = "0px";

					var link = document.createElement("a");
					link.target = "_blank";
					link.appendChild(img);
										
					fieldArea.insertBefore(link, input);
					
					input.img = img;
					input.href = link;
					input.style.display = "none";
				default:			
					input.name = fieldName;
					input.fieldid = fieldid;
			}
			
			// switch row if necessary
			if (i > 0 && (i % 2 == 0)) {
				containerRow = containerRow.cloneNode(false);
				parentTable.insertBefore(containerRow, saveRow);
			}
			
			// add the new field area and label
			containerRow.appendChild(label);
			containerRow.appendChild(fieldArea);
		}
		
		area.appendChild(tablebody.recordInput);
		tablebody.expander.appendChild(area);
	}
	
	return tablebody;
}

/**
 * Handler for populating html elements where id = field name in a record.  Field names
 * must be fully qualified in 4D style, i.e. [Table 1]Field 1
 *
 * @author Jonathan Le
 **/
function populateElementsByIds(http_request, ids, propertyNames)
{
	if (http_request.readyState != 4)
		return;

	// build the arrays
	var result = http_request.responseXML;
	result = result.getElementsByTagName("queryResult");
	if (result.length > 0)
		result = result.item(0);
	else
		return;
	
	var row = result.getElementsByTagName("row");
	if (row.length > 0)
		row = row.item(0);
	else
		return;
	
	var tablename = result.getAttribute("tablename");
	var tableid = result.getAttribute("tableid");
	
	var fields = row.getElementsByTagName("field");
	var values = new Array(ids.length);
	var fieldName = "";
	var fieldValue = "";
	
	for (var i = 0; i < fields.length; i++) {
		fieldName = "[" + tablename + "]" + fields.item(i).getAttribute("name");
		var value = getTextNode(fields.item(i));
		if (value)
			fieldValue = value.nodeValue;
		else
			fieldValue = "";
		
		for (var k in ids) {
			//alert(ids[k]+"/"+propertyNames[k]);
			if (ids[k].toLowerCase() == fieldName.toLowerCase()) {
				values[k] = fieldValue;
				if (propertyNames) {
					// if attributeName is present, then set the attribute id
					$(ids[k])[propertyNames[k]] = fieldValue;
				} else {
					// otherwise, set the innerHTML
					$(ids[k]).innerHTML = fieldValue;
				}
			} else {
				if (values[k] == undefined || values[k] == null)
					values[k] = '';
			}
		}
	}
	
	// now also populate related fields
	var hr = getXMLHttpRequest();
	var sessionId = connection.sessionId;
		
	if (hr) {
		var url = connection.address.getrelatedlist + "?sessionId=" + sessionId + "&tableid=" + tableid;
		
		hr.onreadystatechange = 
			function() {
				populateRelated(hr, ids, values, propertyNames);
			};
			
		try {
			hr.open("GET", url, true);
	  	  	hr.send(null);
	   	} catch(e) {
	   		delete hr;
		}
	}	
	http_request.onreadystatechange = null;
	delete http_request;
}

function populateRelated(http_request, ids, values, propertyNames)
{
	// do a query
	if (http_request.readyState != 4)
		return;
	
	var result = http_request.responseXML;
	if (!result)
		return;
	
	var related = result.getElementsByTagName("related").item(0);
	var fields = related.getElementsByTagName("relatedfield");
	
	for (var i = 0; i < fields.length; i++) {
		var fieldname = fields[i].getAttribute("fieldname");
		var tablename = fields[i].getAttribute("tablename");
		var qualField = "[" + tablename + "]" + fieldname;
	
		var field = fields.item(i).getElementsByTagName("field").item(0);
		var table = fields.item(i).getElementsByTagName("table").item(0);
		
		var fieldid = field.getAttribute("fieldid");
		var tableid = table.getAttribute("tableid");
		
		for (var k = 0; k < ids.length; k++) {
			// check if we need to do a query and populate
			if (qualField.toLowerCase() == ids[k].toLowerCase()) {
				// we have a matching field
				var hr = getXMLHttpRequest();
				var sessionId = connection.sessionId;
					
				if (hr) {
					var url = connection.address.query + "?sessionId=" + sessionId + "&tableid=" + tableid + "&fieldid=" + fieldid + "&comp=equal&value=" + values[k] + "&start=1&length=1";
					
					hr.onreadystatechange = 
						function() {
							populateElementsByIds(hr, ids, propertyNames);
						};
						
					try {
						hr.open("GET", url, true);
				  	  	hr.send(null);
				   	} catch(e) {
				   		delete hr;
					}
				}	
			}
		}
	}
	http_request.onreadystatechange = null;
	delete http_request;
}

/**
 * generic record class.
 **/
function Record(tableid, recordid)
{
	this.tableid = tableid;
	this.recordid = recordid;
}