// static global objects
var WindowManager = new WindowManager(); // singleton
var browser = new Browser();
var os = new OS();
var connection = new Connection();
var structure = new Structure();
var dax = new Framework();
var itemfrom = 0;
var itemto = 0;
var labeledit = false;
var editedobject = 0;
var userlanguage = "";

var taskbar; // reserved for taskbar
var aSidebar; // reserved for sidebar

// load english by default
var STR = STR_EN;

// do a browser check
if ((!browser.ie7) && (!browser.safari) && (!browser.gecko)) {

	alert (STR['unsupportedbrowser']);

}

// Database Backend commands
var DB = {
	SORT 			: "Sort",
	GET_RECORD 		: "GetRecord",
	MODIFY_RECORD	: "ModifyRecord",
	ADD_RECORD		: "AddRecord",
	DELETE_RECORD	: "DeleteRecord"
};

/**
 * Get the Key Code
 * @ author Julien Feasson
 */
function getkey(e)
{
if (window.event)
   return window.event.keyCode;
else if (e)
   return e.which;
else
   return null;
}


/**
 * Controller
 * @ author Jonathan Le
 */
var Controller = {
	// object focusing
	focusedObject : null,
	setFocused : function(aObject)
	{
		// blur objects when focus needs to be switched
		if (aObject != this.focusedObject) {
			Controller.blur(this.focusedObject);
		}
		
		this.focusedObject = aObject;
	},
	focus : function(aObject)
	{
		this.setFocused(aObject);

	},
	blur : function(aObject)
	{
		if (this.focusedObject && this.focusedObject.blur)
			try {
				this.focusedObject.blur();
			} catch (e) { };

		this.focusedObject = null;
	},
		
	// record locking
	lockedRecords : new Array(),
	recordHash : function(tableId, recordId)
	{
		return tableId+"_"+recordId;
	},
	isLocked : function(tableId, recordId)
	{
		var hash = this.recordHash(tableId, recordId);
		return isDefined(this.lockedRecords[hash]) ? this.lockedRecords[hash] : false;
	},
	lockRecord : function(tableId, recordId)
	{
		this.lockedRecords[this.recordHash(tableId, recordId)] = true;
	},
	unlockRecord : function(tableId, recordId)
	{
		this.lockedRecords[this.recordHash(tableId, recordId)] = false;
	},
	
	// file uploading
	uploading : false, 		// simple flag
	uploads : new Array(), 	// queue of objects wanting to upload
	enqueue : function(aObject)
	{
		// enqueue it
		this.uploads.push(aObject);
		debugAlert('this.uploading = ' + this.uploading);
		//if (!this.uploading){
			debugAlert("!this.uploading");
			this.upload();
			debugAlert('uploaded');
		//}
		//else
			debugAlert('else');
	},
	dequeue : function()
	{
		return this.uploads.shift();
	},
	upload : function()
	{
		// check our resource
		if (this.uploads.length <= 0){
			debugAlert('this.uploads.length <=0');
			return;
		}
//		var debugTest = '.upload() in init.js, this.uploading=' + this.uploading + ' this.isUploadReady()= '+ this.isUploadReady();
//		debugAlert (debugTest);
			
		// if we are not already uploading & resource is ready
		if (!this.uploading && this.isUploadReady()) {
			//debugAlert('!this.uploading && this.isUploadReady())');
			this.uploading = true;
			var object = this.dequeue();
			object.upload(); // object handles its own uploading
			// this.uploading = false;
		} else { // wait
			// sleep
			//debugAlert('ready to upload');
			//debugAlert('length = ' + this.uploads.length);
			var controller = this;
			setTimeout(function() { controller.upload(); }, 15); 
		}
	},
	isUploadReady : function()
	{
		var upload = frames['upload'].document;
		debugAlert('.isUploadReady, upload= ' + upload);
		var state = upload.getElementById("state");
		debugAlert('.isUploadReady, state= ' + state);
		var uploadReply = state ? state.className == "ready" : false;
		if (((!state) & (!this.reloading) & (upload.location.pathname != "/dax/js/templates/upload.html")) | ((upload.getElementById("error")) & (upload.location.pathname != "/DAX/UploadBinary"))) {
			upload.location.href = "dax/js/templates/upload.html?random="+Math.random();
			this.reloading = true;
		}
		else
			if (state)
				this.reloading = false;
		debugAlert ('.isUploadReady, reply=' + uploadReply);
		return uploadReply;
	}
};
document.onkeydown = function(aEvent)
{
	if (Controller.focusedObject && Controller.focusedObject.onkeydown) {
		Controller.focusedObject.onkeydown(aEvent);
	}
};
document.onkeypress = function(aEvent)
{
	if (Controller.focusedObject && Controller.focusedObject.onkeypress) {
		Controller.focusedObject.onkeypress(aEvent);
	}
};
document.onkeyup = function(aEvent)
{
	if (Controller.focusedObject && Controller.focusedObject.onkeyup) {
		Controller.focusedObject.onkeyup(aEvent);
	}
};
document.onclick = function(aEvent)
{
	// release the controller's focused object
	Controller.blur();
}

/*
document.onfocus = function(aEvent)
{
	var target;
	var event = xpEvent(aEvent);
	
	if (event.target)
		target = event.target;
	else if (event.srcElement)
		target = event.srcElement;
		
	if (target.nodeType == 3)
		target = target.parentNode;
	
	assert("testA", target);
};
*/

/*

// the default window onload
window.onload = function()
{
	// init our templates
	dax.init();

};
	
*/	


	
// because IE makes my life a nightmare
if(!document.importNode){
	document.importNode = function(externalNode, deep){
		var newNode = null;

		if (externalNode.nodeType == 1) {
			newNode = document.createElement(externalNode.nodeName);
			for (var i = 0; i < externalNode.attributes.length; i++) {
				var attr = externalNode.attributes[i];
				if (attr.nodeValue != null && attr.nodeValue != "") {
					newNode.setAttribute(attr.name,
						attr.value);
				}
			}
	
			// explicit
			newNode.className = externalNode.className;
			newNode.style.cssText = externalNode.style.cssText;
		} else if (externalNode.nodeType == 3 ) {
			newNode = document.createTextNode(externalNode.nodeValue);
		}
		
		if (deep && externalNode.hasChildNodes()) {
			for (var childNode = externalNode.firstChild; childNode; childNode = childNode.nextSibling) {
				var cloneNode = document.importNode(childNode, true);
				if (cloneNode)
					newNode.appendChild(cloneNode);
			}
		}

		return newNode;
	}
}



// extend Object
Object.inherit =
	function(parent)
	{
		for (var property in parent) {
			this[property] = parent[property];
		}
	};

/**
 * create getters for classes where 'prv' property is used.
 * prv property must declare member variables starting with an 'm' prefix for
 * this to work correctly.
 * @author Jonathan Le
 **/
Function.prototype.decl = function(aClass) {
	if (this.prv) {
		for (var property in this.prv) {
			var name = property.charAt(0) == 'm' ? property.substring(1) : property;
			this['get'+name] =
				new Function("return this.prv['"+property+"'];");
			this['set'+name] =
				new Function("value", "this.prv['"+property+"'] = value;");
		}
	}
}

function Framework() {
	this.initialized = false;
	this.init = function()
	{
		// do something
	};
	
	return this;
}

function Structure() {
	this.tables = new Array();
	this.updating = false;
	this.cached = false;
	
	// retrieve a table
	this.getTable =
		function(id)
		{
			var tp = this;
			for (var i in tp.tables) {
				if ((tp.tables[i].tableid == id) || (tp.tables[i].tablename == id))
					return tp.tables[i];
			}
			return null;
		};
	
	this.getField =
		function(tableid, fieldid)
		{
			var table = this.getTable(tableid);
			for (var i in table.fields) {
				if (table.fields[i].fieldid == fieldid)
					return table.fields[i];
			}
			return null;
		};
	
	this.update =
		function()
		{
			if (connection.sessionId == "" || this.updating)
				return;
			
			if (this.cached) {
				return;
			}
			
			this.updating = true;
			
			var url = connection.address.gettablelist+"?sessionId="+connection.sessionId;
			makeRequest(url, buildTableList, null);
		};
	
	this.isUpdated =
		function()
		{
			if (this.updating)
				return false;
				
			// check each field table to see if any are still updating
			for (var i = 0; i < this.tables.length; i++) {
				if (this.tables[i].updating) {
					return false;
				}
			}
			
			return true;
		};
	
	return this;
}