﻿// resources.js

// English
var STR_EN = {
	
	/* BEGIN LOCALIZATION  */
	
	// messages
	// depreciated by backend errors
	// will be kept around until mid Oct for backwards compatibility
	status_save_success		: "Saved!",
	status_save_fail		: "Save Failed!",
	status_locked			: "Read-only",
	status_err_number		: "Invalid number value.",
	status_err_time			: "Invalid time value.",
	status_err_default		: "Invalid input value.",
	status_delete_success 	: "Record deleted.",
	status_err_delete		: "Error deleting record.",
	status_err_required		: "Fields in red are mandatory.",
	status_err_dup			: "Unique value required.",
	status_err_date			: "Wrong date value/format.",
	status_err_intLength	: "Integer field can not have more than 5 digits.",
	status_err_longIntLength: "Long Int field can not have more than 10 digits.",
	
	// generic messages
	loading					: "Loading...",
	none					: "None",
	search					: "Search",
	fields					: "Fields",
	
	//toolbar, generic, used by several objects
	button_create			: "Create",
	button_refresh			: "Refresh",
	button_delete			: "Delete",
	button_save				: "Save",
	button_cancel			: "Cancel",
	button_ddw1				: "DDW",
	button_close			: "Close",
	button_choose			: "Choose",
	
	// grid
	view_image				: "View Image",
	confirm_delete_records 	: "Delete these records?",
	all						: "All", //for All Records
	
	// data window tabs tooltips
	and						: "AND",
	starts_with				: "starts with",
	
	// calendar
	calendar_month			: ['January','February','March','April','May','June','July','August','September','October','November','December'],
	calendar_month_abr		: ['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec'],
	calendar_weekday		: ['Sun','Mon','Tue','Wed','Thu','Fri','Sat'],
	
	// calendar view
	
	// toolbar, date range
	calendar_toolbar_range		: "Range",			// Range Field_X to Field_Y
	calendar_toolbar_to			: "to",
	calendar_toolbar_display	: "Display",		// Display Field_Z
	calendar_toolbar_none		: "None",			// don't use field for Field_y
	
	// taskbar
	taskbar_admin_label		: "Control Panel",		// Admin button
	taskbar_edit			: "Edit",			// Edit WindowX label
	taskbar_views			: "Portal",			// always displayed in DAX app
	taskbar_debug			: "Console",		// debugger
	image					: "Image",			// Image X
	
	// admin
	//
	
	// main tabs
	admin_generalprefs		: "General Prefs",
	admin_accesscontroltab	: "Access Control",
	admin_ddwmanager		: "DDW Manager",
	admin_querymanager		: "Query Manager",

	// general prefs tab
	admin_taskbarlocation	: "Taskbar location:",
	admin_taskbartop		: "Top",
	admin_taskbarbottom		: "Bottom",
	admin_style				: "Style:",
	admin_preload			: "Number of preloaded selections:",

	// ddw tab
	adminDDW_list			: "DDWs",
	adminDDW_title			: "Title",
	adminDDW_content		: "Content",
	adminDDW_type			: "Type",
	adminDDW_newLink		: "New Window - Link",
	adminDDW_newHTML		: "New Window - HTML Method",
	adminDDW_newText		: "Status Message - Text Method",
	adminDDW_associatedTo	: "Associated to",
	adminDDW_portal			: "Portal",
	adminDDW_other			: "Other",
	adminDDW_create			: "Create",
	adminDDW_cancel			: "Cancel",
	adminDDW_noDDWs			: "You currently have no DDWs.",
	adminDDW_to				: "to",

	// query tab
	adminQuery_List			: "Preset Queries",
	
	adminQuery_name			: "Query Name",
	adminQuery_text			: "Query",
	adminQuery_Selection	: "Selection",
	
	adminQuery_create		: "Create",
	adminQuery_save			: "Save",
	adminQuery_cancel		: "Cancel",
	
	adminQuery_noQueries	: "You currently have no preset Queries.",
	adminQuery_filter		: "Filter:",
	adminQuery_allrecords	: "Display the All Records tab:",
	adminQuery_all			: "All",
	adminQuery_createtitle	: "Create a preset query for this selection:",	
	adminQuery_new			: "Create a new query:",	
	adminQuery_dynamic		: "Set dynamic queries:",	
	adminQuery_template		: "Use this template:",	
	adminQuery_template2	: " and apply it to this field:",	
	adminQuery_Next			: "Next",	
	adminQuery_NotAvailable	: "Not Available",	
	adminQuery_error1		: "Please choose a selection",	
	adminQuery_error2part1	: "A query ",	
	adminQuery_error2part2	: " already exist for this selection.",	
	adminQuery_error3		: "Please enter a name",
	adminQuery_Name			: "Name: ",	
	adminQuery_BoundTo		: " Bound To:",	
	adminQuery_SortField	: "Sorting: Field: ",	
	adminQuery_SortOrder	: " Order:",	
	adminQuery_MaxNb		: "Maximum number of records: ",	
	adminQuery_AddCondition	: "Add a condition:",	
	adminQuery_Field		: "Field:",	
	adminQuery_Operator		: "Operator:",	
	adminQuery_Value		: "Value:",	
	adminQuery_IsAMethod	: "is a method:",	
	adminQuery_Link			: "Link:",	
	adminQuery_Add			: "Add",	
	adminQuery_Conditions	: "Conditions:",	
	adminQuery_Asc			: "Asc",	
	adminQuery_Desc			: "Desc",
	adminQuery_Operator1	: "equal",
	adminQuery_Operator2	: "not equal",
	adminQuery_Operator3	: "less",
	adminQuery_Operator4	: "greater",
	adminQuery_Operator5	: "less or equal",
	adminQuery_Operator6	: "greater or equal",
	adminQuery_Operator7	: "starts with",
	adminQuery_Operator8	: "ends with",
	adminQuery_Link1		: "and",
	adminQuery_Link2		: "or",
	adminQuery_FieldTitle	: "Field",
	adminQuery_OperatorTitle: "Operator",
	adminQuery_ValueTitle	: "Value",
	adminQuery_LinkTitle	: "Link",
	adminQuery_DynamicQuery : "Dynamic Queries",
	adminQuery_DDTs			: "Data Driven Tabs based on ",
	adminQuery_dateTip		: "YYYY-MM-DD",
	adminQuery_error4		: "Please add at least one condition",
	adminQuery_error5		: "A dynamic query already exists for this field.",
			
	// access control tab
	admin_accesscontrol		: "Admin Access Control",
	admin_grouppopup		: "View privileges for:&nbsp;",
	admin_grouppopupforprefs: "View preferences for:&nbsp;",
	admin_selections		: "Portlets",
	admin_properties		: "Properties",
	admin_allowaccess		: "Allow access",
	admin_allusers			: "All Users",
	admin_toggleall			: "Toggle All: ",
	admin_none				: "None",
		
	admin_view_titles		: [ "Grid" , "Calendar" , "DataTree", "DataMatrix", "ImageMatrix" ],
	admin_grid_table_labels	: [ "Position", "Allow access", "Real Name", "DAX Alias", "Style", "Views" ],
	admin_grid_field_labels	: [ "Position", "Data Type", "Real Name", "DAX Alias", "Display in list", "Display in detail", "Formatting"	],
	
	
	// load page
	// login widget
	login_login				: "Login",
	login_username			: "Username",
	login_password			: "Password",

	// login and logout
	logoutsuccess			: "You are successfully logged out.",
	logoutfail				: "Logging out failed.",
	logoutconfirm			: "Proceed with logging out?",
	
	// admin, misc
	new_view				: "New View",
	delete_view				: "Delete View",
	no_relation_found		: "No relation found.",
	go						: "Go",
	
	top_columns				: [ "Position","Real Name","DAX Alias","Type","Style","DDW Buttons","Views"],		
	bottom_columns			: [ "Position","Real Name","DAX Alias","Type","Formatting","Break level","OnLoad Event","OnChange Event","DDW Link"],
	
	// window titles
	image_viewer			: "Image Viewer",
	
	// data tree
	select_branch			: "Please select a tree branch where record will be created.",
	delete_records			: "Please select a record(s) to delete.",
	// full message is "Delete X record(s)?"
	delete_records1			: "Delete",
	delete_records2			: "record(s)?",
	// column where list is displayed
	hgrid_first_column		: "List",
	
	// editor
	record_not_in_database	: "Record not in the database yet",

	editor_error_int		: "Value must be between -32,768 and 32,767",
	editor_error_longint	: "Value must be between -2,147,483,648 and 2,147,483,647",
	editor_imageviewer		: "Image Viewer",	
	
	editor_selectionview	: "Nifty tip. It's supposed to be helpful.",

	/* 1.1 Addition */
	
	// editor choice list
	no_data_found			: "No data found.",

	/* 1.1 Addition ends*/
	
	// window titles
	image_viewer			: "Image Viewer",
	
	// data tree
	select_branch			: "Please select a tree branch where record will be created.",
	delete_records			: "Please select a record(s) to delete.",
	// full message is "Delete X record(s)?"
	delete_records1			: "Delete",
	delete_records2			: "record(s)?",
	// column where list is displayed
	hgrid_first_column		: "List",

	// boolean values
	
	yes		: "yes",
	no		: "no",
	
	male	: "male",
	female	: "female",
	
	ttrue	: "true",
	ffalse	: "false",

	// sidebar tooltips
	
	sidebar_logout		: "Logout",
	sidebar_console		: "Console",
	sidebar_settings	: "Control Panel",

	// window
	
	onbeforeunload		: "If you leave, your DAX sessions will not be preserved!",

	// query Engine
	
	qe_list				: "List",
	qe_report			: "Report",
	qe_chart			: "Chart",
	qe_arguments		: ['is equal to', 'is not equal to', 'starts with', 'ends with', 'is less than', 'is greater than', 'is less than or equal to', 'is greater than or equal to'],

	// Chart Engine
	
	ct_charttypes		: ['Column', 'Line', 'Pie'],

	// Report Engine
	
	rp_select			: "Select",
	rp_deselect			: "Deselect",

	// Browser support
	unsupportedbrowser	: "4D AJAX Framework doesn't support this browser. Please upgrade the browser to Internet Explorer 7, Firefox 2+, or Safari 2+.",

	// Image browser & data matrix
	ib_toolbar_display	: "Display",
	ib_toolbar_create	: "Create",
	ib_toolbar_delete	: "Delete",
	ib_toolbar_zoom		: "Zoom",
	ib_toolbar_flip		: "Flip over",
	ib_toolbar_more		: "More",
	ib_toolbar_less		: "Less",
	ib_toolbar_setup	: "Setup",
	ib_toolbar_image	: "Image",
	ib_toolbar_layout	: "Layout",
	ib_toolbar_header	: "Header",
	ib_toolbar_top		: "Top",
	ib_toolbar_bottom	: "Bottom",
	ib_toolbar_left		: "Left",
	ib_toolbar_right	: "Right",
	ib_toolbar_none		: "None",
	ib_toolbar_sort		: "Sort",

	/* 1.1 addition */
	save_column_width	: "Save column widths",
	/* 1.1 addition ends */
	
	
	/* END LOCALIZATION  */
	
	
	/* FORMATTING */

	admin_titles_integer	: [ "None" ,  "9,999,999", 		"$9,999.99",   		"9.999,99 EUR",  		"99.99 %"],
	admin_values_integer	: [ "i1"    , "i,cm,per,0,", 	"i$,cm,per,2,",		 "i,per,cm,2,EUR", 	    "i,,per,2,~"],
	
	admin_titles_longint	: [ "None" ,  "9,999,999",		"9.999,99 EUR",		"$9,999.99",     "99.99 %"],
	admin_values_longint	: [ "l1"   ,  "l,cm,per,0,",	"l,per,cm,2,EUR",	"l$,cm,per,2,",  "l,,per,2,~"],	
	
	admin_titles_real		: [ "None" ,  "9,999,999",		"99.99 %",		"$9,999.99",  	 "9.999,99 EUR"	],
	admin_values_real		: [ "r1"    , "r,cm,per,0,"	,	"r,,per,2,~",	"r$,cm,per,2,",  "r,per,cm,2,EUR"],	

	admin_titles_date		: [ "None" , "MM-DD-YYYY" ,	 "DD-MM-YYYY" ,	 "DD-Jan-YYYY" ],
	admin_values_date		: [ "d1"   , "dMM-DD-YYYY" , "dDD-MM-YYYY",	 "dDD-MMM-YYYY"],
	
	admin_titles_time		: [ "None" ,  "HH:MM:SS",   "HH:MM:SS am/pm",		"HH:MM",	"HH:MM am/pm" ],
	admin_values_time		: [ "t1"    , "tHH:MM:SS",  "tHH:MM:SS am/pm",		"tHH:MM",	"tHH:MM am/pm"],
	
	admin_titles_alpha		: [ "None" ,  "UPPERCASE",   "lowercase"],
	admin_values_alpha		: [ "a1"    , "aUUUU",  	 "auuuu"],
	
	admin_titles_text		: [ "None" ,  "UPPERCASE",   "lowercase"],
	admin_values_text		: [ "x1"    ,  "xUUUU",  	 "xuuuu"],

	// note: these are admin boolean labels, actual boolen values are in the localization section of this file - best thing to do is to update both
	admin_titles_boolean	: [ "None",	"True/False",	"Yes/No",	"Male/Female",	"Checkbox"],
	admin_values_boolean	: [ "b1",	"bTrue",		"bYes",		"bMale",		"bCheckbox"],
	
	admin_titles_none		: ["None"],
	admin_values_none		: ["1"],

	
	/* DO NOT MODIFY STRINGS BELOW */
	
	// XML tags & attribute strings
	tableid 		: 'tableid',
	queryid 		: 'queryid',
	tablename 		: 'tablename',
	recordid		: 'recordid',
	selectioncount 	: 'recordsinselection',
	fieldid			: 'id',
	fieldname		: 'name',
	fieldtag		: 'field',
	rowtag			: 'row',
	size			: 'size',
	modify_success	: 'success',
	success_true	: 'true',
	success_false	: 'false',
	recordidtag		: 'recordid',
	
	// field types
	type_alpha		: 'alpha',
	type_text		: 'text',
	type_picture	: 'picture',
	type_real		: 'real',
	type_integer	: 'integer',
	type_longint	: 'longint',
	type_blob		: 'blob',
	type_boolean	: 'boolean',
	type_date		: 'date',
	type_time		: 'time'

};
