// queryengine.js

function QE_PageLoad(qeObjectParent) {
	var lineCount = 1;

// Executed when they select a table from the tables select object
// populates the fields select object
	this.QE_TableSelected = function () {
		// remove all but the original line
		var qeParametersLines = this.getElementsByClassName(qeObject, 'dax_qe_parameters');
		for ( var i = 1 ; i < qeParametersLines.length ; i++ ) {
			qeParamLines.removeChild(qeParametersLines[i]);
		}

		lineCount = 1;
		var qeOrigParamsLine = qeParametersLines[0];//.cloneNode(true);
		qeOrigParamsLine.parent = qeParamLines;
		qeOrigParamsLine.id = qeOrigParamsLine.id + lineCount;

		QE_AddQueryLine(qeOrigParamsLine);
	}

	this.QE_FieldSelected = function (qeParametersLine) {
	// Get the argument and field select
		var argsSelect = this.getElementByClassName(qeParametersLine, 'dax_qe_argument');
		var fieldSelect = this.getElementByClassName(qeParametersLine, 'dax_qe_field');

	// clear the argument select options
		while ( argsSelect.options.length > 1 ) {
			argsSelect.options[0] = null;
		}

	// build the argument select options
		var argumentOptions = STR['qe_arguments'].slice();
		var argumentValues = new Array('equal', 'notequal', 'starts with', 'ends with', 'less', 'greater', 'lesseq', 'greatereq');

		var selectOption = this.getElementByClassName(argsSelect, 'dax_qe_argsoption');
		for ( i = 0 ; i < argumentOptions.length ; i++ ) {
			selectOption.text = argumentOptions[i];
			selectOption.value = argumentValues[i];
			argsSelect.appendChild( selectOption );
			selectOption = selectOption.cloneNode(true);
		}

	// remove invalid for this type
		var selectedFieldType = top.getField(tableSelect.value,fieldSelect.value).fieldtype;
		if (( selectedFieldType != 'alpha' ) && 
			( selectedFieldType != 'text' )) {

			for ( var i = 0 ; i < argsSelect.options.length ; i++ ) {
				if (( argsSelect.options[i].value == 'starts with' ) ||
					( argsSelect.options[i].value == 'ends with' )) {
						argsSelect.options[i] = null;
						i--;
				}
			}
		}
	}

// add another query parameters lines
	this.QE_AddQueryLine = function (qeParametersLine) {
		var newQueryLineDiv;
	
	// only clone if not the original one
		if ( lineCount == 1 ) {
			newQueryLineDiv = qeParametersLine;
		} else {
			newQueryLineDiv = qeParametersLine.cloneNode(true);
			newQueryLineDiv.parent = qeParametersLine.parent;
			newQueryLineDiv.id = 'dax_qe_parameters' + lineCount;
		}

	// rename and/or select
		var andOrSelect = this.getElementByClassName(newQueryLineDiv, 'dax_qe_andor');
		andOrSelect.name = andOrSelect.name + ( lineCount + '');
		andOrSelect.parent = newQueryLineDiv;

		if ( andOrSelect.options.length == 1 ) {
			var selectOption = this.getElementByClassName(andOrSelect, 'dax_qe_andoroption');
			selectOption.text = 'and';
			selectOption.value = 'and';
			selectOption = selectOption.cloneNode(true);
			selectOption.text = 'or';
			selectOption.value = 'or';
			andOrSelect.appendChild( selectOption );
		}

		if ( lineCount == 1 ) { 
			andOrSelect.selectedIndex = 0;
			andOrSelect.disabled = true;
		} else {
			andOrSelect.disabled = false;
		}

	// rename argument select
		var argsSelect = this.getElementByClassName(newQueryLineDiv, 'dax_qe_argument');
		argsSelect.name = argsSelect.name + ( lineCount + '');
		argsSelect.parent = newQueryLineDiv;
	
	// rename and build fields select
		var fieldsSelect = this.getElementByClassName(newQueryLineDiv, 'dax_qe_field');
		fieldsSelect.name = fieldsSelect.name + ( lineCount + '');
		fieldsSelect.parent = newQueryLineDiv;

		// remove all but the original option
		while ( fieldsSelect.options.length > 1 ) {
			fieldsSelect.options[0] = null;
		}

		// build the options for the selected table
		var tableObject = top.getTable(tableSelect.value);
		top.dax_bridge.cacheFields( tableObject );

		var selectOption = this.getElementByClassName(fieldsSelect, 'dax_qe_fieldoption');
		for ( var i = 0 ; i < tableObject.fields.length ; i++ ) {
			if ( tableObject.fields[i].fieldtype != 'picture' ) {
				selectOption.text = tableObject.fields[i].fieldalias;
				selectOption.value = tableObject.fields[i].fieldid;
				fieldsSelect.appendChild( selectOption );
				selectOption = selectOption.cloneNode(true);
			}
		}

		fieldsSelect.onchange = function() { QE_FieldSelected(this.parent); };
		QE_FieldSelected(newQueryLineDiv);

	// rename searchvalue
		var searchValue = this.getElementByClassName(newQueryLineDiv, 'dax_qe_searchvalue');
		searchValue.name = searchValue.name + ( lineCount + '');

		var addLineButton = this.getElementByClassName(newQueryLineDiv, 'dax_qe_addline');
		addLineButton.onclick = function () { QE_AddQueryLine(newQueryLineDiv) };

		var removeLineButton = this.getElementByClassName(newQueryLineDiv, 'dax_qe_removeline');
		removeLineButton.disabled = (lineCount == 1);
		removeLineButton.onclick = function () { QE_RemoveQueryLine(newQueryLineDiv.parent, newQueryLineDiv) };

		lineCount += 1;
		
		qeParamLines.appendChild(newQueryLineDiv);
	}

// remove a query parameters line
	this.QE_RemoveQueryLine = function (qeParentObject, removeLine) {
		qeParentObject.removeChild(removeLine);
	}

// submit the query
	this.QE_SubmitQuery = function (clickedButton) {
		var qe_fields = this.getElementsByClassName(qeObject, 'dax_qe_field');
		var qe_args = this.getElementsByClassName(qeObject, 'dax_qe_argument');
		var qe_searchValues = this.getElementsByClassName(qeObject, 'dax_qe_searchvalue');
		var qe_andors = this.getElementsByClassName(qeObject, 'dax_qe_andor');
		var tableSelect = this.getElementByClassName(qeObject, 'dax_qe_table');

		var queryURL = "/DAX/queryengine?sessionId=" + top.dax_bridge.sessionId	+ '&dax_qe_table=' + tableSelect.value;
		
		for ( var i = 0 ; i < qe_fields.length ; i++ ) {
			queryURL += '&' + qe_fields[i].name + '=' + qe_fields[i].value;
			queryURL += '&' + qe_args[i].name + '=' + qe_args[i].value;
			queryURL += '&' + qe_searchValues[i].name + '=' + qe_searchValues[i].value;
			queryURL += '&' + qe_andors[i].name + '=' + qe_andors[i].value;
		}
	
		top.debugAlert('<b>QueryEngine:</b>'+'<a href="'+queryURL+'" target="_blank">'+queryURL+'</a>');
		
		if ( clickedButton == 'dax_qe_chart' ) {
			makeCall (queryURL, this.QE_result, null, true);
		} else if ( clickedButton == 'dax_qe_report' ) {
			makeCall (queryURL, this.QE_result, null, true);
		} else {
			makeCall (queryURL, this.QE_result, null, true);
		}
	}

	// process the submitted form reply
	this.QE_result = function (http_result, nada) {
		if (http_result.readyState != 4 )
			return;
		
		// extract the query id
		var result = http_result.responseXML.getElementsByTagName("queryResult").item(0);
		if (!result)
			return;
			
		var qQueryId = result.getAttribute('queryid');
		if (!qQueryId)
			return;
			
		top.debugAlert ('QE_result receives query id:' + qQueryId);
		qeObjectParent.queryID(qQueryId,top.getTable(tableSelect.value).tablename);
	}

// *** start of main function
	qeObjectParent.innerHTML = '';

// get the html template code and clone it
	var qeObjectTemplate = this.getTemplate('dax_query_engine');
	var qeObject = qeObjectTemplate.cloneNode(true);
	qeObject.style.display = 'block';

// get a unique id
	var i = 1;
	while (this.$('dax_query_engine' + i) != null) {
		i++;
	}
	qeObject.id = 'dax_query_engine' + i;

	var qeForm = this.getElementByClassName(qeObject, 'dax_qe_form');
	qeForm.name = qeForm.name + ( i + '' );

	var qeParamLines = this.getElementByClassName(qeObject, 'dax_qe_paramlines');
	var qeOrigParamsLine = this.getElementByClassName(qeObject, 'dax_qe_parameters');
	qeOrigParamsLine.parent = qeParamLines;
	qeOrigParamsLine.id = qeOrigParamsLine.id + lineCount;
	
// get the table select object
	var tableSelect = this.getElementByClassName(qeObject, 'dax_qe_table');
	tableSelect.onchange = function() { QE_TableSelected() };

// build the table select options
	var tableSelectOption = this.getElementByClassName(tableSelect, 'dax_qe_tableoption');
	for ( i = 0 ; i < top.dax_bridge.tables.length ; i++ ) {
		if ( top.dax_bridge.tables[i].tableid < 32000 ) {
			tableSelectOption.text = top.dax_bridge.tables[i].tablealias;
			tableSelectOption.value = top.dax_bridge.tables[i].tableid;
			tableSelect.appendChild( tableSelectOption );
			tableSelectOption = tableSelectOption.cloneNode(true);
		}
	}

	QE_TableSelected();

// Set up the search button
	var queryListButton = this.getElementByClassName(qeObject, 'dax_qe_list', true);
	queryListButton.innerHTML = STR['search'];
	queryListButton.onclick = function() { QE_SubmitQuery('dax_qe_list'); return false; };

// append the qe object to the passed div
	qeObject.parent = qeObjectParent;
	qeObjectParent.appendChild(qeObject);
}
