// Stubs.js by Jonathan Le

function test()
{
	try {
	/*
		var editor = new Editor();
		document.body.appendChild(editor.getDOM());
		
		editor.pull(2, 1);

	var a = $('a');
	var gridobject = new GridObject(a);
	//grid.grid.size(3,3);
	gridobject.load(
		[
			['nav a'],
			['nav b'],
			['nav c']
		]
	);
	
	var grid = gridobject.grid;
	var row = grid.row(0);
	
	row.prv.mDOM.onclick = function() { alert(this.parent.getIndex()); }
	gridobject.viewport.setOverflow(0,0);
		/*
		editor.size(3, 1);
		editor.assign([
			{label: 'a', value: 'b'},
			{label: 'b', value: 2},
			{label: 'c', value: $('a')}
		]);
	*/
	
	var toolbar = new Toolbar();
	toolbar.addButton("Create");
	document.body.insertBefore(toolbar.prv.mDOM, null);
	
	} catch (e) {
		alert(e); 
	}
}

// New all records function
function do_AR(element, tablenumber, aComparison, aObject)
{
	var grid = new GridObject(element);
	/*
	// hack for column width
	for (q = 0; q < grid.grid.prv.mColCount; q++) {
		grid.grid.column(q).setWidth(grid.grid.column(q).prv.mHeader.prv.mWidth);
	}
	*/
	
	grid.owner = aObject;

	// set a grid property
	element.grid = grid;
	
	if (element.parent)
		element.parent.grid = grid;
	
	//grid.clear();
	if (aObject.currentTab) {
		if (aObject.currentTab.queryName)
			grid.populate({tableId : tablenumber, comparison : aComparison, queryName: aObject.currentTab.queryName });
		else
			grid.populate({tableId : tablenumber, comparison : aComparison });
	} else {
		grid.populate({tableId : tablenumber, comparison : aComparison });
	}
	
	//grid.viewport.refresh();
	return grid;
}

/**
 * The "easy button"
 *
 * @author Jonathan Le
 * 
 * @param objectname	the name of the object to draw
 * @param arguments		some arguments, if you know them ;)
 * @param givenname		an id to assign to the object otherwise it takes the id
 * 		of objectname+{number}
 **/
function DAX(objectname, aArguments)
{
	var aArguments = isDefined(aArguments) ? aArguments : "";
	switch (objectname)
	{
		case "window":
		{
			schedule(function() { return getTemplate(objectId);},
				"do_drawWindow("+aArguments+")");
		}
		break;
		case "datawindow":
		{
			schedule(function() { return getTemplate("window") && structure.isUpdated();},
				"do_allRecords("+aArguments+")");
		}
		break;
		case "query":
		{
			schedule(function() { return getTemplate("recordsArea") && structure.isUpdated();},
				"do_queryInto("+aArguments+")");
		}
		break;
		case "queryrelated":
		{
			schedule(function() { return getTemplate("recordsArea") && structure.isUpdated();},
				"do_queryRelated("+aArguments+")");
		}
		break;
		case "login":
		{
			schedule(function() { return true; }, "do_login("+aArguments+")");
		}
		break;
		case "grid":
		{
			schedule(function() { return getTemplate("grid");}, "do_grid("+aArguments+")");
		}
		break;
		case "hl":
		{
			schedule(function() { return getTemplate("hl");}, "do_hl("+aArguments+")");
		}
		break;
		case "AllRecords":
		{
			schedule(function() { return getTemplate("newgrid"); }, "do_AR("+aArguments+")");
		}
		break;
		case "test":
		{
			schedule(function() { return getTemplate("editor"); }, "test("+aArguments+")");
		}
		break;
		case "NavBar":
		{
			schedule(function() { return getTemplate("newgrid"); }, "NavBar("+aArguments+")");
		}

		default:
			return;
	}
}

/**
 * @param condition is a 0P function that returns a boolean
 **/
function schedule(condition, callback)
{
	if (condition()) {
		// use js EVAL to run the function
		eval(callback);
	} else {
		// delay the function call until later
		setTimeout("schedule(" + condition + ", '" + callback + "')", 1);
	}
	
	return true;
}

function do_getPreferences()
{
}

function do_hl(element, listElement)
{
	if (listElement == null || listElement == undefined)
		return;
		
	var hl = new HList();
	hl.build(listElement);
	
	if (element == null || element == undefined) {
		element = document.body;
	}
	
	hl.refresh();
	element.insertBefore(hl.dom, null);
	
	// remove the list
	document.body.removeChild(listElement);
}

function do_grid(element)
{
	if (arguments.length > 0) {
		var grid = new Grid();
		for (var i = 1; i < arguments.length; i++) {
			var col = new GridColumn(arguments[i]);
			grid.insert(col);
		}
		
		element.insertBefore(grid.dom, null);
		grid.refresh();
		
		return grid;
	}
	
	return null;
}

/**
 * Login to the backend database using username and password.
 *
 * @author Jonathan Le
 **/ 
function do_login(username, password, language) {
	if (username == "") {
		on_login_error();
		return;
	}
	
	var url = connection.address.login + "?username=" + username + "&password=" + password;
	
	connection.username = username;
	
	makeRequest(url, login);
}

/**
 * Performs an initial query, returning all possible records, then drawing them into a new
 * window.
 *
 * @author Jonathan Le
 *
 * @param tableId	numerical id of a table
 **/ 
function do_allRecords(tableId)
{
	var dw = new DataWindow(tableId, null, null, null, null, true);
	dw.open();
}

/**
 * Perform a query on the component database; display results in a new window.<b> 
 *
 * @author Jonathan Le
 *
 * @param queryid	string of the last known query id
 * @param start 	integer denoting starting point of record selection
 * @param length	number of records to return
 **/
function do_query(queryid, start, length)
{
	var sessionId = connection.sessionId;
		
	if (sessionId == "" || queryid == "")
		return;
		
	var url = connection.address.query+"?sessionId="+sessionId+"&queryid="+queryid+"&start="+start+"&length="+length;
	
	makeRequest(url, query, null);
}

/**
 * Perform a query but instead of opening a new window, add the result into a
 * given element. 
 *
 * @author Jonathan Le
 *
 * @param comparison	comparison string is appended to the end of a URL
 *						&fieldid=1&comp=equal&value=CA
 *
 * @param element	a reference to add the results into
 **/
function do_queryInto(tableid, queryid, start, length, element, comparison)
{
	var sessionId = connection.sessionId;
		
	if (sessionId == "" || (tableid == "" && queryid == "") || !element)
		return;
	
	if (start == null || start == undefined) {
		start = 0;
	}
	
	if (length == null || length == undefined) {
		length = 25;
	}
	
	if (queryid) {			
		var url = connection.address.query+"?sessionId="+sessionId+"&queryid="+queryid+"&start="+start+"&length="+length;
	} else if (comparison) {
		var url = connection.address.query+"?sessionId="+sessionId+"&tableid="+tableid+"&queryid=&start="+start+"&length="+length;
	} else {
		var url = connection.address.allrecords+"?sessionId="+sessionId+"&tableid="+tableid+"&start="+start+"&length="+length
	}
	
	if (comparison && comparison != "")
		url += comparison;
		
	var http_request = getXMLHttpRequest();
		
	if (http_request) {
		http_request.onreadystatechange = function() { query(http_request, element);};
			
		try {
			// call event handler
			if (element.onbeforeload) {
				element.onbeforeload();
			}
			
			http_request.open("GET", url, true);
	  	  	http_request.send(null);
	   	} catch(e) {
		   	http_request.onreadystatechange = null;
	   		delete http_request;
		}
	}
}

function do_queryRelated(related_tableid, related_recordid, link_tableid, target_tableid, element)
{
	var sessionId = connection.sessionId;
		
	if (sessionId == "" || !element)
		return;
	
	var url = "QueryRelatedRecords" + "?sessionId=" + sessionId + "&relatedtableid=" +
		related_tableid + "&relatedrecordid=" + related_recordid + "&linktableid=" +
		link_tableid + "&targettableid=" + target_tableid;
			
	var http_request = getXMLHttpRequest();
		
	if (http_request) {
		http_request.onreadystatechange = function() { query(http_request, element);};
			
		try {
			http_request.open("GET", url, true);
	  	  	http_request.send(null);
	   	} catch(e) {
	   		http_request.onreadystatechange = null;
	   		delete http_request;
		}
	}
}

/**
 * Draws a generic window based on the 'frame' class.
 *
 * @author Jonathan Le
 *
 * @param title		STRING
 * @param toolbar	NODE
 * @param content	NODE
 * @param status	NODE
 *
 * @see index.html
 **/
function do_drawWindow(title, toolbar, content, status)
{
	// initialize framework
	dax.init();
	   	
   	var newWindow = WindowManager.createNewWindow();
   	
   	if (content) {
		newWindow.contentArea.appendChild(content);
	}
	
	if (title) {
		newWindow.titleBar.innerHTML = title;
	}
	
	if (toolbar) {
		newWindow.addToolbar(toolbar);
	}
	
	if (status) {
		var sbar = newWindow.status.appendChild(status);
		sbar.parent = newWindow;
	}
   	
   	// open the window
   	newWindow.open();
   	
   	// set the size of the new window and activate it
   	newWindow.size(newWindow.dom.offsetWidth, newWindow.dom.offsetHeight);
   	newWindow.activate();
   	
   	return newWindow.dom;
}

/**
 * Shrinks an HTML element in the direction that is specified.  The function does
 * not take into account the padding, margin, or border.
 *
 * @author Jonathan Le
 *
 * @param object	reference to an HTML element
 * @param direction	either "left" or "up"
 *
 * @return the object that is shrinking.
 **/
function do_shrink(object, direction)
{
	// already shrinking something...escape
	if (window.shrinking || object.style.display == "none")
		return null;
	
	// first we need a generic object
	var shrinker = new Object();
	
	// save the original widths
	object.startWidth = object.offsetWidth;
	object.startHeight = object.offsetHeight;
	object.startDisplay = object.style.display;
	
	// this is the current width
	object.currentWidth = object.offsetWidth;
	object.currentHeight = object.offsetHeight;
	
	// set properties
	shrinker.object = object;	
	shrinker.direction = direction;
	shrinker.shrink = shrink;
	
	// do the shrinking
	return shrinker.shrink();
}

/**
 * Grows an HTML element in the direction that is specified.  the object can only be
 * grown if it had previously been shrunk.  see do_shrink().
 *
 * @author Jonathan Le
 *
 * @param object	reference to an HTML element
 * @param direction	either "right" or "down"
 *
 * @return	the object that is growing
 **/
function do_grow(object, direction)
{
	// already shrinking something...escape
	if (window.growing)
		return null;
		
	if (!object.startHeight && !object.startWidth)
		return null;
		
	// first we need a generic object
	var grower = new Object();
	
	// reset
	object.style.display = object.startDisplay;
	
	// set properties
	grower.object = object;	
	grower.direction = direction;
	grower.grow = grow;
	
	// do the growing
	return grower.grow();
}

/**
 * Add a rounded corner appearance to an object
 *
 * @author Jonathan Le
 *
 * @param object			reference to an HTML element
 * @param backgroundColor	string for HTML color, eg "red" or "#ff0000"
 **/
function do_roundCorners(object, backgroundColor)
{
	// first look for our template
	var rc = getElementByClassName(document, "roundedCornerObject");

	if (!rc)
		return;
	
	rc = rc.cloneNode(true);
		
	var body = document.getElementsByTagName("body").item(0);
	body.insertBefore(rc, object);
	
	var rbody = getElementByClassName(rc, "roundedCornerObjectBody");
	rbody.appendChild(object);
	
	// set some styles
	rc.style.display = "";
	
	// try to match the background color of the contained object
	var bg = object.style.backgroundColor;
	
	if (bg.length == 0) {
		bg = getCSSPropertyValue(object.className, "background-color");
	}
	
	rc.style.backgroundColor = bg;
}

/**
 * Creates an accordion effect for a specified object in the specified direction.
 *
 * Ex. onclick="do_accordion($('myobj'), 'up')"
 * 
 * @author Jonathan Le
 * @param object	a reference to an HTML element
 * @param direction	a string that is either "up" or "left"
 *
 * @return the reference to the object that has been given the accordion effect.
 **/
function do_accordion(object, direction)
{
	var growdir = "";
	
	if (direction == "up")
		growdir = "down";
	else if (direction == "left")
		growdir = "right";
	else
		return;
	
	var rv = null;
	
	if (!(rv = do_shrink(object, direction))) {
		rv = do_grow(object, growdir);
	}
	
	return rv;
}

/**
 * Shows a blackout screen with widgets.  Optionally adds an object as a widget to the
 * dashboard.
 *
 * @author Jonathan Le
 *
 * @param object	HTML element reference to add as widget
 **/
function do_showDashboard(object, enabledragging)
{
	// dashboard based on this blackout object
	var blackout = $('blackout');
	
	if (!blackout)
		return;
		
	if (!blackout.dashboard)
		blackout.dashboard = new Dashboard(blackout);
	
	if (object) {
		object.style.position = "absolute";
		blackout.dashboard.add(object);
		if (enabledragging==undefined)
			do_enableDragging(object);
		else
			switch(enabledragging) 
			{
				case "Full":
					do_enableDragging(object);	
					break;
				case "None":
					break;
				default:
					// Borders
					var borderobject = $('top_dash'+enabledragging);
					setStyle(borderobject, "cursor", "move");
					borderobject.onmousedown = function(event) {
						startDragOtherObject(event, object);
					}
					var borderobject = $('left_dash'+enabledragging);
					setStyle(borderobject, "cursor", "move");
					borderobject.onmousedown = function(event) {
						startDragOtherObject(event, object);
					}
					var borderobject = $('right_dash'+enabledragging);
					setStyle(borderobject, "cursor", "move");
					borderobject.onmousedown = function(event) {
						startDragOtherObject(event, object);
					}
					var borderobject = $('bottom_dash'+enabledragging);
					setStyle(borderobject, "cursor", "move");
					borderobject.onmousedown = function(event) {
						startDragOtherObject(event, object);
					}
					break;
				
			}
		
	}
	
	//var zindextoapply = ++WindowManager.maxZIndex;
	var zindextoapply = 9100;
	
	// now show the dashboard and all its widgets
	for (var i in blackout.dashboard.widgets) {
		blackout.dashboard.widgets[i].style.display = "";
		blackout.dashboard.widgets[i].style.zIndex = zindextoapply+1;
	}
	
	// show the blackout
	blackout.style.display = "block";
	blackout.style.left = "0px";
	blackout.style.zIndex = zindextoapply;
}

/**
 * Hide the dashboard and all its widgets.
 *
 * @author Jonathan Le
 **/
function do_hideDashboard(object)
{
	var blackout = $('blackout');
	
	if (!blackout)
		return;
		
	if (blackout.dashboard) {
		for (var i in blackout.dashboard.widgets) {
			blackout.dashboard.widgets[i].style.display = "none";
			blackout.dashboard.widgets[i].style.zIndex = "";
		}
	}

	if (object) {
		if (blackout.dashboard) {
			blackout.dashboard.remove(object);
		}	
	}
	
	if (aSidebar)
		do_redrawSidebar();
		
	blackout.style.display = "none";
	blackout.style.zIndex = "";
}

/**
 * Enable dragging of an object in the browser.
 *
 * @author Jonathan Le
 *
 * @param object	the object to make draggable.
 **/
function do_enableDragging(object)
{
	setStyle(object, "cursor", "move");
	object.onmousedown = startDragObject;
}

/**
 * Disable dragging of the object.
 *
 * @author Jonathan Le
 *
 * @param object the object to disable dragging
 **/
function do_disableDragging(object)
{
	object.style.cursor = "auto";
	object.onmousedown = null;
}


/* J.L - Below is deprecated by the replacement of the Taskbar Object */
/**
 * Displays the taskbar.  The taskbar object (id='taskbar') must be present in the file
 * that is going to call this function.
 *
 * @author	Jonathan Le
 * @see		index.html
 
function do_showTaskbar()
{
	var tb = $("taskbar");
	
	if (!tb)
		return;
	
	// default display
	tb.style.display = "block";
}
*/

/**
 * Appends the item reference to the taskbar.
 *
 * @author	Jonathan Le
 *
 * @param item	a reference to an HTML element to append to the taskbar element
 **
function do_addTaskbarItem(item)
{
	var tb = $("taskbar");
	
	if (!tb)
		return;
	
	tb.appendChild(item);
	
	return item;
}
*/

/**
 * Remove the specified item from the task bar.
 *
 * @author Jonathan Le
 *
 * @param item	a reference to the item to remove
 *
 function do_removeTaskbarItem(item)
 {
 	var tb = $("taskbar");
 	
 	if (!tb)
 		return;
 	
 	try {
	 	tb.removeChild(item);
	} catch(e) { }
 }
 */
 
 /**
  * Create a new tab holder and return a reference to it.
  * <br>
  * The tab object contains the following properties:
  * <ol>
  *  <li>tabs - an array of references to tabs</li>
  *  <li>first - reference to the first tab</li>
  *  <li>last - reference to the last tab</li>
  *  <li>current - reference to the currently active tab</li>
  * </ol>
  *
  * @author Jonathan Le
  *
  * @param parent	Optional. place the tab holder in this element.
  * @param text		text of the first tab
  *
  * @return a reference to the newly created tab holder
  **/
 function do_createTabHolder(text, parent)
 {
 	if (text == '')
 		return;
 		
 	// based on a template
 	var tabObject = $('tabObject');
 	
 	if (!tabObject)
 		return null;
 	
 	// duplicate it
 	tabObject = tabObject.cloneNode(true);
 	tabObject.tabs = new Array(0);
 	
 	do_addTab(tabObject, text);
 	
 	if (parent) {
 		var children = parent.childNodes;
 		
 		if (children) {
 			parent.insertBefore(tabObject, children[0]);
 		} else { 			
	 		parent.appendChild(tabObject);
 		}
 		tabObject.parent = parent;
 	}
 	
 	tabObject.style.display = "block";
 	
 	return tabObject;
 }
 
 /**
  * Add a new tab to a given tab holder with text.
  *
  * @author Jonathan Le
  * 
  * @param tabholder	the tab holder to add the new tab to
  * @param text			the text to put on the tab
  *
  * @return a reference to the newly created tab
  **/
 function do_addTab(tabholder, text)
 {
 	if (!tabholder || text == '')
 		return;
 		
 	var tabContainer = getElementByClassName(tabholder, "tabContainer");
 	var tabItem = null;
 	
 	// first count the tab objects that this tabholder currently contains
 	if (tabholder.first) {
 		// first tab was already added
 		tabItem = tabholder.first.cloneNode(true);
 	} else {
 		// this is the first tab to be added
 		tabItem = getElementByClassName(tabContainer, "tabItem");
 		tabholder.first = tabItem;
 	}
 	
 	if (tabItem) {
 		var tabBody = getElementByClassName(tabItem, "tabItemBody");	
 		tabBody.innerHTML = text;
 		tabholder.last = tabItem;
 		tabContainer.appendChild(tabItem);
 		
 		tabItem.onclick = function(event) { activateTab(event, this); };
 		tabItem.parent = tabholder;
 		tabItem.value = text;
  		
 		var actor = getElementByClassName(tabItem, "tabItemActive");
 		tabItem.actor = actor ? actor : getElementByClassName(tabItem, "tabItemInactive");
 		
 		var index = tabholder.tabs.push(tabItem);
 
 		// assign function to close the tab
 		var tabCloser = getElementByClassName(tabholder, "tabCloser");
 		if (tabCloser)
	  		tabCloser.onclick = function() { do_removeTab(tabholder); };
 		
 		activateTab(null, tabItem);
 	}
 	
 	return tabItem;
 }
 
 /**
  * Closes and removes a tab from the tab holder.
  *
  * @author Jonathan Le
  *
  * @param tabholder	reference to the container holding the tabs
  * @param tabIndex		number of the tab to remove
  **/
 function do_removeTab(tabholder, tabIndex)
 {
 	if (!tabholder.tabs)
 		return;
 	
 	if (tabIndex >= 0) {
 		// get the tab to remove from list of tabs
 		var tab = tabholder.tabs[tabIndex];
 	} else {
 		var tab = tabholder.current;
 		
 		for (var i in tabholder.tabs) {
 			if (tabholder.tabs[i] == tab)
 				tabIndex = i;
 		}
 	}
 	
 	if (tab) {
 		var tabContainer = getElementByClassName(tabholder, "tabContainer");
 		tabContainer.removeChild(tab);
 		
 		// remove the item from the tabs
 		tabholder.tabs.splice(tabIndex, 1);
 		
 		if (tabholder.tabs.length > 0) {
 			tabholder.current = tabholder.tabs[tabholder.tabs.length-1];
 			tabholder.last = tabholder.current;
 			tabholder.current.onclick();
 		} else {
 			// remove the tabholder
 			if (tabholder.parent) {
 				tabholder.parent.tabholder = null;
 				tabholder.parent.removeChild(tabholder);
 			}
 		}
 	}
 }
 
 /**
  * Populates the innerHTML or optionally an attribute.
  **/
  function do_populateElementsByIds(ids, tableid, recordid, propertyNames)
 {
 	var sessionId = connection.sessionId;
 
 	if (!ids || sessionId == "")
 		return;
 		
 	var http_request = getXMLHttpRequest();
		
	if (http_request) {
		var url = connection.address.getrecord + "?sessionId=" + sessionId + "&tableid=" + tableid + "&recordid=" + recordid;
		
		http_request.onreadystatechange = 
			function() {
				populateElementsByIds(http_request, ids, propertyNames);
			};
			
		try {
			http_request.open("GET", url, true);
	  	  	http_request.send(null);
	   	} catch(e) {
	   		http_request.onreadystatechange = null;
	   		delete http_request;
		}
	}
 }

// JF
function purgeparents(d) {
	for (var property in d) {
		if (d[property]) {
			if (d[property].parent)
				d[property].parent = null;
		}
	}
};

// http://javascript.crockford.com/memory/leak.html 
function purge(d) {
	var a = d.attributes, i, l, n; 
	if (a) {
		l = a.length;
		for (i = 0; i < l; i += 1) {
			n = a[i].name;
			if (typeof d[n] === 'function') {
				d[n] = null;
			}
			if (n == 'parent')
				d[n] = null;
		}
	}
	a = d.childNodes;
	if (a) {
		l = a.length;
		for (i = 0; i < l; i += 1) {
			purge(d.childNodes[i]);
		}
	}
}
 