// tools.js by Jonathan Le

function $(id)
{
	var elem = document.getElementById(id);
	return elem;
}


// assert
function assert(id, string)
{
	var el = document.getElementById(id);
	if (!isDefined(el) || el.nodeType != 1) {
		document.write(string);
	} else {
		el.innerHTML = string;
	}
}

function isDefined(variable)
{
	return variable != null && variable != undefined
}

function Browser() {
	var ua = navigator.userAgent;
	
	this.ie = false;
	this.ie6 = false;
	this.ie7 = false;
	this.gecko = false;
	this.safari = false;
	
	if (ua.indexOf("MSIE") >= 0) {
		this.ie = true;
		if (ua.indexOf("MSIE 7") >= 0) {
			this.ie7 = true;
		}	
		if (ua.indexOf("MSIE 6") >= 0) {
			this.ie6 = true;
		}	
	} else if (ua.indexOf("WebKit") >= 0) {
		this.safari = true;
	} else if (ua.indexOf("Gecko") >= 0) {
		this.gecko = true;
	}
	
	this.theme = "basic";
	this.themePath = "themes/" + this.theme + "/";
}

function OS() {
	var os = navigator.appVersion;
	
	this.mac = false;
	this.win = false;
	this.linux = false;
	this.unix = false;
	
	if (os.indexOf("Win") >= 0) {
		this.win = true;
	} else if (os.indexOf("Mac") >= 0) {
		this.mac = true;
	} else if (os.indexOf("X11") >= 0) {
		this.unix = true;
	} else if (os.indexOf("Linux") >= 0) {
		this.linux = true;
	}

}

function getParentByClassName(child, className)
{
	// find the parent
	var parent = null;
	while (child && !parent) {
		if (child.className == className)
			parent = child;
		else
			child = child.parentNode;
	}
	
	return parent;
}

function getElementsByClassName(parent, className, match)
{
	var elements = new Array(0);

	if (parent.nodeType == 1) {
		if (match != null && match != undefined && match) {
			var cname = parent.className != undefined ? parent.className : "";
			if (cname.indexOf(className) >= 0) {
				elements.push(parent);
			}
		} else {
			if (parent.className == className)
				elements.push(parent);
		}
	
		if (parent.hasChildNodes()) {
			var children = parent.childNodes;
			for (var i = 0; i < children.length; i++) {
				elements = elements.concat(getElementsByClassName(children[i], className, match));
			}
		}
	}
	return elements;
}

function getElementByClassName(parent, className, match)
{
	if (!parent || className == "")
		return null;
	
	if (match != null && match != undefined && match) {
		var cname = parent.className != undefined ? parent.className : "";
		if (cname.indexOf(className) >= 0) {
			return parent;
		}
	} else {
		if (parent.className == className)
			return parent;
	}
	
	// get the first level of children
	var children = parent.childNodes;
	var node = null;
	var i = 0;
	
	while (!node && i < children.length) {
		node = getElementByClassName(children.item(i), className, match);
		i++;
	}
			
	return node;
}

function getCSSPropertyValue(className, property)
{
  	var className = "." +className;
   	
	if (browser.ie) {
		rules = document.styleSheets.item(0).rules;
	} else {
		rules = document.styleSheets.item(0).cssRules;
	}
	
	var value = "";
	var st = "";
		
	for (var i = 0; i < rules.length; i++) {
		st = rules.item(i).selectorText;
		
		if (st) {
			var tokens = st.split(',');
			
			for (var k = 0; k < tokens.length; k++) {
				if (strip(tokens[k], ' ') == className) {
					if (browser.ie) {
						value = rules.item(i).style.getAttribute(property);
					} else {
						value = rules.item(i).style.getPropertyValue(property);
					}
					
					// break
					k = tokens.length;
					i = rules.length;					
				}
			}
		}
   	}
   	
   	return value;
}

// remove all instances of char from a string
function strip(string, symbol) {
	var newstring = "";
	
	for (var i = 0; i < string.length; i++) {
		if (string.charAt(i) != symbol)
			newstring += string.charAt(i);
	}
	return newstring;
}

function getTextNode(aNode)
{
	if (!isDefined(aNode) || !aNode.hasChildNodes())
		return null;
	
	for (var child = aNode.firstChild; child; child = child.nextSibling) {
		if (child.nodeType == 3) {
			return child;
		}
	}	
	
	return null;
}

///////////////////////

function shrink()
{
	var ws = window.shrinking;
	var shrinkage = 10;
	var rate = 10;
	
	if (!ws) {
		window.shrinking = this;
		ws = this;
		
		// now we have to set the object's children to no display
		var children = ws.object.childNodes;
		
		for (var i = 0; i < children.length; i++) {
			if (children[i].style)
				children[i].style.visibility = "hidden";
		}
		
	}
	
	switch (ws.direction)
	{
		case "left":
			var width = ws.object.currentWidth;
			
			if (width) {
				if (width > shrinkage)
					width -= shrinkage;
				else
					width = 0;
				
				ws.object.style.width = width + "px";
				ws.object.currentWidth = width;
				
				setTimeout("shrink()", rate);
			} else {
				// we're done.
				ws.object.currentWidth = 0;
				ws.object.style.display = "none";
				delete window.shrinking;
			}
		break;
		case "up":
			var height = ws.object.currentHeight;
			
			if (height) {
				if (height > shrinkage)
					height -= shrinkage;
				else
					height = 0;
				
				ws.object.style.height = height + "px";
				ws.object.currentHeight = height;
				
				setTimeout("shrink()", rate);
			} else {
				// we're done.
				ws.object.currentHeight = 0;
				ws.object.style.display = "none";
				delete window.shrinking;
			}
		
		break;
	}
	
	return ws.object;
}

// same thing as shrink but increasing instead of decreasing
function grow()
{
	var ws = window.growing;
	var shrinkage = 10;
	var rate = 10;
	
	if (!ws) {
		window.growing = this;
		ws = this;
		
		// now we have to set the object's children to visible
		var children = ws.object.childNodes;
		
		for (var i = 0; i < children.length; i++) {
			if (children[i].style)
				children[i].style.visibility = "visible";
		}
		
	}
	
	switch (ws.direction)
	{
		case "right":
			var width = ws.object.currentWidth;
			
			if (width < ws.object.startWidth) {
				if ((ws.object.startWidth - width) > shrinkage)
					width += shrinkage;
				else
					width = ws.object.startWidth;
				
				ws.object.style.width = width + "px";
				ws.object.currentWidth = width;
					
				setTimeout("grow()", rate);
			} else {
				// we're done.
				ws.object.startWidth = 0;
				delete window.growing;
			}
		break;
		case "down":
			var height = ws.object.currentHeight;
			
			if (height < ws.object.startHeight) {
				if ((ws.object.startHeight - height) > shrinkage)
					height += shrinkage;
				else
					height = ws.object.startHeight;
				
				ws.object.style.height = height + "px";
				ws.object.currentHeight = height;
				
				setTimeout("grow()", rate);
			} else {
				// we're done.
				ws.object.startHeight = 0;
				delete window.growing;
			}
		
		break;
	}
	
	return ws.object;
}

/**
 *
 *
 **/
function Dashboard(parent) {
	// properties
	this.parent = parent;
	this.widgets = new Array(0);
	
	// member functions
	this.add = dashboardAdd;
	this.remove = dashboardRemove;
	
	return this;
}

function dashboardAdd(object) {
	if (!this.widgets)
		return;
	
	var widget = null;
	
	// find the widget in the existing array
	for (var i in this.widgets) {
		if (this.widgets[i] == object) {
			widget = this.widgets[i];
			break;
		}
	}
	
	if (!widget)
		widget = this.widgets[this.widgets.push(object)];
		
	return widget;
}

function dashboardRemove(object) {
	if (!this.widgets)
		return;
	
	var widget = null;
	
	// find the widget in the existing array
	for (var i in this.widgets) {
		if (this.widgets[i] == object) {
			widget = this.widgets[i];
			break;
		}
	}
	
	if (widget)
		this.widgets.splice(i,1);
		
	return true;
}

/**
 *
 **/
 
 // flags
var DAX_Global_disableDragging = false;
 
 function startDragObject(event)
 {
	
	if (DAX_Global_disableDragging) {
		DAX_Global_disableDragging = false;
		return false;
	}
 
 	var event = xpEvent(event, true);
 	Controller.dragObject = this;
 	
 	var x = 0;
	var y = 0;
	
	if (event.pageX || event.pageY) {
		x = event.pageX;
		y = event.pageY;
 	} else if (event.screenX || event.screenY) {
	    x = event.screenX;
	    y = event.screenY;
	}
	
	if (this.style.zIndex < 9000) {
		setStyle(this, "zIndex", ++WindowManager.maxZIndex);
	} else { 
		setStyle(this, "zIndex", ++WindowManager.maxZDashIndex);
	}
		
	this.offsetX = this.offsetLeft - x;
    this.offsetY = this.offsetTop - y;
    
    if (document.addEventListener) {
    	document.addEventListener("mousemove", draggingObject, true);
  	 	document.addEventListener("mouseup",   stopDragObject, true);
    } else {
       document.onmousemove = draggingObject;
 	   document.onmouseup   = stopDragObject;
    }
    
    // propagate user-defined event
    if (this.ondragstart) {
    	this.ondragstart(event);
    }
 }
 
 /**
 *
 **/
 function startDragOtherObject(event, object)
 {
 	var event = xpEvent(event, true);
 	Controller.dragObject = object;
 	
 	var x = 0;
	var y = 0;
	
	if (event.pageX || event.pageY) {
		x = event.pageX;
		y = event.pageY;
 	} else if (event.screenX || event.screenY) {
	    x = event.screenX;
	    y = event.screenY;
	}
	
	if (object.style.zIndex < 9000) {
		setStyle(object, "zIndex", ++WindowManager.maxZIndex);
	} else { 
		setStyle(object, "zIndex", ++WindowManager.maxZDashIndex);
	}
	object.offsetX = object.offsetLeft - x;
    object.offsetY = object.offsetTop - y;
    
    if (document.addEventListener) {
    	document.addEventListener("mousemove", draggingObject, true);
  	 	document.addEventListener("mouseup",   stopDragObject, true);
    } else {
       document.onmousemove = draggingObject;
 	   document.onmouseup   = stopDragObject;
    }
    
    // propagate user-defined event
    if (object.ondragstart) {
    	object.ondragstart(event);
    }
 }

 function draggingObject(event)
 {
 	var event = xpEvent(event, true, true);
 	var object = Controller.dragObject;
 	
 	if (!object)
 		return;
 	
 	object.dragging = true;
 	
 	var x = 0;
	var y = 0;
	
	if (event.pageX || event.pageY) {
		x = event.pageX;
		y = event.pageY;
	} else if (event.screenX || event.screenY) {
		x = event.screenX;
		y = event.screenY;
	}
	
	object.style.left = (x+object.offsetX)+"px";
	object.style.top = (y+object.offsetY)+"px";
	
	// propagate user-defined event
	if (object.ondragging) {
		object.ondragging(event);
	}
	
	return false;
 }
 
 function stopDragObject(event)
 {
 	if (!Controller.dragObject)
 		return;
 		
	if (document.removeEventListener) {
 		document.removeEventListener("mousemove", draggingObject, true);
	    document.removeEventListener("mouseup",   stopDragObject, true);
 	} else {
		document.onmousemove = null;
 		document.onmouseup   = null;	
    }
    
 	// propagate user-defined event
    if (Controller.dragObject.dragging && Controller.dragObject.ondragstop) {
    	Controller.dragObject.ondragstop(event);
    }
    
    Controller.dragObject.dragging = false;
    Controller.dragObject = null;
 }
 
 // JL
// node 2 string conversion. gets the value of a node, returns as string object
function n2String(aNode)
{
	var tn = getTextNode(aNode);
	return isDefined(tn) ? new String(tn.nodeValue) : new String("");
}

function removeChildren(node)
{
	while(node.firstNode) {
		node.removeChild(firstNode);
	}
}

function getElementById(aNode, aElementId) {
	if (aNode.nodeType != 1)
		return null;
	
	if (aNode.id == aElementId)
		return aNode;
	
	var node = null;
	
	for (var child = aNode.firstChild; child; child = child.nextSibling) {
		node = getElementById(child, aElementId);
	}
	
	return node;
}

/*
function initTemplates()
{
	if (this.initialized)
		return;
	else
		this.initialized = true;
	

	// insert the framework templates
	var inlines = new Array();
	inlines[0] = 'framework';
	//inlines[1] = 'dax';

	var body = document.body;

	for (var i in inlines) {
		var iframe = document.createElement("iframe");
		
		iframe.id = inlines[i];
		iframe.name = inlines[i];
		iframe.src = 'js/templates/'+inlines[i]+'.html';
		iframe.width = 0;
		iframe.height = 0;
		
		if (browser.gecko) {
			setStyle(iframe, "display", "none");
		}
		body.insertBefore(iframe, null);
	}
}
*/

function getTemplate(id, aTemplate)
{
	var obj = document.getElementById(id);
	if (obj)
		return obj;
	
	// TODO: uncomment below when other templates really exist...
	// if (!isDefined(aTemplate))
		var aTemplate = "framework";
	
	var templ = this.frames[aTemplate] ? this.frames[aTemplate].document : null;
	obj = templ ? templ.getElementById(id) : null;

	if (obj) {
		obj = document.importNode(obj, true);
		document.body.insertBefore(obj, null);
	}
	
	return obj;
}

function getAdmin()
{
	var obj = document.getElementById("adminSettings");
	if (obj)
		return obj;
	
	var aTemplate = "admin";
	
	var templ = frames[aTemplate] ? frames[aTemplate].document : null;
	obj = templ ? templ.getElementById("adminSettings") : null;
	
	if (obj) {
		obj = document.importNode(obj, true);
		document.body.insertBefore(obj, null);
	}
	
	return obj;
}

//
// Create properties based on HTML elements' classnames.
//
// Ex.
//  var a = ...
//  probe(a);
//  alert(a.b);
//
// <div class="a">
//  <div class="b"></div>
// </div>
//
//
// by Jonathan Le
function probe(aParentNode)
{
	// loop through each child
	if (aParentNode.hasChildNodes()) {
		for (var child = aParentNode.firstChild; child; child = child.nextSibling) {
			if (child.nodeType == 1) {// Node.ELEMENT_NODE
				if (child.className != "") {
					var cname = new String();
					for (var i = 0; i < child.className.length; i++) {
						if (child.className.charAt(i) != "_")
							cname += child.className.charAt(i);
						else {
							if (i+1 < child.className.length) {
								cname += child.className.charAt(i+1).toUpperCase();
								i++;
							}
						}
					}
					aParentNode[cname] = child;
				}
				probe(child);
			}
		}
	} else
		return;
}

// Get the style of the element (with checks)
function getStyle(aHTMLElement, aStyle)
{
	var value = aHTMLElement.style[aStyle];
	if (!value) {
		if (document.defaultView && document.defaultView.getComputedStyle) {
			var css = document.defaultView.getComputedStyle(aHTMLElement, null);
			value = css ? css.getPropertyValue(aStyle) : null;
		} else if (aHTMLElement.currentStyle) {
			value = aHTMLElement.currentStyle[aStyle];
		}
	}

	return value;
}

function setStyle(aHTMLElement, aStyle, aValue)
{
	try {
			// compensate for sizing in IE
		if (aStyle.toLowerCase() == "width" && browser.ie && false) {

		// $('fwdebug').value += '('+aHTMLElement.id+','+aHTMLElement.className+'):'+aHTMLElement.currentStyle.paddingTop;

			// check if value is in pixels
			if ( (aValue.indexOf('px') != -1) || (!(isNaN(aValue))) ){

				aValue = parseFloat(aValue);

				paddingOffset = parseFloat(aHTMLElement.currentStyle.paddingLeft) + parseFloat(aHTMLElement.currentStyle.paddingRight);

				if (!(isNaN(paddingOffset))) {
					aValue = aValue + paddingOffset;
				}

				borderOffset = parseFloat(aHTMLElement.currentStyle.borderLeftWidth) + parseFloat(aHTMLElement.currentStyle.borderRightWidth);
				if (!(isNaN(borderOffset))) {
					aValue = aValue	+ borderOffset;
				}
			}
		} else if (aStyle.toLowerCase() == "height" && browser.ie && false) {
			// check if value is in pixels
			if ( (aValue.indexOf('px') != -1) || (!(isNaN(aValue))) ){

				/*
				paddingOffset = parseFloat(aHTMLElement.currentStyle.paddingTop) + parseFloat(aHTMLElement.currentStyle.paddingBottom);

				if (!(isNaN(paddingOffset))) {
					aValue = parseFloat(aValue);
					aValue = aValue + paddingOffset;
				}

				borderOffset = parseFloat(aHTMLElement.currentStyle.borderTopWidth) + parseFloat(aHTMLElement.currentStyle.borderBottomWidth);
				if (!(isNaN(borderOffset))) {
					aValue = parseFloat(aValue);
					aValue = aValue	+ borderOffset;

				}
				*/				
			}
		}
		
		aHTMLElement.style[aStyle] = aValue;
	} catch (e) {
	//	 alert("style error: " + setStyle.caller + " " + e);
	}
}

function getMousePosition(aEvent)
{
	var x = 0;
	var y = 0;
	
	if (!aEvent) var aEvent = window.event;
	if (aEvent.pageX || aEvent.pageY) {
		x = aEvent.pageX;
		y = aEvent.pageY;
	} else if (aEvent.clientX || aEvent.clientY){
		x = aEvent.clientX;
		y = aEvent.clientY;
	}
	
	return { x : x, y : y};
}

function getObjectPosition(object)
{
	var px = 0;
	var py = 0;
	
	if (object.offsetParent) {
		for (var px = 0, py = 0; object.offsetParent; object = object.offsetParent) {
			px += object.offsetLeft;
			py += object.offsetTop;
		}
	} else {
		px = object.offsetLeft;
		py = object.offsetTop;
	}
	
    return { x : px, y : py  };
}

// FUNCTION: xpEvent(aEvent, aCancel) by Jonathan Le
// Pass in an Event to ensure it is cross-platform
function xpEvent(aEvent, aCancel, aPreventDefault)
{
	var aCancel = isDefined(aCancel) ? aCancel : false;
	var aEvent = !aEvent ? window.event : aEvent;
	var aPreventDefault = isDefined(aPreventDefault) ? aPreventDefault : false;
	
	if (aCancel) {
		aEvent.cancelBubble = aCancel;
		
		if (aEvent.stopPropagation)
			aEvent.stopPropagation();
	}
	
	if (aPreventDefault) {
		if (aEvent.preventDefault)
			aEvent.preventDefault();
	}

	aEvent._target = isDefined(aEvent.target) ? aEvent.target : aEvent.srcElement;
	if (aEvent._target) {
		if (aEvent._target.nodeType == 3) // handle safari
			aEvent._target = aEvent._target.parentNode;
	}
	
	return aEvent;
}

// returns an object with properties {width, height}
function xpGetSize(aElement)
{
	if (getStyle(aElement, "display") != "none")
		return (browser.ie) ? { width: aElement.clientWidth, height: aElement.clientHeight} :
			{ width: aElement.offsetWidth, height: aElement.offsetHeight };
				
    // adapted from prototype...enable visibility temporarily
    var els = aElement.style;
    var originalVisibility = els.visibility;
    var originalPosition = els.position;
    
    els.visibility = 'hidden';
    els.position = 'absolute';
    els.display = '';
    
    var originalWidth = aElement.clientWidth;
    var originalHeight = aElement.clientHeight;
    
    els.display = 'none';
    els.position = originalPosition;
    els.visibility = originalVisibility;
    
    return {width: originalWidth, height: originalHeight};
}

// validate date
// Rudolf Psenicnik

function validateDate (date) {
	//assert ('testA',date);
	if (isDefined(date)) {
		brokenDate = date.split("-");
		if (brokenDate.length == 3) {
			year = brokenDate[0];
			month = brokenDate[1];
			date = brokenDate[2];
			// check date validity
			testDate = new Date(year, month-1, date);
			if ((testDate.getFullYear() == year) && 
				(testDate.getMonth() == month-1) &&
				(testDate.getDate() == date)) {
				return true;
			} else {
				return false;
			}
		} else {	
			return false;
		}
	}
}

// Courtesy of Omid Tavallai
function setActiveStyleSheet(title) {
  var i, a, main;
  for(i=0; (a = document.getElementsByTagName("link")[i]); i++) {
	curTitle = a.getAttribute("title");
    if(a.getAttribute("rel").indexOf("style") != -1 && a.getAttribute("title")) {
      a.disabled = true;
      if(curTitle == title) {
		a.disabled = false;
	  }
    }
  }
}

function getActiveStyleSheet() {
  var i, a;
  for(i=0; (a = document.getElementsByTagName("link")[i]); i++) {
    if(a.getAttribute("rel").indexOf("style") != -1 && a.getAttribute("title") && !a.disabled) return a.getAttribute("title");
  }
  return null;
}

function getPreferredStyleSheet() {
  var i, a;
  for(i=0; (a = document.getElementsByTagName("link")[i]); i++) {
    if(a.getAttribute("rel").indexOf("style") != -1
       && a.getAttribute("rel").indexOf("alt") == -1
       && a.getAttribute("title")
       ) return a.getAttribute("title");
  }
  return null;
}

function GetPopupTemplate(name, array_values, array_titles, size, display) {

	var display = (display == null) ? "block" : display;
	
	var selectdiv = cachedselectdiv.cloneNode(true);
	var select = cachedselect.cloneNode(true);
	
	if (selectdiv) {
		selectdiv.style.display = display;
		selectdiv.id = name+"_div";
	
		if (select) {
			if (size != null) 
				select.style.width = size + "px";
			select.id = name;
			var option = select.options[0];
		
			for (var k in array_titles) {
				if (k > 0)
					option = option.cloneNode(true);
				
				option.innerHTML = array_titles[k];
				option.value = array_values[k];
				select.appendChild(option);
			}
		
		}
	}
	
	return select;
}

// get window height
function getWindowHeight() {
	var windowHeight=0;
	if (typeof(window.innerHeight)=='number') {
		windowHeight=window.innerHeight;
	}
	else {
		if (document.documentElement&&
		document.documentElement.clientHeight) {
			windowHeight=
			document.documentElement.clientHeight;
		}
		else {
			if (document.body&&document.body.clientHeight) {
				windowHeight=document.body.clientHeight;
			}
		}
	}
	return windowHeight;
}

// find object position
function getPosition(obj) {
	var curleft = curtop = 0;
	if (obj.offsetParent) {
		curleft = obj.offsetLeft
		curtop = obj.offsetTop
		while (obj = obj.offsetParent) {
			curleft += obj.offsetLeft
			curtop += obj.offsetTop
		}
	}
	return [curleft,curtop];
}

// check if object is an array
function isArray(obj) {
//returns true is it is an array
	if (obj.constructor.toString().indexOf("Array") == -1)
		return false;
	else
		return true;
}

function findInArray (obj, value, fromIndex, useCaps, subStringSearch) {
	if (!useCaps)
		useCaps = false;
		
	if (fromIndex == null) {
		fromIndex = 0;
	} else if (fromIndex < 0) {
		fromIndex = Math.max(0, obj.length + fromIndex);
	}
	for (var i = fromIndex; i < obj.length; i++) {
		if (useCaps) {
			if (obj[i].toLowerCase() === value.toLowerCase())
				return i;
		} else if (subStringSearch) {
			if (obj[i].indexOf(value) != -1)
				return i;
		} else {
			if (obj[i] === value)
				return i;
		}
	}
	return -1;
}

function initTooltop() {

	// if tooltip object exists, return
	if ($('dax_tooltip0'))
		return $('dax_tooltip0');
		
	// add node to the page
	var tooltipNode = getTemplate ('dax_tooltip').cloneNode (true);
	var tooltip = document.body.appendChild (tooltipNode);
	tooltip.id = 'dax_tooltip0';
	
	if (tooltip)
		return tooltip;
	else
		return null;
}

function showTooltip(message, x, y) {

	var tooltip = initTooltop();
	
	if (!tooltip)
		return;
		
	setStyle (tooltip, 'display', 'block');
	
	tooltip.innerHTML = message;
	
	setStyle (tooltip, 'top', y - 22 + 'px');
	setStyle (tooltip, 'left', x + 8 + 'px');
	
}

function hideTooltip () {

	var tooltip = $('dax_tooltip0');
	
	if (!tooltip)
		return;

	setStyle (tooltip, 'display', 'none');

}

function ReplaceString(sString, sReplaceThis, sWithThis) {
	if (sReplaceThis != "" && sReplaceThis != sWithThis) {
		var counter = 0;
		var start = 0;
		var before = "";
		var after = "";
		while (counter<sString.length) {
			start = sString.indexOf(sReplaceThis, counter);
			if (start == -1){
				break;
			} else {
				before = sString.substr(0, start);
				after = sString.substr(start + sReplaceThis.length, sString.length);
				sString = before + sWithThis + after;
				counter = before.length + sWithThis.length;
			}
		}
	}
	return sString;
} 

function EncodeString(aString) {
	var sReplaceThis = "%";
	var sWithThis = "&#x";
	var sString = escape(aString);
	
	if (sReplaceThis != "" && sReplaceThis != sWithThis) {
		var counter = 0;
		var start = 0;
		var before = "";
		var after = "";
		while (counter<sString.length) {
			start = sString.indexOf(sReplaceThis, counter);
			if (start == -1){
				break;
			} else {
				before = sString.substr(0, start);
				after = sString.substr(start + sReplaceThis.length + 2, sString.length);
				sString = before + sWithThis + sString.substr(start + sReplaceThis.length, 2) + ";" + after;
				counter = before.length + sWithThis.length + 3;
			}
		}
	}
	return escape(sString);
} 
