function Viewport_destroy() {
	this.parent = null;
	this.owner = null;
	
	if (this.content)
		this.content.parent = null;
	
	this.content = null;
	
	this.hscrollbar.destroy();
	this.vscrollbar.destroy(); 
};

/**
 * Viewport
 *
 * @author Jonathan Le
 *
 */
 function ViewPort()
{
	var node = getTemplate("viewport");
	if (!node)
		return null;

	this.dom = node.cloneNode(true);
//	this.dom.id = "viewport" + getElementsByClassName(document.body, "viewport").length;
	generateUniqueId(this.dom);	

	// V-scrollbar
	this.vscrollbar = new VerticalScrollBar(this.dom);
	this.dom.insertBefore(this.vscrollbar.dom, null);
	this.vscrollbar.viewport = this;
	
	// H-scrollbar
	this.hscrollbar = new HorizontalScrollBar(this.dom);
	this.dom.insertBefore(this.hscrollbar.dom, null);
	this.hscrollbar.viewport = this;
	
	// bottom right corner
	var cornerNode = getTemplate('viewport_bottomrightcorner');
	this.bottomrightcorner = cornerNode.cloneNode(true);
	this.dom.insertBefore(this.bottomrightcorner, null);	
	cornerNode = null;

	i = 1;
	while ($('viewport_bottomrightcorner' + i) != null) {
		i++;
	}
	
	this.bottomrightcorner.id = 'viewport_bottomrightcorner' + i;
	
	this.parent 			= null;
	this.content 			= null;
	this.overflow 			= 0;
	this.hOverflow 			= 0;
	
	// resize viewport when refreshing
	this.resizeOnRefresh	= true;
	
	this.destroy = Viewport_destroy;
	
	this.setContent =
		function(content, overflow)
		{
			this.dom.insertBefore(content, this.hscrollbar.dom);

			this.content = content;
			
			if (isDefined(overflow)) {
				this.setOverflow(overflow);
			} else {
				this.setOverflow(this.content.offsetHeight - this.dom.offsetHeight,
					this.content.offsetWidth - this.dom.offsetWidth);
			}

			setStyle(this.content, "position", "relative");
			setStyle(this.content, "overflow", "hidden");
		};

	this.refresh =
		function()
		{
			// show or hide depending whether or not we have content
			if (!this.content) {
				this.vscrollbar.hide();
				this.hscrollbar.hide();
				// no need to continue because we have no content
				return;
			} else {
				// show scrollbars
				if (this.overflow > 0) {
					this.vscrollbar.show();
				}
				
				if (this.hOverflow > 0) {
					this.hscrollbar.show();
				}
			}
			
			// we've got to make sure the viewport matches the parent
			if ((this.parent) && (this.resizeOnRefresh)) {
				setStyle(this.dom, "width", this.parent.style.width);
				setStyle(this.dom, "height", this.parent.style.height);
			}
	
			// refresh the scrollbar
			this.vscrollbar.refresh();			
			this.hscrollbar.refresh();
		
			if(!browser.safari){
				setStyle(this.bottomrightcorner, "zIndex", ++WindowManager.maxZIndex);
				setStyle(this.vscrollbar.dom, "zIndex", ++WindowManager.maxZIndex);
				setStyle(this.hscrollbar.dom, "zIndex", WindowManager.maxZIndex);
			} else {
				//ACI0049049 fix
				var refreshOnSafari = true;
				if (this.owner) {
					if (this.owner.toString() == '[object GridObject]') {
						if (typeof(this.owner.owner) != 'undefined') {
							if (this.owner.owner.toString() == '[object DataGrid]') {
								if (typeof(this.owner.owner.editor) != 'undefined') {
									if (this.owner.owner.editor.prv.mTearAway.prv.mDOM.style.display != 'none') {
										refreshOnSafari = false;
									}
								}
							}
						}
					}
				}
				
				if (refreshOnSafari) {
					setStyle(this.bottomrightcorner, "zIndex", ++WindowManager.maxZIndex);
					setStyle(this.vscrollbar.dom, "zIndex", ++WindowManager.maxZIndex);
					setStyle(this.hscrollbar.dom, "zIndex", WindowManager.maxZIndex);
				}
			}

			// user defined event
			this.onrefresh();

			// reposition white space in bottom right corner
			if ((this.vscrollbar.dom.style.display != 'none') & (this.hscrollbar.dom.style.display != 'none')) {
				if (browser.ie) {
					var aLeftStyle = this.hscrollbar.dom.offsetWidth + 'px';
				} else {
					var aLeftStyle = this.hscrollbar.dom.offsetWidth + this.bottomrightcorner.offsetWidth - 4 + 'px';
				}
				this.bottomrightcorner.style.left = aLeftStyle;
				this.bottomrightcorner.style.top = parseInt(this.vscrollbar.dom.style.top) + this.vscrollbar.dom.offsetHeight + 'px';
				this.bottomrightcorner.style.display = 'block';
			} else {
				this.bottomrightcorner.style.display = 'none'
			}
		};
	
	this.setOverflow =
		function(overflow, hOverflow)
		{
			// allow the caller to specify an overflow
			// this determines how the scrollbar will be drawn
			this.overflow = overflow;
			if (isDefined(hOverflow)) {
				this.hOverflow = hOverflow;
			}
			
			if (this.overflow <= 0) {
				this.vscrollbar.hide();
			} else {
				this.vscrollbar.show();
			}
			
			if (this.hOverflow <= 0) {
				this.hscrollbar.hide();
			} else {
				this.hscrollbar.show();
			}
		};

	this.onrefresh = function() { };
	
	// user-defined, overrideable
	this.onvscrollstop = function(aTop) { };
	this.onvscrollstart = function(aTop) { };
	this.onvscroll = function(aTop, aIsScrollDown)
	{
		setStyle(this.content, "style", (aTop * (-1) * this.vscrollbar.ratio)+ "px");
	};
	
	this.onhscroll = function(aLeft, aIsScrollRight)
	{
		if (!(isNaN(aLeft * (-1) * this.hscrollbar.ratio))) {
			setStyle(this.content, "left", (aLeft * (-1) * this.hscrollbar.ratio)+ "px");
		}
		
		//RP 12/14/06
		
		//setStyle(this.dom, "width", xpGetSize(this.parent).width + aLeft + "px");
		
		//var newSize = xpGetSize(this.parent).width + aLeft + "px";
		
		//debugAlert ('width:' + newSize);
	};
}

function HorizontalScrollBar_destroy() {
	purgeparents(this);

	this.lArrow 	= null;
	this.rArrow 	= null;
	this.slideArea 	= null;
	this.slider 	= null;

	this.parent = null;
	
	this.viewport = null;
	this.prv.mParent = null;
		
};

/**
 * HorizontalScrollBar
 *
 * probably could've used inheritence...oh well.
 * 
 * @author Jonathan Le
 */
 function HorizontalScrollBar(aParentElement)
{
	var node = getTemplate("hscrollbar");
	if (!node)
		return null;

	// HTML elements
	this.dom = node.cloneNode(true); probe(this.dom);
//	this.dom.id = "hscrollbar" + getElementsByClassName(document.body, "hscrollbar").length;
	generateUniqueId(this.dom);
	
	this.lArrow 	= this.dom.track.arrowLeft;
	this.rArrow 	= this.dom.track.arrowRight;
	this.slideArea 	= this.dom.track.slideArea;
	this.slider 	= this.dom.track.slideArea.slider;
	
	for (var properties in this) {
		this[properties].parent = this;
	}

	// public properties
	this.viewport 	= null;
	this.ratio		= 1;
	this.last		= 0;
	
	this.pageIncrement	= 50;
	this.increment		= 10;
	
	// private properties
	
	this.destroy = HorizontalScrollBar_destroy;
	
	this.prv = {
		mParent : isDefined(aParentElement) ? aParentElement : null,
		mVisibility : true
	}; Function.decl.apply(this); // generate accessors
	
	this.show = function()
	{
		if (this.prv.mVisibility)
			return;
			
		setStyle(this.dom, "display", "block");
		this.prv.mVisibility = true;
	};
	
	this.hide = function()
	{
		if (!this.prv.mVisibility)
			return;
		
		setStyle(this.dom, "display", "none");
		this.prv.mVisibility = false;
	};
	
	// position the scroll bar on any point (x,y)
	this.position = function(aX, aY)
	{
		var v_height = xpGetSize(this.prv.mParent).height;
		var sb_height = xpGetSize(this.dom).height;
		
		if (isDefined(aX)) {
			this.dom.style.left = aX + "px";
		}
		
		if (!isDefined(aY)) {
			var aY = browser.ie ? v_height - sb_height + 1 : v_height - sb_height +
				this.prv.mParent.offsetTop;
		}
		
		// set
		setStyle(this.dom, "top", aY + "px");
	};
	
	// redraw the horizontal scrollbar
	this.refresh = function()
	{
		if (!this.prv.mParent || !this.prv.mVisibility || !this.viewport)
			return;

		this.position();
		
		// calculate the slider height
		var thumbW = 0;
		var parentWidth = xpGetSize(this.prv.mParent).width;
		
		// determine how big the scroll should be
		var scrollWidth = this.viewport.vscrollbar.visible ?
			(parentWidth - xpGetSize(this.viewport.vscrollbar.dom).width) :
			parentWidth;
		
		setStyle(this.dom, "width", scrollWidth + "px");

		var minWidth = xpGetSize(this.slider.sliderLeft).width +
			xpGetSize(this.slider.sliderRight).width;
		var trackSpace = scrollWidth - xpGetSize(this.lArrow).width -
			xpGetSize(this.rArrow).width;
		
		if (trackSpace > this.viewport.hOverflow) {
			// the slider height is the difference
			thumbW = trackSpace - this.viewport.hOverflow;
		} else {
			// the slider is the minimum
			this.ratio = (this.viewport.hOverflow > 0) && (trackSpace > 0) ?
				this.viewport.hOverflow / trackSpace : 1;
		}
		
		// size the slider
		thumbW = thumbW > minWidth ? thumbW : minWidth;

		setStyle(this.slider, "width", thumbW + "px");
		setStyle(this.slider.sliderMid, "width", thumbW -
			(xpGetSize(this.slider.sliderLeft).width +
			xpGetSize(this.slider.sliderRight).width) + "px");
		
		// save the trackSpace
		this.trackSpace = trackSpace;
		
		this.sliderWidth = this.slider.sliderLeft.offsetWidth + this.slider.sliderRight.offsetWidth
			+ this.slider.sliderMid.offsetWidth;
		
		// calculate increments
		this.pageIncrement = this.pageIncrement > this.trackSpace ? this.trackSpace :
			this.pageIncrement;
		this.increment = this.increment > this.trackSpace ? this.trackSpace :
			this.increment;
		
		// sliding area
		var sw = xpGetSize(this.dom.track).width -
			(xpGetSize(this.lArrow).width + xpGetSize(this.rArrow).width);
		setStyle(this.slideArea, "width", sw + "px");
		
		var swRight = this.slider.offsetLeft + thumbW;
		
		if (swRight > this.rArrow.offsetLeft) {
			this.scroll(this.last - (swRight - this.rArrow.offsetLeft));
		} else 
			this.scroll(this.last);
	};
	
	this.scroll = function(aPosition)
	{
		var sh = this.slider.sliderLeft.offsetWidth + this.slider.sliderRight.offsetWidth
			+ this.slider.sliderMid.offsetWidth;
		
		if (aPosition < 0 || (aPosition + sh) > this.slideArea.offsetWidth)
			return;
		
		// set slider position
		setStyle(this.slider, "left", aPosition + "px");
		
		// scrolling down
		var right = (this.last < aPosition);
		this.onscroll(aPosition, right);

		this.last = aPosition;
	};
	
	//
	// Event handlers
	//
	this.slider.onmousedown = function(aEvent)
	{
		var event = xpEvent(aEvent, true, true);
		var curs_pt = getMousePosition(event);
		
		WindowManager.scroll = this.parent;
		WindowManager.scroll.point = getObjectPosition(this.parent.slideArea);

		// calculate the mouse point from the top of the slider
		var point = getObjectPosition(this);
		WindowManager.scroll.offset = curs_pt.x - point.x;
		WindowManager.scroll.last = curs_pt.x - WindowManager.scroll.point.x - WindowManager.scroll.offset;
		
		// Gecko, Safari
		if (document.addEventListener) {
			document.addEventListener("mousemove", horizontalScrollDragging, true);
	   		document.addEventListener("mouseup",   horizontalScrollStop, true);
	    } else { //IE
	      	document.onmousemove = horizontalScrollDragging;
			document.onmouseup   = horizontalScrollStop;
	    }
	    
	    // user def event handler
	    this.parent.onscrollstart(WindowManager.scroll.last);
	    
	    return false;
	};
	
	this.lArrow.onmousedown = function(aEvent)
	{
		this.className = "arrow_left_down";
		var scroll = this.parent;
		var pos = ((scroll.last - scroll.increment) < 0) ? 0 : (scroll.last - scroll.increment);
		scroll.scroll(pos);
	};
	
	this.lArrow.onmouseup = function(aEvent)
	{
		this.className = "arrow_left";
	};
	
	this.rArrow.onmousedown = function(aEvent)
	{
		this.className = "arrow_right_down";
		var scroll = this.parent;
		var sh = scroll.slider.sliderLeft.offsetWidth +scroll.slider.sliderRight.offsetWidth
			+ scroll.slider.sliderMid.offsetWidth;
		var pos = scroll.last + scroll.increment;
		pos = (pos + sh) > scroll.slideArea.offsetWidth ?
			scroll.slideArea.offsetWidth - sh : pos;
		
		scroll.scroll(pos);
	};
	
	this.rArrow.onmouseup = function(aEvent)
	{
		this.className = "arrow_right";
	};

	this.slideArea.onmousedown = function(aEvent)
	{
		var event = xpEvent(aEvent);
		var scrollbar = this.parent;
		var sh = scrollbar.slider.sliderLeft.offsetWidth + scrollbar.slider.sliderRight.offsetWidth
			+ scrollbar.slider.sliderMid.offsetWidth;
		
		var pt = getMousePosition(event);
		
		var p = getObjectPosition(this);
		var x = pt.x - p.x;

		if (x < scrollbar.last) {
			scrollbar.scroll((scrollbar.last - scrollbar.pageIncrement) < 0 ? 0 : scrollbar.last - scrollbar.pageIncrement);
		} else if (x > scrollbar.last + sh) {
			scrollbar.scroll((scrollbar.last + scrollbar.pageIncrement + sh) > scrollbar.slideArea.offsetWidth ? scrollbar.slideArea.offsetWidth - sh : scrollbar.last + scrollbar.pageIncrement);
		}
		
		return false;
	};
	
	//
	// Abstract methods (overrideable)
	//
	this.onscrollstart = function(aLeft)
	{
		if (this.viewport && this.viewport.onhscrollstart)
			this.viewport.onhscrollstart(aLeft);
	};
	
	this.onscroll = function(aLeft, aIsScrollRight)
	{
		if (this.viewport && this.viewport.onhscroll)
			this.viewport.onhscroll(aLeft, aIsScrollRight);
	};
	
	this.onscrollstop = function(aLeft)
	{
		if (this.viewport && this.viewport.onhscrollstop)
			this.viewport.onhscrollstop(aLeft);
	};
	
	// init
	{
		setStyle(this.dom, "display", "block");
		setStyle(this.dom, "position", "absolute");
	}
	
	return this;
}

//
// Jonathan Le
//
// Handles the scroll thumb being dragged
//
function horizontalScrollDragging(aEvent)
{
	var event = xpEvent(aEvent, true);
	var point = getMousePosition(event);
	var scrollbar = WindowManager.scroll;
	
	// calculate the top position of the slider in relation to the cursor
	var left = point.x - scrollbar.point.x - scrollbar.offset;
	scrollbar.scroll(left);
	
	return false;
}

//
// Jonathan Le
//
// Handles the scroll thumb dragged to a stop
//
function horizontalScrollStop(aEvent)
{
	var event = xpEvent(aEvent, true);
	var point = getMousePosition(event);
	var scrollbar = WindowManager.scroll;
	
	// calculate the top position of the slider in relation to the cursor
	var left = point.x - scrollbar.point.x - scrollbar.offset;
	
	var scrollbar = WindowManager.scroll;
 	scrollbar.onscrollstop(left);
	
	WindowManager.scroll = null;

	// Gecko
	if (document.removeEventListener) {
		document.removeEventListener("mousemove", horizontalScrollDragging, true);
		document.removeEventListener("mouseup",   horizontalScrollStop, true);
	} else {
		document.onmousemove = null;
 		document.onmouseup   = null;
	}
	
	return false;
}

function VerticalScrollBar_destroy() {
	purgeparents(this);

	this.arrowTop 	= null;
	this.arrowBottom 	= null;
	this.slideArea 	= null;
	this.slider 	= null;
	
	this.parent = null;
	
	this.viewport = null;
};		

/**
 * VeritcalScrollBar
 *
 * @author Jonathan Le
 */
function VerticalScrollBar(aParentElement)
{
	var node = getTemplate("scrollbar");
	if (!node)
		return null;
	
	// HTML related properties
	this.dom = node.cloneNode(true); probe(this.dom);
	this.arrowTop 		= this.dom.track.arrowTop;
	this.arrowBottom 	= this.dom.track.arrowBottom;
	this.slideArea		= this.dom.track.slideArea;
	this.slider			= this.slideArea.slider;
	this.slider.top		= this.slider.sliderTop;
	this.slider.mid		= this.slider.sliderMid;
	this.slider.bottom	= this.slider.sliderBottom;

//	this.dom.id = "scrollbar" + getElementsByClassName(document.body, "scrollbar").length;
	generateUniqueId(this.dom);
	
	for (var properties in this) {
		this[properties].parent = this;
	}
	
	// properties
	this.parent 	= isDefined(aParentElement) ? aParentElement : null;
	this.visible 	= true;
	this.viewport 	= null;
	this.ratio 		= 1;
	this.last 		= 0;
	
	// arrow advancing
	this.increment 	= 10;
	this.pageIncrement = 50;
	
	// methods
	
	this.destroy = VerticalScrollBar_destroy;
	
	this.position = function(aX, aY)
	{
//		var pt = getObjectPosition(this.parent);
		var v_width = xpGetSize(this.parent).width;
		var sb_width = xpGetSize(this.dom).width;
		
		if (!isDefined(aX)) {
			var aX = (browser.ie) ? v_width - sb_width :
				v_width - sb_width + this.parent.offsetLeft;
		}
		
		if (!isDefined(aY)) {
			var aY = (browser.ie) ? 0 : this.parent.offsetTop;
		}
		
		setStyle(this.dom, "left", aX + "px");
		setStyle(this.dom, "top", aY + "px");
	};
	
	// before refresh, user customizable
	this.beforeRefresh = function () { };
	
	this.refresh = function()
	{
		if (!this.parent || !this.visible || !this.viewport)
			return;
		
		this.beforeRefresh();
		
		// calculate the slider height
		var sh = 0;
		this.position(); // reset position
		
		var parentHeight = (browser.ie) ? xpGetSize(this.parent).height + 3 :
			xpGetSize(this.parent).height;
		
		var minHeight = xpGetSize(this.slider.top).height +
			xpGetSize(this.slider.bottom).height;

		// determine scroll height
		var scrollHeight = this.viewport.hscrollbar.getVisibility() ?
			(parentHeight - xpGetSize(this.viewport.hscrollbar.dom).height) :
			parentHeight;
		
		setStyle(this.dom, "height", parseInt(scrollHeight) + "px");

		var trackSpace = scrollHeight - xpGetSize(this.arrowTop).height -
			xpGetSize(this.arrowBottom).height;
		/*
		if ((this.isStatic == undefined) || (!this.isStatic)) { // if (this.isStatic) {
			if (trackSpace < this.viewport.overflow) {
				// the slider height is the difference
				sh = trackSpace - this.viewport.overflow;
	
			} else {
				// the slider is the minimum
				this.ratio = (this.viewport.overflow > 0) && (trackSpace > 0) ? 
					this.viewport.overflow / trackSpace : 1;
			}
			
			// size the slider
			sh = sh > minHeight ? sh : minHeight;
		
		}
		*/
		if (!this.isStatic) {
			sh = (this.viewport.dom.offsetHeight - 2 * this.viewport.owner.grid.header.offsetHeight) * trackSpace / (this.viewport.dom.offsetHeight + this.viewport.overflow - 2 * this.viewport.owner.grid.header.offsetHeight);
			this.pageIncrement = sh;
			sh = sh > minHeight ? sh : minHeight;

			this.ratio = (this.viewport.overflow > 0) && ((trackSpace-sh) > 0) ? 
					this.viewport.overflow / (trackSpace-sh) : 1;
		}
		else {
			sh = (this.areaHeight - this.viewport.overflow) * trackSpace / this.areaHeight ;
			this.pageIncrement = sh;
			
			// size the slider
			sh = sh > minHeight ? sh : minHeight;
			this.ratio = (this.viewport.overflow > 0) && ((trackSpace-sh) > 0) ? 
					this.viewport.overflow / (trackSpace-sh) : 1;
//			this.ratio = (this.viewport.overflow > 0) && (trackSpace > 0) ?  
//				this.areaHeight / trackSpace : 1;
			
		}
		
		setStyle(this.slider, "height", sh + "px");
		setStyle(this.slider.mid, "height", sh - (xpGetSize(this.slider.top).height +
			xpGetSize(this.slider.bottom).height) + "px");
		//if ((this.slider.offsetHeight + this.slider.offsetTop) > (parentHeight - xpGetSize(this.arrowTop).height - xpGetSize(this.arrowBottom).height))
		//	setStyle(this.slider, "top", parentHeight - xpGetSize(this.arrowTop).height - xpGetSize(this.arrowBottom).height - sh + "px");
		
		// save the trackSpace
		this.trackSpace = trackSpace;

		this.sliderHeight = this.slider.top.offsetHeight + this.slider.bottom.offsetHeight
			+ this.slider.mid.offsetHeight;
		
		// calculate increments
		this.pageIncrement = this.pageIncrement > this.trackSpace ? this.trackSpace :
			this.pageIncrement;
		this.increment = this.increment > this.trackSpace ? this.trackSpace :
			this.increment;
		
		// calc sliding area
		var height = this.dom.track.offsetHeight -
			(xpGetSize(this.arrowTop).height + xpGetSize(this.arrowBottom).height);
			
		if (height < 0)
			return;
			
		this.slideArea.style.height = parseInt(height) + "px";

		if (height < this.slider.offsetTop) {
			setStyle(this.slider, "top",
				parseInt(height - this.arrowBottom.offsetHeight) + "px");
		}
	};
	
	this.show = function()
	{
		setStyle(this.dom, "display", "block");
		this.visible = true;
	};
	
	this.hide = function()
	{
		setStyle(this.dom, "display", "none");
		this.visible = false;
	};
	
	this.scroll = function(position, skipOnScroll)
	{
		var sh = this.slider.top.offsetHeight + this.slider.bottom.offsetHeight
			+ this.slider.mid.offsetHeight;
		
		if (position < 0 || (position + sh) > this.slideArea.offsetHeight)
			return;
		
		// set slider position
		setStyle(this.slider, "top", position + "px");
		//assert('testA', position);
		// scrolling down
		var down = (this.last < position);
		if (!skipOnScroll)
			this.onscroll(position, down);

		this.last = position;
	};
	
	//
	// Event Handlers
	//
	this.slider.onmousedown = function(aEvent)

	{
		// IE, W3C Compatability
		var event = xpEvent(aEvent, true);
		var pt = getMousePosition(event);
		
		WindowManager.scroll = this.parent;
		WindowManager.scroll.point = getObjectPosition(this.parent.slideArea);

		// calculate the mouse point from the top of the slider
		var point = getObjectPosition(this);
		WindowManager.scroll.offset = pt.y - point.y;
		WindowManager.scroll.last = pt.y - WindowManager.scroll.point.y - WindowManager.scroll.offset;
		
		// Gecko, Safari
		if (document.addEventListener) {
			document.addEventListener("mousemove", verticalScrollDragging, true);
	    	document.addEventListener("mouseup",   verticalScrollStop, true);
	    } else { // IE
	    	document.onmousemove = verticalScrollDragging;
			document.onmouseup   = verticalScrollStop;
	    }

		// user def event handler
	    this.parent.onscrollstart(WindowManager.scroll.last);
	    
	    return false;
	};
		
	this.arrowTop.onmousedown = function(aEvent)
	{
		var scrollbar = this.parent;
		var pos = scrollbar.last - scrollbar.increment < 0 ? 0 :
			scrollbar.last - scrollbar.increment;
		scrollbar.scroll(pos);
		
		this.className = "arrow_top_down";
	};
	
	this.arrowTop.onmouseup = function(aEvent)
	{
		this.className = "arrow_top";
		this.parent.onscrollstop(this.parent.last);
	};

	this.arrowBottom.onmousedown = function(aEvent)
	{
		var scrollbar = this.parent;
		var sh = scrollbar.slider.top.offsetHeight + scrollbar.slider.bottom.offsetHeight
			+ scrollbar.slider.mid.offsetHeight;
		var pos = scrollbar.last + scrollbar.increment;
		pos = (pos + sh) > scrollbar.slideArea.offsetHeight ?
			scrollbar.slideArea.offsetHeight - sh :	pos;
		
		scrollbar.scroll(pos);
		
		this.className = "arrow_bottom_down";
	};
	
	this.arrowBottom.onmouseup = function()
	{
		this.className = "arrow_bottom";
		this.parent.onscrollstop(this.parent.last);
	};
	
	this.slideArea.onmousedown = function(event)
	{
		var event = xpEvent(event);
		var scrollbar = this.parent;
		var sh = scrollbar.slider.top.offsetHeight + scrollbar.slider.bottom.offsetHeight
			+ scrollbar.slider.mid.offsetHeight;
		
		var pt = getMousePosition(event);
		
		var p = getObjectPosition(this);
		var y = pt.y - p.y;
		
		if (y < scrollbar.last) {
			scrollbar.scroll((scrollbar.last - scrollbar.pageIncrement) < 0 ? 0 : scrollbar.last - scrollbar.pageIncrement);
		} else if (y > scrollbar.last + sh) {
			scrollbar.scroll((scrollbar.last + scrollbar.pageIncrement + sh) > scrollbar.slideArea.offsetHeight ? scrollbar.slideArea.offsetHeight - sh : scrollbar.last + scrollbar.pageIncrement);
		}
		
		return false;
	};
	
	this.slideArea.onmouseup = function(aEvent)
	{
		var scrollbar = this.parent;
		scrollbar.arrowTop.onmouseup();
		scrollbar.arrowBottom.onmouseup();
	};
	
	//
	// custom handlers
	//
	this.onscrollstart = function(aTop)
	{	
		this.isScrolling = true;
		if (this.viewport)
			this.viewport.onvscrollstart(aTop);
	};
	
	this.onscroll = function(aTop, aIsScrollDown)
	{
		if (this.viewport)
			this.viewport.onvscroll(aTop, aIsScrollDown);
	};
	
	this.onscrollstop = function(aTop)
	{
		var sh = this.slider.top.offsetHeight + this.slider.bottom.offsetHeight
			+ this.slider.mid.offsetHeight;
			
		if ((aTop + sh) > this.slideArea.offsetHeight)
			var aTop = this.slideArea.offsetHeight - sh;
	
		if (this.viewport)
			this.viewport.onvscrollstop(aTop);

		this.isScrolling = false;
	};
	
	// initializer
	{
		setStyle(this.dom, "display", "block");
		setStyle(this.dom, "position", "absolute");
	}
	
	return this;
}

//
// Jonathan Le
//
// Handles the scroll thumb being dragged
//
function verticalScrollDragging(event)
{
	var event = xpEvent(event, true);
	var point = getMousePosition(event);
	var scrollbar = WindowManager.scroll;
	
	// calculate the top position of the slider in relation to the cursor
	var top = point.y - scrollbar.point.y - scrollbar.offset;
	scrollbar.scroll(top);
	
	return false;
}

//
// Jonathan Le
//
// Handles the scroll thumb dragged to a stop
//
function verticalScrollStop(event)
{
	var event = xpEvent(event, true);
	var point = getMousePosition(event);
	var scrollbar = WindowManager.scroll;
	
	// calculate the top position of the slider in relation to the cursor
	var top = point.y - scrollbar.point.y - scrollbar.offset;
 	scrollbar.onscrollstop(top);
	
	WindowManager.scroll = null;

	// Gecko
	if (document.removeEventListener) {
		document.removeEventListener("mousemove", verticalScrollDragging, true);
		document.removeEventListener("mouseup",   verticalScrollStop, true);
	} else {
		document.onmousemove = null;
 		document.onmouseup   = null;
	}
}

