// test by Jonathan Le

function WindowManager_createNewWindow()
{
	var newWindow = null;
	try {
		newWindow = new Window();
   	} catch(e) {alert(e.description + e.message + e.number + e.name);}
   	return newWindow;
};

function WindowManager_insertWindow(aWindow)
{
	// check to see that the window isn't already added
	for (var i = 0; i < this.windows.length; i++) {
		if (this.windows[i] == aWindow) {
			return this.windows[i];
		}
	}
	
	if (!this.windowTarget)
		this.windowTarget = new WindowTarget();
		
	var target = this.windowTarget.area;
	target.insertBefore(aWindow.dom, null);
	
	return this.windows.push(aWindow);
};

function WindowManager_destroyWindow(aWindow)
{
	if (this.active == aWindow) {
		WindowManager.active = null;
	}
	
	var windowindex = -1;
	for (var i = 0; i < WindowManager.windows.length; i++)
		if (WindowManager.windows[i] == aWindow)
			windowindex = i;

	// close the window
	aWindow.close();
			
	// purge (aWindow.dom); 
	WindowManager.windowTarget.area.removeChild(aWindow.dom);
			
	if (windowindex > -1) {
		WindowManager.windows[windowindex] = null;
		WindowManager.windows.splice(windowindex, 1);			
	}
	//		delete aWindow;
};

function WindowManager_hideWindow(aWindow)
{
	if (this.active == aWindow) {
		WindowManager.active = null;
	}
	do_accordion(aWindow.dom, 'top')
	setStyle(aWindow.dom,'display','none');
};

function WindowManager_redraw()
{
	// redraw all the windows
	var winObj;
	for (var i = 0; i < this.windows.length; i++) {
		winObj = this.windows[i];
		winObj.size(winObj.dom.offsetWidth, winObj.dom.offsetHeight);
	}
};

// function WindowManager_

function WindowManager()
{
	this.active = null;
	this.maxZIndex = 0;
	this.maxZDashIndex = 9110;
//	this.windowTarget = {
//		area : document.body
//	};
	this.windowTarget = null;
	this.windows = new Array();
	this.scroll = null;
	
	// prototypes
	this.createNewWindow = WindowManager_createNewWindow;
	
	this.insertWindow = WindowManager_insertWindow;
	
	this.destroyWindow = WindowManager_destroyWindow;

	this.hideWindow = WindowManager_hideWindow;
	
/*
	
	this.fadeWindow = function(aWindow, fadeticker)
	{
		assert('testA',aWindow + ":" + fadeticker);
		if (this.active == aWindow) {
			WindowManager.active = null;
		}
		if (fadeticker > 0) {
			setStyle(aWindow.dom, 'opacity', '0.' + this.fadeticker);
			setStyle(aWindow.dom, '-moz-opacity', '0.' + this.fadeticker);
			setStyle(aWindow.dom, 'filter', 'alpha(opacity = ' + this.fadeticker + ')');
			fadeticker = fadeticker - 10;
			setTimeout (this.fadeWindow(aWindow,fadeticker), 1000); 
		} else {
			setStyle(aWindow.dom,'display','none');
		}
	};

*/
	
	this.redraw = WindowManager_redraw;
	
	return this;
}

// finds window by table id assigned to id
function findWindowByTableId(tableId) {

	// loop though window to find it
	for (ta = 0; ta < WindowManager.windows.length; ta++) {
		if (WindowManager.windows[ta].tableId == tableId)
			return WindowManager.windows[ta];
	}
	
	// not found
	return null;
}

function WindowTarget()
{
	this.area = document.body;
	return this;
}

function windowDragStart(event)
{	
	// activate the window
	this.parent.activate();
	this.parent.ondragstart();
	
	var x = 0;
	var y = 0;
	
	if (browser.ie) {
	    x = window.event.screenX;
	    y = window.event.screenY;
 
 	   document.onmousemove = windowDragging;
 	   document.onmouseup   = windowDragStop;
	} else {
		x = event.pageX;
		y = event.pageY;
 
		document.addEventListener("mousemove", windowDragging, true);
    	document.addEventListener("mouseup",   windowDragStop, true);
    	event.preventDefault();
	}
     
    WindowManager.active.offsetX = WindowManager.active.dom.offsetLeft - x;
    WindowManager.active.offsetY = WindowManager.active.dom.offsetTop - y;
    
    WindowManager.active.dragging = true;
}

function windowDragging(event)
{
	var x = 0;
	var y = 0;
	
	if (!WindowManager.active.dragging)
		return;
		
	if (browser.ie) {
		x = window.event.screenX;
		y = window.event.screenY;
		window.event.cancelBubble = true;
	    window.event.returnValue = false;
	} else {
		x = event.pageX;
		y = event.pageY;
		event.preventDefault();
	}
	
	x = (x+WindowManager.active.offsetX);
	y = (y+WindowManager.active.offsetY);
	
	if (x >= 0)
		WindowManager.active.dom.style.left = x +"px";
		
	if (y >= 0)
		WindowManager.active.dom.style.top = y +"px";
}

function windowDragStop(event)
{
	WindowManager.active.dragging = false;
	
	if (browser.ie) {
 		document.onmousemove = null;
 		document.onmouseup   = null;	
	} else {
		document.removeEventListener("mousemove", windowDragging, true);
	    document.removeEventListener("mouseup",   windowDragStop, true);
    }
	
	WindowManager.active.ondragstop();	
}

function Window_destroy() {
	purgeparents(this);
	this.contentArea.grid = null;

	if (this.currentTab) {	
		this.currentTab.owner = null;
		this.currentTab = null;
		delete this.currentTab;
	}
	
	this.grid.owner = null;
	this.grid.destroy();
	delete this.grid;
	
	this.search.owner = null;

	this.tabsbar.destroy();
	delete this.tabsbar;

	for (var i in this.mainToolbar.prv.mContent)
		this.mainToolbar.prv.mContent[i].parent = null;
	
	this.mainToolbar.prv.mDOM.parent = null;
	this.mainToolbar.prv.mDOM.contents = null;
	
	for (var i in this.toolbars)
		this.toolbars[i].parent = null;
		
	this.table = null;
	this.winObj = null;
};

function Window_toString()
{
	return "[object Window]";
};		

function Window_activate()
{
	// window object
	var win = this;
	
	// current active window was clicked again
	if (win == WindowManager.active)
		return;

	// unfocus the last window
	if (WindowManager.active) {
		WindowManager.active.deactivate();
	}
	
	// change the style
	with (this) {
		dom.t.className = "window_t_a";
		dom.tl.className = "window_tl_a";
		dom.tr.className = "window_tr_a";
		dom.l.className = "window_l_a";
		dom.r.className = "window_r_a";
		dom.b.className = "window_b_a";
		dom.bl.className = "window_bl_a";
		dom.br.className = "window_br_a";
		closeBox.className = "window_closebox";
		minimizeBox.className = "window_minimizebox";
		refreshBox.className = "window_refreshbox";
		savePrefsBox.className = "window_saveprefsbox";
		
		win.dom.style.zIndex = ++WindowManager.maxZIndex;
		//alert('Window Zindex1 = ' + win.dom.style.zIndex);
	}
	
	// set the current focus to this window
	WindowManager.active = win;
	
	setStyle(this.dom, 'display','block');
	
	// check if window has corresponding tab, if so select it
	if (this.tbitem) {
		this.tbitem.setSelected(true,true);
	}
};

function Window_deactivate()
{
	this.dom.t.className = "window_t";
	this.dom.tl.className = "window_tl";
	this.dom.tr.className = "window_tr";
	this.dom.l.className = "window_l";
	this.dom.r.className = "window_r";
	this.dom.b.className = "window_b";
	this.dom.bl.className = "window_bl";
	this.dom.br.className = "window_br";
	this.closeBox.className = "window_closebox_o";
	this.minimizeBox.className = "window_minimizebox_o";
	this.refreshBox.className = "window_refreshbox_o";
	this.savePrefsBox.className = "window_saveprefsbox_o";
	
	WindowManager.active = null;
};

function Window_size(width, height, overrideMinimumSize)
{
	var win = this;
	var frame = win.dom;
	
	var closebox = win.closeBox;
	var minimizebox = win.minimizeBox;
	var refreshbox = win.refreshBox;
	var title = win.titleBar;
	var content = win.contentArea;
	var logo = win.logo;
	var savePrefsBox = win.savePrefsBox;
	
	// resize by width
	if (isDefined(width) && width > 0) { 

		// set minimum size if needed
		if ((!overrideMinimumSize) && (this.minimumWidth) && (width <= this.minimumWidth))
			width = this.minumumWidth;
	
		// resize the top portion width
		var dx = (frame.tr.offsetWidth ? frame.tr.offsetWidth : 0) + (frame.tl.offsetWidth ? frame.tl.offsetWidth : 0);
		
		// ie7 fix
		if (!width)
			return;
		
		frame.t.style.width = width - dx + "px";
		
		if (savePrefsBox.style.display != 'none') {
			title.style.width = width - (dx + savePrefsBox.offsetWidth + refreshbox.offsetWidth + minimizebox.offsetWidth + closebox.offsetWidth +
			logo.offsetWidth) + "px";
		} else { 
			title.style.width = width - (dx + refreshbox.offsetWidth + minimizebox.offsetWidth + closebox.offsetWidth +
				logo.offsetWidth) + "px";
		}
			
		// resize the bottom portion width
		dx = (frame.bl.offsetWidth ? frame.bl.offsetWidth : 0) + (frame.br.offsetWidth ? frame.br.offsetWidth : 0);
		frame.b.style.width = width - dx + "px";
		
		// resize the middle portion
		dx = (frame.r.offsetWidth ? frame.r.offsetWidth : 0) + (frame.l.offsetWidth ? frame.l.offsetWidth : 0);
		content.style.width = width - dx + "px";
		
		for (var i in this.toolbars) {
			var toolbar = this.toolbars[i];
			if (this.doResizeToolbar)
				toolbar.style.width = content.style.width;
			// resize tabs bar
			if ((toolbar.className == 'tabs_tb') || (toolbar.className == 'tabs'))
				toolbar.style.width = content.style.width;
			}
		
		win.status.style.width = content.style.width;
		frame.m.style.width = content.style.width;
		
		// required to properly resize the window
		frame.style.width = width + "px";
	}
	
	// resize by height
	if (isDefined(height) && height > 0) {

		// set minimum size if needed
		if ((!overrideMinimumSize) && (this.minimumHeight) && (height <= this.minimumHeight))
			height = this.minimumHeight;

		var dy = (frame.b.offsetHeight ? frame.b.offsetHeight : 0) + (frame.t.offsetHeight ? frame.t.offsetHeight : 0);
		var tbDy = 0;
		
		for (var i in this.toolbars) {
			tbDy += (this.toolbars[i].offsetHeight ? this.toolbars[i].offsetHeight : 0);
		}

		// ie7 fix
		if (!height)
			return;
		
		if (height - dy - tbDy - (win.status.offsetHeight ? win.status.offsetHeight : 0) > 0)
			content.style.height = height - dy - tbDy -	(win.status.offsetHeight ? win.status.offsetHeight : 0) + "px";
		frame.l.style.height = height - dy + "px" ;
		frame.r.style.height = height - dy + "px";
		
		frame.style.height = height + "px";
	}
	
	this.onsize();
};

function Window_resize(dx, dy, overrideMinimumSize)
{
	var width = 0;
	var height = 0;
	
	if (dx == undefined || dx == null)
		dx = 0;
	
	if (dy == undefined || dy == null)
		dy = 0;
		
	// increase by dx, or dy
	width = this.dom.offsetWidth + dx;
	height = this.dom.offsetHeight + dy;
	
	this.size(width, height, overrideMinimumSize);
};

function Window_resizeToolbar(bool)
{
	if (bool == false)
		this.doResizeToolbar = false;
	else
		this.doResizeToolbar = true;
};

function Window_setTitle(newTitle)
{
	if (newTitle)
		this.titleBar.innerHTML = newTitle;
};

function Window_addToolbar(toolbar)
{
	if (this.toolbars.length > 0) {
		var tb = this.toolbar.cloneNode(false);
		this.dom.m.insertBefore(tb, this.contentArea);
	} else {
		var tb = this.toolbar;
	}
	
	tb.appendChild(toolbar);
	this.toolbars.push(toolbar);
};

function Window_close()
{
	// custom
	this.onclose();
};

function Window_open()
{
	// have the window manager insert ourselves
	WindowManager.insertWindow(this);
	
	// size and activate the window for the first time
	this.size(this.dom.offsetWidth, this.dom.offsetHeight);
   	this.activate();
	
	// custom
	this.onopen();
};

function Window_empty() { };

// function Window_

function Window()
{
	node = getTemplate("window");

	if (!node)
		return null;

	// override toString
	this.toString = Window_toString;		
		
	// prototypes
	this.destroy = Window_destroy;
	
	this.activate = Window_activate;
	
	this.deactivate = Window_deactivate;
	
	this.size = Window_size;
	
	this.resize = Window_resize;

	// added by Rudolf Psenicnik
	// disable toolbar resizing, useful when using overflow with toolbar
	this.resizeToolbar = Window_resizeToolbar;
	
	// set window title bar
	this.setTitle = Window_setTitle;
	
	// count
	var windowCount = WindowManager.windows.length;
	
	// create the nodes
	this.dom 	= node.cloneNode(true);
	this.dom.tl	= getElementByClassName(this.dom, "window_tl");
	this.dom.l	= getElementByClassName(this.dom, "window_l");
	this.dom.bl	= getElementByClassName(this.dom, "window_bl");
	this.dom.t	= getElementByClassName(this.dom, "window_t");
	this.dom.m	= getElementByClassName(this.dom, "window_m");
	this.dom.b	= getElementByClassName(this.dom, "window_b");
	this.dom.tr	= getElementByClassName(this.dom, "window_tr");
	this.dom.r	= getElementByClassName(this.dom, "window_r");
	this.dom.br	= getElementByClassName(this.dom, "window_br");
	this.dom.top	= getElementByClassName(this.dom, "window_top");
	this.dom.btm	= getElementByClassName(this.dom, "window_bottom");
	
	this.logo 			= getElementByClassName(this.dom, "window_logo");
	this.titleBar 		= getElementByClassName(this.dom, "window_title");
	this.toolbar 		= getElementByClassName(this.dom, "window_toolbar");
	this.contentArea 	= getElementByClassName(this.dom, "window_content");
	this.closeBox 		= getElementByClassName(this.dom, "window_closebox");
	this.minimizeBox	= getElementByClassName(this.dom, "window_minimizebox");
	this.refreshBox		= getElementByClassName(this.dom, "window_refreshbox");
	this.savePrefsBox	= getElementByClassName(this.dom, "window_saveprefsbox");
	this.status			= getElementByClassName(this.dom, "window_status");
	this.message		= getElementByClassName(this.dom, "window_status_message");
	
	// an array of toolbars
	this.toolbars = new Array();
	this.doResizeToolbar = true;
	
	// frame
	this.dom.id = this.dom.className+windowCount;
	this.dom.parent = this;
	this.dom.style.display = "block";
	if (WindowManager.active) {
		this.dom.style.top = WindowManager.active.dom.offsetTop + 25 + "px";
		this.dom.style.left = WindowManager.active.dom.offsetLeft + 25 + "px";	
		this.dom.style.width = WindowManager.active.dom.offsetWidth + "px";
		this.dom.style.height = WindowManager.active.dom.offsetHeight + "px";	
	}	
	else {
		this.dom.style.top = "40px";
		this.dom.style.left = "200px";	
	}
	this.dom.style.zIndex = ++WindowManager.maxZIndex;
	//alert('Toolbar zIndex = ' + this.dom.style.zIndex);

	// resizing events
	this.dom.tl.onmousedown = resizeDragStart;
	this.dom.t.onmousedown 	= resizeDragStart;
	this.dom.tr.onmousedown = resizeDragStart;
	this.dom.l.onmousedown 	= resizeDragStart;
	this.dom.r.onmousedown 	= resizeDragStart;
	this.dom.bl.onmousedown	= resizeDragStart;
	this.dom.b.onmousedown 	= resizeDragStart;
	this.dom.br.onmousedown	= resizeDragStart;

	// titleBar
	if (this.titleBar) {
		this.titleBar.id = this.titleBar.className+windowCount;
		this.titleBar.parent = this;

		// event handling
		this.titleBar.onmousedown = windowDragStart;
	}
	
	// content area
	if (this.contentArea) {
		this.contentArea.id = this.contentArea.className+windowCount;
		this.contentArea.parent = this;

		// event handling
		this.contentArea.onmousedown = function() { this.parent.activate(); };
	}
	
	//toolbar
	if (this.toolbar) {
		this.toolbar.parent = this;
		this.toolbar.id = this.toolbar.className+windowCount;
	}
		
	// close box
	if (this.closeBox) {
		this.closeBox.parent = this;
		this.closeBox.id = this.closeBox.className+windowCount;
		
		function Window_closeBox_onmousedown(event)
			{ 
				var event = xpEvent(event, true);
				this.className = "window_closebox_d";
				this.parent.activate();
			};
		
		function Window_closeBox_onmouseup(event)
		{
			if (event)
				var event = xpEvent(event, true);
			var aWindow = this.parent;
			WindowManager.destroyWindow(this.parent);
			setTimeout(function() {aWindow = null;}, 1);
			return false;
		};
		
		function Window_closeBox_onmouseover() { this.className = "window_closebox_a"; };
		
		function Window_closeBox_onmouseout() 
			{
				if (WindowManager.active == this.parent)
					this.className = "window_closebox";
				else
					this.className = "window_closebox_o";
			};
			
		// function Window_closeBox_
		
		// Events
		this.closeBox.onmousedown = Window_closeBox_onmousedown;
		
		this.closeBox.onmouseup = Window_closeBox_onmouseup;
		
		this.closeBox.onmouseover = Window_closeBox_onmouseover;
		
		this.closeBox.onmouseout = Window_closeBox_onmouseout;
	}

	// minimize box
	if (this.minimizeBox) {
		this.minimizeBox.parent = this;
		this.minimizeBox.id = this.minimizeBox.className+windowCount;
		
		function Window_minimizeBox_onmouseover() { this.className = "window_minimizebox_a"; };

		function Window_minimizeBox_onmouseout() 
			{
				if (WindowManager.active == this.parent)
					this.className = "window_minimizebox";
				else
					this.className = "window_minimizebox_o";
			};		
		
		function Window_minimizeBox_onmousedown(event)
			{ 
				var event = xpEvent(event, true);
				this.className = "window_minimizebox_d";
				this.parent.activate();
			};
		
		function Window_minimizeBox_onmouseup(event)
		{
			var event = xpEvent(event, true);
			WindowManager.hideWindow(this.parent);
			return false;
		};
		
		// function Window_minimizeBox_
		
		this.minimizeBox.onmouseover = Window_minimizeBox_onmouseover;
		
		this.minimizeBox.onmouseout = Window_minimizeBox_onmouseout;		

		this.minimizeBox.onmousedown = Window_minimizeBox_onmousedown;
		
		this.minimizeBox.onmouseup = Window_minimizeBox_onmouseup;
			
	}

	// save prefs box
	if (this.savePrefsBox) {
		this.savePrefsBox.parent = this;
		this.savePrefsBox.id = this.savePrefsBox.className+windowCount;
		
		function Window_savePrefsBox_onmouseover(aEvent) 
			{
				this.className = "window_saveprefsbox_a";
				mousePos = getMousePosition (aEvent);
				showTooltip(STR['save_column_width'], mousePos.x, mousePos.y);				
				
			};

		function Window_savePrefsBox_onmouseout() 
			{
				hideTooltip();
				if (WindowManager.active == this.parent)
					this.className = "window_saveprefsbox";
				else
					this.className = "window_saveprefsbox_o";
			};		
		
		function Window_savePrefsBox_onmousedown(event)
			{ 
				var event = xpEvent(event, true);
				this.className = "window_saveprefsbox_d";
				this.parent.activate();
			};
		
		function Window_savePrefsBox_onmouseup(event)
		{
			var event = xpEvent(event, true);
			// WindowManager.hideWindow(this.parent);
			this.className = "window_saveprefsbox";
			var grid = this.parent.contentArea.grid;
			var url = dax_bridge.url + "AdminSetPreferences?sessionId=" + dax_bridge.sessionId + 
				"&dax_colwidth_" + this.parent.tableId + "=";
				
			// add column widths to save prefs
			for (var colCount = 0; colCount < grid.grid.prv.mColumns.length; colCount++) {
				url += grid.grid.prv.mColumns[colCount].fieldId + ':' +
					grid.grid.prv.mColumns[colCount].prv.mWidth + '_';			
			}
			
			makeCall (url, null, null, null);			
			//grid.reload();
			return false;
		};
		
		// function Window_refreshBox_
		
		this.savePrefsBox.onmouseover = Window_savePrefsBox_onmouseover;
		
		this.savePrefsBox.onmouseout = Window_savePrefsBox_onmouseout;		

		this.savePrefsBox.onmousedown = Window_savePrefsBox_onmousedown;
		
		this.savePrefsBox.onmouseup = Window_savePrefsBox_onmouseup;
			
	}	
	
	// refresh box
	if (this.refreshBox) {
		this.refreshBox.parent = this;
		this.refreshBox.id = this.refreshBox.className+windowCount;
		
		function Window_refreshBox_onmouseover() { this.className = "window_refreshbox_a"; };

		function Window_refreshBox_onmouseout() 
			{
				if (WindowManager.active == this.parent)
					this.className = "window_refreshbox";
				else
					this.className = "window_refreshbox_o";
			};		
		
		function Window_refreshBox_onmousedown(event)
			{ 
				var event = xpEvent(event, true);
				this.className = "window_refreshbox_d";
				this.parent.activate();
			};
		
		function Window_refreshBox_onmouseup(event)
		{
			var event = xpEvent(event, true);
			// WindowManager.hideWindow(this.parent);
			this.className = "window_refreshbox";
			var grid = (this.parent.contentArea.grid);
			grid.reload();
			return false;
		};
		
		// function Window_refreshBox_
		
		this.refreshBox.onmouseover = Window_refreshBox_onmouseover;
		
		this.refreshBox.onmouseout = Window_refreshBox_onmouseout;		

		this.refreshBox.onmousedown = Window_refreshBox_onmousedown;
		
		this.refreshBox.onmouseup = Window_refreshBox_onmouseup;
			
	}

	this.status.parent = this;
	
	this.addToolbar = Window_addToolbar;
	
	// close out the window
	this.close = Window_close;
	
	// open the window
	this.open = Window_open;
	
	// user-definable
	this.onsize = Window_empty;
	this.onsizestop = Window_empty;
	this.onclose = Window_empty;
	this.onopen = Window_empty;
	
	// added by Rudi
	// user-definable events for dragging
	this.ondragstart = Window_empty;
	this.ondragstop = Window_empty;
	
	// minimum window size
	this.minimumWidth = 150;
	this.minimumHeight = 125;
	
	return this;
}

function resizeDragStart(event)
{
	if (!WindowManager.active || WindowManager.active.dragging)
		return;
	
	WindowManager.active.resizing = true;
	
	var frame = getParentByClassName(this, "window");
	if (frame.parent.activate)
		frame.parent.activate();
	
	var x = 0;
	var y = 0;
		
	if (browser.ie) {
		document.onmousemove = resizeDragging;
		document.onmouseup   = resizeDragStop;
		
		if (document.documentElement && document.documentElement.scrollTop)	{
			addx = document.documentElement.scrollLeft;
			addy = document.documentElement.scrollTop;
		}
		else if (document.body) {
			addx = document.body.scrollLeft;
			addy = document.body.scrollTop;
		}
		
		x = window.event.clientX + addx;
		y = window.event.clientY + addy;
	} else {
		document.addEventListener("mousemove", resizeDragging, true);
    	document.addEventListener("mouseup",   resizeDragStop, true);
    	
 		x = event.pageX;
		y = event.pageY;
 	}

	var cname = this.className;
	var direction = cname.substring(cname.indexOf('_') +1, cname.lastIndexOf('_'));
	
 	// determine drag direction
   	WindowManager.active.north 	= direction.indexOf('t') != -1 ? true : false;
  	WindowManager.active.south 	= direction.indexOf('b') != -1 ? true : false;
 	WindowManager.active.east 	= direction.indexOf('r') != -1 ? true : false;
 	WindowManager.active.west 	= direction.indexOf('l') != -1 ? true : false;
 	
 	WindowManager.active.oldY = y;
 	WindowManager.active.oldCY = WindowManager.active.dom.offsetHeight;
 	WindowManager.active.oldX = x;
 	WindowManager.active.oldCX = WindowManager.active.dom.offsetWidth;
}

function resizeDragging(event)
{
	if (!WindowManager.active || !WindowManager.active.resizing)
		return;
	
	//assert("testA", WindowManager.active.north +","+WindowManager.active.south+","+WindowManager.active.east+","+WindowManager.active.west);
	
	var x = 0;
	var y = 0;
				
	if (browser.ie) {
	
		if (document.documentElement && document.documentElement.scrollTop)	{
			addx = document.documentElement.scrollLeft;
			addy = document.documentElement.scrollTop;
		}
		else if (document.body) {
			addx = document.body.scrollLeft;
			addy = document.body.scrollTop;
		}
		
		x = window.event.clientX + addx;
		y = window.event.clientY + addy;
		
		window.event.cancelBubble = true;
	    window.event.returnValue = false;
		
	} else {
		x = event.pageX;
		y = event.pageY;
		event.preventDefault();
	}
	
	var h = 0;
	var w = 0;
	
	if (WindowManager.active.north) {
		WindowManager.active.dom.style.top = y+"px";
		h = WindowManager.active.oldCY+WindowManager.active.oldY - y;		
	} else if (WindowManager.active.south) {
		h = y-WindowManager.active.dom.offsetTop;
	}
	
	if (WindowManager.active.east) {
		w = x-WindowManager.active.dom.offsetLeft;
	} else if (WindowManager.active.west) {
		WindowManager.active.dom.style.left = x+"px";
		w = WindowManager.active.oldCX+WindowManager.active.oldX - x;
	}
	
	WindowManager.active.size(w, h);
}

function resizeDragStop(event)
{
	if (!WindowManager.active || !WindowManager.active.resizing)
		return;

	WindowManager.active.onsizestop();
	WindowManager.active.resizing = false;

	if (browser.ie) {
		document.onmousemove = null;
 		document.onmouseup   = null;
 	} else {
		document.removeEventListener("mousemove", resizeDragging, true);
	    document.removeEventListener("mouseup",   resizeDragStop, true);
    }
}

/**
 * DataWindow
 *
 * @author	Jonathan Le
 *
 **/
 
 function DataWindow_empty() {};
 
 // function DataWindow_
 
function DataWindow(aTableId, aLocation, aField, aValue, qQueryId, aSync, selectOneRow)
{
	
	// for future reference
	this.aTableId = aTableId;
	this.aLocation = aLocation;
	this.aField = aField;
	this.aValue = aValue;
	this.qQueryId = qQueryId;
	this.initialized = false;
	
	// load data window asyncronosuly?
	
	if (aSync)
		this.aSync = aSync;
	else
		this.aSync = false;
	
	
//	this.table = structure.getTable(this.aTableId);
	this.table = getTable(this.aTableId);

	if (!this.table) {
		this.table = getTable (this.aTableId);
		if (!this.table) {
			return null;
		} else {
			this.aTableId = this.table.tableid;
		}
	} else {
		this.aTableId = this.table.tableid;
	}

	// this.bridgeTable = getTable (this.aTableId);
	
	this.selectOneRow = false;
	this.updatingTabsFieldId = null;
	
	if (selectOneRow)
		if (selectOneRow == true)
			this.selectOneRow = true;

		
	// inherit from Window
	Window.apply(this);

	if (connection.admin)
		this.savePrefsBox.style.display = 'block';
	
	this.tableId = this.aTableId;
	
	var aThis = this;
	
	this.onLoadSuccess = DataWindow_empty
	this.initializing = true;
	
	// will call the rest of the data window to create illusion of loading
	if (this.aSync)
		setTimeout(function() { DataWindowPartTwo(aThis); }, 1);
	else
		DataWindowPartTwo(aThis);		

}

function DataWindowPartTwo_createBtn_onclick() { create_record(this.prv.mDOM); };

function DataWindowPartTwo_deleteBtn_onclick() { delete_records(this.prv.mDOM); };

function DataWindowPartTwo_aThis_fetchData (fieldId, queryValue, queryId) {

	this.aComparison = null;
	if ((fieldId) && (queryValue)) {
		queryField = getField (this.aTableId, fieldId);
		if (queryField) {
			this.aComparison = "&fieldid=" + queryField.fieldid + "&comp=equal&value=" + encodeURIComponent(queryValue);
		}
	} else if (queryId) {
		this.aComparison = "&queryid=" + queryId;
	}

	// check if data window was loaded completely first 
	if (this.qQueryId == 'noload') {
		this.qQueryId = null;
		this.grid.populate({tableId : this.aTableId, comparison : this.aComparison });
	}
	
	this.grid.recreateSelection = true;
	this.grid.populate({tableId : this.aTableId, comparison : this.aComparison });

		
}

// function DataWindowPartTwo_

function DataWindowPartTwo (aThis) {
	
	// construct
	{
	
		// instead of closing the window, hide it on close
	//	if (aThis.hideOnClose) {
	
		// update window on close box method
		
		function DataWindow_toString()
			{
				return "[object DataGrid]";
			};	
			
		aThis.toString = DataWindow_toString;
		
		dax_bridge.cacheFields (getTable(aThis.aTableId));
		
		aThis.enableTabs = true;
		
		aThis.closeBox.onmouseup = function (aEvent) {
			clearTimeout(this.parent.grid.prv.mTimeoutId);
			WindowManager.hideWindow(this.parent);
			if (taskbar)
				this.parent.tbitem.dom.style.display = 'none';
			return false;
		}
		
	//	}
	
		// target location
		aThis.target = aThis.aLocation;
	
		// set the title
		var tablename = aThis.table.tablename;
		var tableRef = getTable(aThis.table.tableid);
		aThis.titleBar.innerHTML = tableRef.tablealias;		
		
		var toolbar = new Toolbar();
		aThis.mainToolbar = toolbar;
		
		// create the buttons we need
		var createBtn = toolbar.addButton(STR['button_create']);
		createBtn.onclick = DataWindowPartTwo_createBtn_onclick;
		
		// var refreshBtn = toolbar.addButton(STR['button_refresh']);
		// refreshBtn.onclick = function() { refresh_table(this.prv.mDOM); };
		
		var deleteBtn = toolbar.addButton(STR['button_delete']);
		deleteBtn.onclick = DataWindowPartTwo_deleteBtn_onclick;
		
		// add the toolbar to the window
		aThis.addToolbar(toolbar.prv.mDOM);
		
		// add the spinner
		var spinner = getTemplate("spinner").cloneNode(true);
		toolbar.addContent(spinner);
		setStyle(spinner, "display", "block");
		
		aThis.spinner = spinner;
		
		var search = getTemplate("searchwidget").cloneNode(true);
		generateUniqueId (search);
		search.inputBox = getElementByClassName (search, 'queryname');
		
		// for ie, manually set search function
		if (browser.ie7) {
			search.inputBox.fieldSelect = getElementByClassName (search, 'fieldSelect');

			function DataWindowPartTwo_inputBox_fieldSelect_onchange(e) {
				this.fieldid=this.options[this.selectedIndex].fieldid;			
			};

			function DataWindowPartTwo_search_inputBox_onkeyup(e) {
				inline_query(this, this.fieldSelect.fieldid, this.value, this.queryId, null, null, true);
			};

			// function DataWindowPartTwo_
			
			search.inputBox.fieldSelect.onchange = DataWindowPartTwo_inputBox_fieldSelect_onchange;

			search.inputBox.onkeyup = DataWindowPartTwo_search_inputBox_onkeyup;
		}
		
		aThis.search = search;
		search.owner = aThis;
		
		toolbar.addContent(search);
		setStyle(search, "display", "block");
		
		getElementByClassName (search, 'label').innerHTML = STR['search'];
		getElementByClassName (search, 'searchOptGroup').label = STR['fields'];
		
		var select = getElementByClassName(search, "fieldSelect");
		var queryname = getElementByClassName(search, "queryname");
		
		if (select) {
			var option = getElementByClassName(select, "fieldOption");
			var optgroup = option.parentNode;

			select.tableId = aThis.table.tableid;
			
			// build the select list in the toolbar
			for (var k in aThis.table.fields) {
				if (aThis.table.fields[k].fieldtype != 'picture') {
					if (k > 0)
						option = option.cloneNode(true);
					else
						select.fieldid = aThis.table.fields[k].fieldid;

					option.parent = select;
					option.innerHTML = aThis.table.fields[k].fieldalias;
					//option.value = table.fields[k].fieldid;
					option.fieldid = aThis.table.fields[k].fieldid;
					option.onclick =
						function() { select.fieldid = this.fieldid;};
					optgroup.appendChild(option);
				}
			}
		}
		
		var saveBtn = toolbar.addButton(STR['button_save']);
		saveBtn.owner = aThis;
		aThis.search.saveButton = saveBtn;
		
		getElementByClassName(search, 'queryname').boundTo = aThis;
		
		function DataWindowPartTwo_saveBtn_onclick() { 
			save_query(search, select.tableId, select.fieldid, queryname.value, this.owner.contentArea.grid.receivedQueryId); 
			getElementByClassName (this.owner.dom, 'queryname').queryId = this.owner.contentArea.grid.receivedQueryId;
			search.inputBox.value = '';
		};
		
		// function DataWindowPartTwo_
		saveBtn.onclick = DataWindowPartTwo_saveBtn_onclick;

		getElementByClassName (search, 'form').enterButton = saveBtn;		
		
		// add ddw button to the toolbar
		var eTable = getTable (aThis.aTableId);
		if ((eTable) && (eTable.ddwOptions) && (eTable.ddwOptions.length > 0)) {
			// add a ddw button
			var ddwOption = eTable.ddwOptions[0];
			
			var ddwButton = toolbar.addButton (ddwOption.title);
			ddwButton.url = ddwOption.url;
			ddwButton.title = ddwOption.title;
			ddwButton.owner = aThis;
			if (ddwOption.type.indexOf("Static") != -1) {

				function DataWindowPartTwo_ddwButton_onclick() {
					if (this.owner.search.inputBox.value)
						var queryId = this.owner.currentQueryId;
					else if ((this.owner.currentTab) && (this.owner.currentTab.queryId)) 
						var queryId = this.owner.currentTab.queryId;
					else
						var queryId = this.owner.contentArea.grid.selection.queryId;
					var tableId = this.owner.contentArea.grid.selection.tableId;
					var selectedRecords = new Array();
					if (this.owner.grid.selection.selected) {
						for (z in this.owner.grid.selection.selected) {
							if (this.owner.grid.selection.selected[z]) {
								selectedRecords.push(z);
							}
						}
					}
					new DDW(this.url, 'static_url', this.title, '&queryid=' + queryId + "&tableid=" + tableId, selectedRecords);
				};
				
				// function DataWindowPartTwo_
				
				ddwButton.onclick = DataWindowPartTwo_ddwButton_onclick;
				
			} else if (ddwOption.type.indexOf("Dynamic") != -1) {
				ddwButton.onclick = function () {
					if (this.owner.search.inputBox.value)
						var queryId = this.owner.currentQueryId;
					else if ((this.owner.currentTab) && (this.owner.currentTab.queryId)) 
						var queryId = this.owner.currentTab.queryId;
					else
						var queryId = this.owner.contentArea.grid.selection.queryId;
					var tableId = this.owner.contentArea.grid.selection.tableId;
					var selectedRecords = new Array();
					if (this.owner.grid.selection.selected) {
						for (z in this.owner.grid.selection.selected) {
							if (this.owner.grid.selection.selected[z]) {
								selectedRecords.push(z);
							}
						}
					}
					new DDW(this.url, 'dynamic_url', this.title, '&queryid=' + queryId + "&tableid=" + tableId, selectedRecords);	
				};
			} else if (ddwOption.type.indexOf("Message") != -1) {
				ddwButton.onclick = function () {
					if (this.owner.search.inputBox.value)
						var queryId = this.owner.currentQueryId;
					else if ((this.owner.currentTab) && (this.owner.currentTab.queryId)) 
						var queryId = this.owner.currentTab.queryId;
					else
						var queryId = this.owner.contentArea.grid.selection.queryId;
					var tableId = this.owner.contentArea.grid.selection.tableId;
					var selectedRecords = new Array();
					if (this.owner.grid.selection.selected) {
						for (z in this.owner.grid.selection.selected) {
							if (this.owner.grid.selection.selected[z]) {
								selectedRecords.push(z);
							}
						}
					}
					new DDW(this.url, 'message_window', this.owner, '&queryid=' + queryId + "&tableid=" + tableId, selectedRecords);	
				};
			}
		}
		
		// add the status bar
		var status = getTemplate("statusbar", "dax").cloneNode(true); 
		probe(status);
		
		status.id = "statusbar"+WindowManager.windows.length + 1;
		//status.style.display = 'none';
		//setStyle(status, "display", "block");
		// hide status section for now
		setStyle(status, "display", "none");
		setStyle(aThis.status, "height", "19px");
		

		status.parent = aThis;
		aThis.status.appendChild(status);

		aThis.open();
	
		// fix toolbar overflow
		setStyle (toolbar.prv.mDOM, 'overflow', 'hidden');
		aThis.resizeToolbar(false);
		// set toolbar size
		if (toolbar)
			if (aThis.offsetWidth < 800)
				setStyle (toolbar.prv.mDOM, 'width', '600px');
			else
				setStyle (toolbar.prv.mDOM, 'width', aThis.offsetWidth + 'px');

		if (browser.safari)
			setStyle (toolbar.prv.mDOM, 'width', '1000px');
		
				
		// reference ourselves
		var winObj = aThis;
		aThis.winObj = winObj;

		// overwrite the window object's events

		function DataWindowPartTwo_aThis_winObj_onopen() {
			try {
				// add an item to the taskbar
				if (taskbar) {
					var ti = new taskbarItem(taskbar);
					ti.setLabel(this.titleBar.innerHTML);
					ti.setIcon("datawindow");
					setStyle (ti.dom, 'display', 'block');
					// create a handler for clicking
					var winRef = this;
					ti.dom.onclick = function() { 
						this.parent.setSelected (true, true);
						winRef.activate(); 
					};

					ti.setSelected (true, true);
					ti.parent.refresh();
					
					// handler for close button
					// ticlose = getElementByClassName (ti.dom, 'dax_taskbar_close', true);
					// ticlose.onclick = function () {WindowManager.destroyWindow(winRef); };
					
					this.tbitem = ti;
				}
			} catch(e) {
			}
		};

		function DataWindowPartTwo_tab_onswitch()
		{
			if (this.owner.grid.selection)
				this.owner.grid.selection.selected = new Array();
			this.owner.currentTab = this;
			inline_query(search, -1, '*', this.queryId);
			this.owner.search.inputBox.value = '';
			getElementByClassName (this.owner.dom, 'queryname').queryId = this.queryId;
		};
		
		// function DataWindowPartTwo_

		aThis.fetchData = DataWindowPartTwo_aThis_fetchData;
		
		aThis.winObj.onopen = DataWindowPartTwo_aThis_winObj_onopen;
		
		aThis.winObj.onopen();
		
		// the first Tab is all records
		var tabs = new Tabs();
		
		// show first tab if there are no custom queries
		if ((aThis.table.showallrecordstab.toLowerCase() == 'true') || ((aThis.table.preselectQueries.length == 0) && (aThis.table.preselectedDynamicQueries.length == 0))) {
		
			var tab = tabs.insert(STR['all']+ " " +winObj.titleBar.innerHTML);
			tab.owner = aThis;
			tabs.dom.className = "tabs_tb";
			tab.firstTab = true;
			tab.queryId = null;
			tab.queryName = null;

			tab.onswitch = DataWindowPartTwo_tab_onswitch;
			
			tab.tooltip = '';

			// query properties
			// tab keeps 'permanent' query id 
			aThis.currentTab = tab;
		
		}

		// this is current unsaved query id
		aThis.currentQueryId = null;
		
		
		// add preselect query tabs
		for (var tCount = 0; tCount < aThis.table.preselectQueries.length; tCount++) {
			var tab = tabs.insert(aThis.table.preselectQueries[tCount].name);
			tab.owner = aThis;
			tabs.dom.className = "tabs_tb";
			tab.firstTab = false;
			tab.queryId = null;
			tab.queryName = aThis.table.preselectQueries[tCount].name;

			tab.onswitch = function()
			{
				// do an inline query
				if (this.owner.grid.selection)				
					this.owner.grid.selection.selected = new Array();
				this.owner.currentTab = this;
				if ((!this.queryId) && (this.queryName)) {
					inline_query(select, null, '*', null, this.queryName);
				} else {
					inline_query(select, null, '*', this.queryId, null);
					getElementByClassName (this.owner.dom, 'queryname').queryId = this.queryId;
				}
				this.owner.search.inputBox.value = '';
			}
			
			tab.tooltip = '';	

			if (!aThis.currentTab) {
				aThis.currentTab = tab;
			}
		}


		
		// set first tab active
		tabs.activateById(0);
		
		/*
		
		tab.userMouseOver = function (aEvent) {
			//this.className = 'dax_sidebar_button ' + this.defaultClass + '_o';
			if (this.tooltip) {
				objectPos = getObjectPosition (this.r);
				showTooltip(this.tooltip, objectPos.x, objectPos.y + this.r.offsetHeight);
			}
		}
		
		
		tab.userMouseOut = function (aEvent) {
			//this.className = 'dax_sidebar_button ' + this.defaultClass;
			if (this.tooltip)
				hideTooltip();
		}

		*/		
		
		// set close tab button visible
		// getElementByClassName (tabs.dom, 'tab_close', true).style.display = 'block';
		
		winObj.addToolbar(tabs.dom);
		if (browser.safari) {
			//tabs.dom.style.width = '100%';
			tabs.dom.parentNode.style.width = '100%';
		}
		
		//winObj.resize();
		
		aThis.tabsbar = tabs;
		
		// custom query on load
		aThis.aComparison = null;
		if ((aThis.aField) && (aThis.aValue)) {
			queryField = getField (aThis.aTableId, aThis.aField);
			if (queryField) {
				aThis.aComparison = "&fieldid=" + queryField.fieldid + "&comp=equal&value=" + aThis.aValue;
			}
		} else if (aThis.qQueryId) {
			aThis.aComparison = "&queryid=" + aThis.qQueryId;
		}

		// fixed drawing bug
		aThis.resize(null, null, true);

		/*
		// add spinner in the content area
		var newSpinner = getTemplate('window_preload').cloneNode(true);
		newSpinner.style.display = 'block';
		aThis.winObj.contentArea.appendChild (newSpinner);		
		newSpinner = null;
		*/
		
		// will call the rest of the data window to create illusion of loading
		if (aThis.aSync)
			setTimeout(function() { DataWindowPartThree(aThis); }, 1);
		else
			DataWindowPartThree(aThis);			
	}
}
	
function DataWindowPartThree(aThis)
{
	{		
		// load the grid and queue the first autoreload
		//var grid = do_AR(aThis.winObj.contentArea, aThis.aTableId, aThis.aComparison);
		// update tabs with dynamic values
		function DataWindowPartThree_updateDynamicQueryTabs()
		{
			if (this.table) {
				if (this.table.preselectedDynamicQueries) {
					if (this.table.preselectedDynamicQueries.length > 0) {
						for (var qCount = 0; qCount < this.table.preselectedDynamicQueries.length; qCount++) {
							// check for valid string
							if (this.table.preselectedDynamicQueries[qCount].fieldId.indexOf('][') != -1) {
								// generate a call to backend to get the list of unique values
								var url = dax_bridge.url + "GetUniqueQueries?sessionId=" + dax_bridge.sessionId + "&tableid=" + this.table.tableid +
									"&fieldid=" + this.table.preselectedDynamicQueries[qCount].fieldId;
								makeCall (url, this.updateDynamicQueryTabs_handler, this);
							}
						}
					}
				}
			}
		}
		
		function DataWindowPartThree_updateDynamicQueryTabs_handler(http_result, aRef)
		{
		
			if (http_result.readyState != 4)
				return;

			var responseError = checkResponse (http_result);
				
			if (responseError)	
				return;
			
			var queryNode = http_result.responseXML.getElementsByTagName("queries").item(0);
			var queryNames = queryNode ? queryNode.getElementsByTagName("query") : null;		
			var fieldId = queryNode.getAttribute("fieldid");

			if (!queryNames)
				return;
			
			if (queryNames.length == 0)
				return;

			if (aRef.updatingTabsFieldId) {
				if (aRef.updatingTabsFieldId == fieldId) {
					return;
				} else {
					setTimeout(function() {DataWindowPartThree_updateDynamicQueryTabs_handler(http_result, aRef) }, 1000);
					return;
				}
			} else {
				aRef.updatingTabsFieldId = fieldId;
			}				
				
			for (var tabCount = 0; tabCount < aRef.tabsbar.tabs.length; tabCount++) {
				// mark all tabs as removable until proven otherwise later
				aRef.tabsbar.tabs[tabCount].keepTab = false;
			}
				
			for (qnCount = 0; qnCount < queryNames.length; qnCount++) {	
				var queryName = queryNames.item(qnCount).getAttribute('name');
				if (queryName) {
					if (queryName != '4daf_unique_') {
						var tabExists = false;
						// check if the tab exists before adding it
						for (var tabCount = 0; tabCount < aRef.tabsbar.tabs.length; tabCount++) {
							if (aRef.tabsbar.tabs[tabCount].queryName == queryName) {
								var tabExists = true;
								// so we won't erase it later when purging the non-existent tabs
								aRef.tabsbar.tabs[tabCount].keepTab = true;
							}						
						}

						if (!tabExists) {
							// add tab
							var tabs = aRef.tabsbar;
							var tab = tabs.insert(queryName.substr(12));
							tab.owner = aThis;
							tabs.dom.className = "tabs_tb";
							tab.firstTab = false;
							tab.queryId = null;
							tab.queryName = queryName;
							tab.keepTab = true;
							// so we won't mess with the tabs that deal with other id's
							tab.fieldId = fieldId;

							tab.onswitch = function()
							{
								if (this.owner.grid.selection)								
									this.owner.grid.selection.selected = new Array();
								// do an inline query
								this.owner.currentTab = this;
								if ((!this.queryId) && (this.queryName)) {
									inline_query(null, null, '*', null, this.queryName, this.owner);
								} else {
									inline_query(null, null, '*', this.queryId, null, this.owner);
									getElementByClassName (this.owner.dom, 'queryname').queryId = this.queryId;
								}
								this.owner.search.inputBox.value = '';
							}
							
							tab.tooltip = '';
						}
					}
				}
			}
			// erase tabs
			var eraseTabsArray = new Array();
			for (var tabCount = 0; tabCount < aRef.tabsbar.tabs.length; tabCount++) {
				if (!aRef.tabsbar.tabs[tabCount].firstTab) {
					if ((!aRef.tabsbar.tabs[tabCount].keepTab) && (aRef.tabsbar.tabs[tabCount].queryName)) {
						if ((aRef.tabsbar.tabs[tabCount].queryName.indexOf('4daf_unique_') != -1) && (aRef.tabsbar.tabs[tabCount].fieldId == fieldId))
							eraseTabsArray.push(aRef.tabsbar.tabs[tabCount]);
					}
				}
			}
			if (eraseTabsArray) {
				if (eraseTabsArray.length > 0) {
					for (var tabCount = 0; tabCount < eraseTabsArray.length; tabCount++) {
						var clearCurrentTab = false;
						// remove current tab manually from data window
						if (aRef.currentTab = eraseTabsArray[tabCount])
							clearCurrentTab = true;
						// remove tab
						aRef.tabsbar.remove(eraseTabsArray[tabCount].index);
						if (clearCurrentTab)
							aRef.currentTab = null;
					}
				}			
			}

			// if object is in init state, open first dynamic tab
			if (aRef.initialize == true) {
				aRef.initialize = false;
				if (aRef.tabsbar.tab[0])
					aRef.tabsbar.tab[0].dom.onclick();
			}
			
			// current tab still exists, reselect it
			if (aRef.currentTab) {
				aRef.tabsbar.activate(aRef.currentTab);
			} else {
				aRef.currentTab = aRef.tabsbar.tabs[0];
				aRef.currentTab.dom.onclick();
			}

			
			// release lock
			aRef.updatingTabsFieldId = null;
			aRef.tabsbar.refresh();
			if (!aRef.initialized) {
				aRef.winObj.resize(1,1);
				aRef.winObj.initialized = true;
			
			}
		}
		
		function DataWindowPartThree_refreshDynamicTabs()
		{
			if (this.dynamicTabId) {
				clearTimeout(this.dynamicTabId);
			}

			this.updateDynamicQueryTabs();
			
			var thisWindow = this;
						
			this.dynamicTabId = setTimeout(function() { thisWindow.refreshDynamicTabs(); }, 60 * 3 * 1000);

		}

		aThis.updateDynamicQueryTabs = DataWindowPartThree_updateDynamicQueryTabs;
		
		aThis.updateDynamicQueryTabs_handler = DataWindowPartThree_updateDynamicQueryTabs_handler;
		
		aThis.refreshDynamicTabs = DataWindowPartThree_refreshDynamicTabs;

		if (aThis.qQueryId == 'noload'){
			aThis.winObj.preloaded = true;
			var grid = new GridObject(aThis.winObj.contentArea);
			
			aThis.winObj.contentArea.grid = grid;
		
			aThis.grid = grid;
			grid.owner = aThis;
		} else {
			var grid = do_AR(aThis.winObj.contentArea, aThis.aTableId, aThis.aComparison, aThis);
			aThis.grid = grid;
			grid.owner = aThis;	
			var auto = grid.prv.mAutoReload;
			if (auto > 0) {
				grid.prv.mTimeoutId = setTimeout(function() { grid.reload(); }, auto * 3000);
			}
		}
		
		function DataWindowPartThree_aThis_grid_onAfterRefresh() {

			if (this.grid.header.offsetWidth)
				this.grid.dom.style.width = this.grid.header.offsetWidth + 'px';
		
		};
		
		function DataWindowPartThree_grid_onbeforeload()
		{
			setStyle(this.spinner, "visibility", "visible");
		};

		function DataWindowPartThree_grid_onafterload()
		{
			setStyle(this.spinner, "visibility", "hidden");
			var g_ref = this;
			
			// calculate the pagecount
			this.prv.mPageCount = Math.ceil(this.selection.total /this.selection.range.length);
			
			this.refresh();
		
			// do it again if it is a first load
			if (this.firstLaunch) {
				this.refresh();
				this.firstLaunch = false;
			}
		
			/*
		
			// set the page total
			if(this.prv.mPageCount > 0){
				status.pagecont.inputcont.inputs.pagetotal.value = this.prv.mPageCount;
				status.pagecont.inputcont.inputs.pagenum.value = this.prv.mCurrentPage;	
			}
			else{
				status.pagecont.inputcont.inputs.pagetotal.value = 0;
				status.pagecont.inputcont.inputs.pagetotal.disabled = true;
				status.pagecont.inputcont.inputs.pagenum.value = 0;	
				status.pagecont.inputcont.inputs.pagenum.disabled = true;
			}
			
			// define the status bar actions
			status.buttons.statusButtonFirst.onclick = function(aEvent)
			{
				g_ref.goToPage(1);
			};
			status.buttons.statusButtonLast.onclick = function(aEvent)
			{
				g_ref.goToPage(g_ref.prv.mPageCount);
			};
			status.buttons.statusButtonPrev.onclick = function(aEvent)
			{
				g_ref.previousPage();
			};
			status.buttons.statusButtonNext.onclick = function(aEvent)
			{
				g_ref.nextPage();
			};
			status.pagecont.statusButtonGo.onclick = function(aEvent)
			{
				var status = getParentByClassName(this, "statusbar");
				g_ref.goToPage(parseInt(status.pagecont.inputcont.inputs.pagenum.value));
			};
			
			*/
			
			// assign new query id to the window
			if (this.owner.enableTabs) {
				if (this.owner.currentTab)
					if (!this.owner.currentTab.firstTab) {
						if (this.owner.currentTab.queryId)
							this.selection.queryId = this.owner.currentTab.queryId;
					} else {
						if (!this.owner.currentTab.queryId) {
							this.owner.currentTab.queryId = this.selection.queryId;
						} else {
							this.selection.queryId = this.owner.currentTab.queryId;
						}
					}
			}
			this.owner.currentQueryId = this.currentQueryId;	

			// place editor, ie7 bug fix
			if (browser.ie7)
				if ((this.owner) && (this.owner.editor) && (this.owner.editor.prv.mTearAway) ) {
					//setStyle(this.owner.editor.prv.mTearAway.dom, "display", "block");
					setStyle(this.owner.editor.prv.mTearAway.dom, "top", "29px");
					setStyle(this.owner.editor.prv.mTearAway.dom, "position", "absolute");
					//debugAlert ('top position:' + this.owner.editor.prv.mTearAway.dom.style.top);
				}
				
				if ((browser.safari) && (this.owner.target)) {
					
						this.owner.contentArea.style.width = aThis.target.offsetWidth + 'px';
						this.owner.contentArea.style.height = aThis.target.offsetHeight + 'px';				

				}		
				
		};

		function DataWindowPartThree_grid_grid_onrowdblclick(aRow)
		{
			
			var go = this.owner;
	
			/*
			
			if (rudiDebug) {
				var winObj = aThis.winObj;
				winObj.getCustomEditor();
				setStyle(winObj.editor.dom, "display", "block");
				var editor = winObj.editor;
				return;
			}
					
			*/
					
			if( aRow.recordId != -1 ){ //make sure to edit a valid record on the grid
				// for a grid with a selection
				if (go && go.selection) {
					// was already opened once
					var winObj = aThis.winObj;
					if (isDefined(winObj.editor) && isDefined(winObj.editor.record)) {
						winObj.editor.edit();
					} else {
						winObj.getEditor();
						setStyle(winObj.editor.getDOM(), "display", "block");
						var editor = winObj.editor;
						var auto = editor.prv.mAutoReload;
						if (auto > 0) {
							this.prv.mTimeoutId = setTimeout(function() { editor.reload(); }, auto * 3000);
						}
					}
					winObj.editor.pull(go.selection.tableId, aRow.recordId);
				}
			}
		};

		function DataWindowPartThree_aThis_winObj_onclose() {
			if (this.tbitem)
				this.tbitem.remove();

			// remove query	
			if (this.contentArea.grid.selection)
				if (this.contentArea.grid.selection.queryId)
					clearQuery (this.contentArea.grid.selection.queryId, false);

			// get rid of the grid
			if (this.contentArea.grid) {
				this.contentArea.grid.destroy();
				if (this.contentArea.grid) {
					this.contentArea.grid = null;
				}
			}
			
			if (this.editor)
				this.editor.destroy();			
			
			this.destroy();
				
			// delete this;			
		};

		function DataWindowPartThree_aThis_winObj_onsize() {
			this.contentArea.grid.refresh();
			if (this.mainToolbar)
				if (this.contentArea.offsetWidth < 800)
					setStyle (this.mainToolbar.prv.mDOM, 'width', '800px');
				else
					setStyle (this.mainToolbar.prv.mDOM, 'width', this.contentArea.offsetWidth + 'px');	
			};

		function DataWindowPartThree_aThis_winObj_onsizestop() {
			var sb = this.contentArea.grid.viewport.vscrollbar;
			//if (sb.visible) {
				this.contentArea.grid.viewport.onvscrollstop(sb.last);
				this.grid.refresh();
				this.tabsbar.refresh();
			//}
		};

		function DataWindowPartThree_aThis_winObj_getEditor()
		{
			if (this.editor)
				return this.editor;
		
			this.editor = new Editor();
			var dom = this.editor.getDOM();
			this.dom.style.zIndex = ++WindowManager.maxZIndex;
		//	alert('Editor = ' + this.dom.style.zIndex);
			this.dom.m.insertBefore(dom, this.toolbar);
		
			var w_off =  (this.dom.offsetWidth / 2) -
				(dom.offsetWidth / 2);
		
			setStyle(dom, "position", "absolute");
			setStyle(dom, "left", w_off + "px");
			
			this.editor.owner = this;
			
			var w_ref = this; // use this for when editor is detatched

			function DataWindowPartThree_aThis_winObj_getEditor_editor_onaftersave()
			{
				w_ref.contentArea.grid.reload();
			};

			function DataWindowPartThree_aThis_winObj_getEditor_editor_onafterrefresh()
			{
				//setStyle(this.owner.editor.prv.mTearAway.dom, "display", "block");
				if ((this.owner) && (this.owner.editor)) {
					setStyle(this.prv.mTearAway.dom, "top", "29px");
					setStyle(this.prv.mTearAway.dom, "position", "absolute");
				}
			};			

			function DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop(aEvent)
			{
				this.className = "tearaway_torn";
				var editor = this.owner;
				
				if (editor.owner) {
					var winObj = editor.owner;
					if (!winObj.editor)
						return;
					var dom = winObj.editor.prv.mDOM;
					var pos = getObjectPosition(this); // global coordinates

					var ti = new taskbarItem(taskbar);

					// make unique label based on table name
					i = 1;
					while ($('dax_taskbar_button' + winObj.titleBar.innerHTML + i) != null) {
						i++;
					}
					
					if (ti.dom) {
						ti.dom.id = 'dax_taskbar_button' + winObj.titleBar.innerHTML + i;

						ti.setLabel(STR['taskbar_edit'] + " " + winObj.titleBar.innerHTML + " " + i);
						ti.setIcon("editor");
						
						editor.tbitem = ti;
				
					}
				
					// create a handler for clicking
					var ref = this;
					
					function DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_ti_dom_onclick() { 
						this.parent.setSelected (true, true);
						ref.onclick();
					};
					
					function DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_dom_cancelBtn_onclick(aEvent) {
						if (ti.dom)
							ti.remove(); // remove taskbar item
						document.body.removeChild(this.parent.getDOM());
						this.parent.tbitem = null;	
						this.parent.destroy();
						if (!browser.ie)
							delete this.parent;
					};
					
					function DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_onclick(aEvent) {
						if (WindowManager.active)
							WindowManager.active.deactivate();
							setStyle(this, "zIndex", ++WindowManager.maxZIndex);
							if ((ti) && (ti.dom)) {
								ti.setSelected(true,true);
							}
					};
	
					// function DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_
					
					if (ti.dom) {
					
						ti.dom.onclick = DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_ti_dom_onclick;
						
						setStyle (ti.dom, 'display', 'block');
						ti.setSelected (true, true);
						
						ti.parent.refresh();
						
					}
					
					// handler for closing
					// ticlose = getElementByClassName (ti.dom, 'dax_taskbar_close', true);
					// ticlose.cancelBtnRef = dom.cancelBtn;
					// ticlose.onclick = function () {this.cancelBtnRef.onclick(null); };
					
					
					// override cancel button
					dom.cancelBtn.onclick = DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_dom_cancelBtn_onclick;
					
					// override the focusing
					this.onclick = DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_onclick;
	
					// release
					winObj.deactivate();
					winObj.editor = null;
					this.parent.owner = null;
					
					// reposition
					document.body.insertBefore(this, null);
					setStyle(this, "left", pos.x + "px");
					setStyle(this, "top", pos.y + "px");
				}
			};
			
			// function DataWindowPartThree_aThis_winObj_getEditor_
			
			this.editor.onaftersave = DataWindowPartThree_aThis_winObj_getEditor_editor_onaftersave;

			// place editor, ie7 bug fix
			if (browser.ie7) {
				this.editor.onafterrefresh = DataWindowPartThree_aThis_winObj_getEditor_editor_onafterrefresh;
			}
			
			// customize

			dom.ondragstop = DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop;
			return this.editor;
		};

		function DataWindowPartThree_aThis_winObj_getCustomEditor()
		{
			if (this.editor)
				return this.editor;
		
			this.editor = new CustomEditor();
			var dom = this.editor.dom;
			this.dom.style.zIndex = ++WindowManager.maxZIndex;
		//	alert('Editor = ' + this.dom.style.zIndex);
			this.dom.m.insertBefore(dom, this.toolbar);
		
			var w_off =  (this.dom.offsetWidth / 2) -
				(dom.offsetWidth / 2);
		
			setStyle(dom, "position", "absolute");
			setStyle(dom, "left", w_off + "px");
			
			this.editor.owner = this;
			
			var w_ref = this; // use this for when editor is detatched
			
			this.editor.tearaway.expand();
			this.editor.construct();

			function DataWindowPartThree_aThis_winObj_getEditor_editor_onaftersave()
			{
				w_ref.contentArea.grid.reload();
			};

			function DataWindowPartThree_aThis_winObj_getEditor_editor_onafterrefresh()
			{
				//setStyle(this.owner.editor.prv.mTearAway.dom, "display", "block");
				if ((this.owner) && (this.owner.editor)) {
					setStyle(this.prv.mTearAway.dom, "top", "29px");
					setStyle(this.prv.mTearAway.dom, "position", "absolute");
				}
			};			

			function DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop(aEvent)
			{
				this.className = "tearaway_torn";
				var editor = this.owner;
				
				if (editor.owner) {
					var winObj = editor.owner;
					if (!winObj.editor)
						return;
					var dom = winObj.editor.getDOM();
					var pos = getObjectPosition(this); // global coordinates

					var ti = new taskbarItem(taskbar);

					// make unique label based on table name
					i = 1;
					while ($('dax_taskbar_button' + winObj.titleBar.innerHTML + i) != null) {
						i++;
					}
					
					ti.dom.id = 'dax_taskbar_button' + winObj.titleBar.innerHTML + i;

					ti.setLabel(STR['taskbar_edit'] + " " + winObj.titleBar.innerHTML + " " + i);
					ti.setIcon("editor");
					
					editor.tbitem = ti;
				
					// create a handler for clicking
					var ref = this;
					
					function DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_ti_dom_onclick() { 
						this.parent.setSelected (true, true);
						ref.onclick();
					};
					
					function DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_dom_cancelBtn_onclick(aEvent) {
						ti.remove(); // remove taskbar item
						document.body.removeChild(this.parent.getDOM());
						this.parent.tbitem = null;	
						this.parent.destroy();
						if (!browser.ie)
							delete this.parent;
					};
					
					function DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_onclick(aEvent) {
						if (WindowManager.active)
							WindowManager.active.deactivate();
							setStyle(this, "zIndex", ++WindowManager.maxZIndex);
							if (ti) {
								ti.setSelected(true,true);
							}
					};
	
					// function DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_
					
					ti.dom.onclick = DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_ti_dom_onclick;
					
					setStyle (ti.dom, 'display', 'block');
					ti.setSelected (true, true);
					
					ti.parent.refresh();
					
					// handler for closing
					// ticlose = getElementByClassName (ti.dom, 'dax_taskbar_close', true);
					// ticlose.cancelBtnRef = dom.cancelBtn;
					// ticlose.onclick = function () {this.cancelBtnRef.onclick(null); };
					
					
					// override cancel button
					dom.cancelBtn.onclick = DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_dom_cancelBtn_onclick;
					
					// override the focusing
					this.onclick = DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_onclick;
	
					// release
					winObj.deactivate();
					winObj.editor = null;
					this.parent.owner = null;
					
					// reposition
					document.body.insertBefore(this, null);
					setStyle(this, "left", pos.x + "px");
					setStyle(this, "top", pos.y + "px");
				}
			};
			
			// function DataWindowPartThree_aThis_winObj_getEditor_
			
			this.editor.onaftersave = DataWindowPartThree_aThis_winObj_getEditor_editor_onaftersave;

			// place editor, ie7 bug fix
			if (browser.ie7) {
				this.editor.onafterrefresh = DataWindowPartThree_aThis_winObj_getEditor_editor_onafterrefresh;
			}
			
			// customize

			dom.ondragstop = DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop;
			return this.editor;
		};

		
		function DataWindowPartThree_aThis_customize(aToolbar, aTaskbar, aStatusbar, aEditor) {
			if (!aToolbar)
				this.toolbar.style.display = 'none';
			else
				this.toolbar.style.display = 'block';

			if (!aTaskbar) {
				this.tabsbar.dom.parentNode.style.display = 'none';
				this.enableTabs = false;
			} else {
				this.tabsbar.dom.parentNode.style.display = 'block';
				this.enableTabs = true;
			}
			
			if (!aStatusbar)
				this.status.style.display = 'none';
			else
				this.status.style.display = 'block';

				
			function DataWindowPartThree_aThis_customize_empty(){};
			
			function DataWindowPartThree_aThis_customize_grid_grid_onrowdblclick(aRow)
			{
				
				var go = this.owner;
				
				if( aRow.recordId != -1 ){ //make sure to edit a valid record on the grid
					// for a grid with a selection
					if (go && go.selection) {
					
						winObj = this.owner.owner;
					
						// was already opened once
						if (isDefined(winObj.editor) && isDefined(winObj.editor.record)) {
							winObj.editor.edit();
						} else {
							winObj.getEditor();
							setStyle(winObj.editor.getDOM(), "display", "block");
							var editor = winObj.editor;
							var auto = editor.prv.mAutoReload;
							if (auto > 0) {
								this.prv.mTimeoutId = setTimeout(function() { editor.reload(); }, auto * 3000);
							}
						}
						winObj.editor.pull(go.selection.tableId, aRow.recordId);
					}
				}
			};			

			// function DataWindowPartThree_aThis_customize_
				
			if (!aEditor) {
				this.grid.grid.onrowdblclick = DataWindowPartThree_aThis_customize_empty;
			} else {
					// override the grid's double click
				this.grid.grid.onrowdblclick = DataWindowPartThree_aThis_customize_grid_grid_onrowdblclick;
			}			
				
			this.resize(null, null, true);
		};
		
		function DataWindowPartThree_hideColumns(colArray)
		{
			this.grid.hideColumnsArray = colArray.slice();
		
		}

		function DataWindowPartThree_showColumns(colArray)
		{
			this.grid.showColumnsArray = colArray.slice();
		
		}
		
		// function DataWindowPartThree_
		
		aThis.hideColumns = DataWindowPartThree_hideColumns;
		aThis.showColumns = DataWindowPartThree_showColumns;
		
		aThis.grid.onAfterRefresh = DataWindowPartThree_aThis_grid_onAfterRefresh;
	
		// override any GridObject events we need
		grid.onbeforeload = DataWindowPartThree_grid_onbeforeload;
		
		grid.onafterload = DataWindowPartThree_grid_onafterload;
		
		// override the grid's double click
		grid.grid.onrowdblclick = DataWindowPartThree_grid_grid_onrowdblclick;
		
	
		/*
	
		// override grid sort
		this.sort = function(aFieldId, aIsAscending)
		{
			var direction = aIsAscending ? "asc" : "desc";
			var url = connection.command(DB.SORT) + "&tableid="+this.selection.tableId+
				"&fieldid="+aFieldId+"&direction="+direction+"&queryid="+
				this.selection.queryId;

			
			var http_request = getXMLHttpRequest();
			if (http_request) {
				var this_ref = this;
				
				debugAlert('<b>Grid:</b>'+'<a href="'+url+'" target="_blank">'+url+'</a>');
				
				http_request.onreadystatechange = function() {this_ref.onsort(http_request);};
				http_request.open("GET", url, true);
		  	  	http_request.send(null);
		  	  				
		  	  	this.onbeforeload();
			}
			
		};		
	
		*/
		
		aThis.winObj.onclose = DataWindowPartThree_aThis_winObj_onclose;
		
		// propagate the window event
		aThis.winObj.onsize = DataWindowPartThree_aThis_winObj_onsize;
		
		aThis.winObj.onsizestop = DataWindowPartThree_aThis_winObj_onsizestop;

		// set minimum sizes
		//winObj.size (425, 175);
		aThis.winObj.minimumWidth = 425;
		aThis.winObj.minimumHeight = 175;
		
		// let's write a function dynamically
		aThis.winObj.getEditor = DataWindowPartThree_aThis_winObj_getEditor;
		aThis.winObj.getCustomEditor = DataWindowPartThree_aThis_winObj_getCustomEditor;

		// if location exists, insert the data window into the target element
		if (aThis.target) {
			var targetPosition = getObjectPosition (aThis.target);
			// position the window where target element is
			aThis.winObj.dom.style.top = targetPosition.y + 'px';
			aThis.winObj.dom.style.left = targetPosition.x + 'px';
			aThis.winObj.size (aThis.target.offsetWidth, aThis.target.offsetHeight, true);
			// hide window based doms
			aThis.winObj.dom.top.style.display = 'none';
			aThis.winObj.dom.btm.style.display = 'none';
			aThis.winObj.dom.l.style.display = 'none';
			aThis.winObj.dom.r.style.display = 'none';
		}
		
		// IE7 modification
		if (browser.ie7) {
			// so that viewport contents won't overspill
			grid.viewport.dom.style.position = 'absolute';
		}

		// customize appearance of the window by hiding or showing the elements
		aThis.customize = DataWindowPartThree_aThis_customize;
		
		aThis.tabsbar.refresh();
		aThis.onLoadSuccess();
		
	}
};
// DataWindow.prototype = new Window(); // 12/12 JF. Causing problems in DDW on IE

/**
 * Shapable		an object that can be made to expand or contract
 *
 * @author	Jonathan Le
 */
function Shapable(aDOM)
{
	this.dom = aDOM;
	this.height = 0;
	this.width = 0;
	
	this.contract = function(aInterval, aDecrement, aMinimum)
	{
		if (browser.ie) {
			setStyle(this.dom, "display", "none");
			return;
		}
		
		if (!this.height) {
			this.height = xpGetSize(this.dom).height;
		}

		// no scrollbars
		setStyle(this.dom, "overflow", "hidden");
	
		var ref = this;
		var aDecrement = Math.min(aDecrement, this.dom.clientHeight);
		var aMinimum = isDefined(aMinimum) ? aMinimum : 0;
	
		if (this.dom.clientHeight > 0) {
			setStyle(this.dom, "height", (this.dom.clientHeight) - aDecrement + "px");
			setTimeout(function() { ref.contract(aInterval, aDecrement); }, aInterval);
		} else {
			setStyle(this.dom, "display", "none");
		}
	};
	
	this.expand = function(aInterval, aIncrement)
	{
		if (!isDefined(this.height))
			return;
		
		// because editor appears at the wrong location
		if (browser.ie) {
			setStyle(this.dom, "display", "block");
			setStyle(this.dom, "top", "29px");
			return;
		}
	
		// return style to block
		setStyle(this.dom, "display", "");
		setStyle(this.dom, "overflow", "hidden");
		
		var aInterval = isDefined(aInterval) ? aInterval : 1;
		var aIncrement = isDefined(aIncrement) ? aIncrement : Math.floor(this.height / 4);
			
		var ref = this;
		var aIncrement = Math.min(aIncrement, this.height - this.dom.clientHeight);
		
		if (this.dom.clientHeight < this.height) {
			setStyle(this.dom, "height", (this.dom.clientHeight) + aIncrement + "px");
			setTimeout(function() { ref.expand(aInterval, aIncrement); }, aInterval);
		} else {
			// must redraw when expansion is over
			this.prv.mDOM.owner.redraw();
			// restore overflow
			setStyle(this.dom, "overflow", "hidden");
		}
	};
};

/**
 * Tear-away window
 *
 * @author	Jonathan Le
 */
function TearAway()
{
	this.prv = {
		mDOM : getTemplate("tearaway").cloneNode(true)
	}; Function.decl.apply(this);
	
	this.prv.mDOM.parent = this;
	probe(this.prv.mDOM);

	Shapable.apply(this, [this.prv.mDOM]);
	this.getDOM().style.zIndex = ++WindowManager.maxZIndex;

	// assign unique id
	i = 1;
	while ($('tearaway' + i) != null) {
		i++;
	}
	
	this.prv.mDOM.id = 'tearaway' + i;	

	
	this.setContent = function(aContent)
	{
		// insert the content
		this.prv.mDOM.middle.m.innerHTML = "";
		this.prv.mDOM.middle.m.insertBefore(aContent, null);
	};
	
	this.size = function(aWidth, aHeight)
	{
		var dom = this.prv.mDOM;
		var style = dom.style;
		
		if (aWidth) {

			style.width = aWidth + "px";
			
			dom.middle.m.style.width = (aWidth - (xpGetSize(dom.middle.ml).width +
				xpGetSize(dom.middle.mr).width)) + "px";

			dom.bottom.b.style.width = dom.middle.m.style.width;
			dom.top.t.style.width = dom.middle.m.style.width;
		}
		
		if (aHeight) {

		style.height = aHeight + "px";
			dom.middle.ml.style.height = (aHeight - (xpGetSize(dom.top.tl).height +
				xpGetSize(dom.bottom.bl).height)) + "px";
			dom.middle.mr.style.height = (aHeight - (xpGetSize(dom.top.tr).height +
				xpGetSize(dom.bottom.br).height)) + "px";
		}
	};
	
	// generic draggable object
	this.prv.mDOM.onmousedown = startDragObject;
	
	this.prv.mDOM.ondragstart = function(aEvent)
	{
	};
			
	this.prv.mDOM.ondragging = function(aEvent)
	{
		this.className = "tearaway_drag";
	};
	
	this.prv.mDOM.ondragstop = function(aEvent)
	{
		this.className = "tearaway_torn";
	};
	
	// construct
	{
		setStyle(this.prv.mDOM, "display", "block");
	}
	
	return this;
}
TearAway.prototype = new Shapable();

// modal window
function modalWindow () {

	// create 'blackout' area to capture out-of-window clicks
	if (!($('modalwindowblackout0'))) {
		this.blackout = getTemplate('modalwindowblackout').cloneNode(true);
		this.blackout.id = 'modalwindowblackout0';
		document.body.appendChild (this.blackout);
	} else {
		// one already exists
		this.blackout = $('modalwindowblackout0');
	}

	// create tearaway window
	this.tearAway = new TearAway();
	// disable dragging
	this.tearAway.prv.mDOM.onmousedown = null;
	// link to tearAway dom
	this.dom = this.tearAway.dom;
	
	// set class name
	this.dom.className = "tearaway_torn";
	
	// get modal window template
	this.contents = getTemplate ('modalwindowcontents').cloneNode(true);
	// assign unique id
	i = 1;
	while ($('modalwindowcontents' + i) != null) {
		i++;
	}
	
	this.contents.id = 'modalwindowcontents' + i;
	this.contents.style.display = 'block';
	
	this.dom.middle.m.appendChild (this.contents);
	
	this.setContents = function (aContents) {
		this.tearAway.size(aContents.offsetWidth, aContents.offsetHeight);	
		this.contents.appendChild(aContents);
	}
	
	this.setSize = function (aWidth, aHeight) {
		// update contents size
		this.contents.style.width = aWidth + 'px';
		this.contents.style.height = aHeight + 'px';
		// update window size
		this.tearAway.size (this.contents.offsetWidth + this.tearAway.dom.middle.ml.offsetWidth + this.tearAway.dom.middle.mr.offsetWidth,
			this.contents.offsetHeight + this.tearAway.dom.top.t.offsetHeight + this.tearAway.dom.bottom.b.offsetHeight);
		
	}
	
	this.position = function (aLeft, aTop) {
		//this.tearAway.dom.style.position = 'absolute';
		this.tearAway.dom.style.left = aLeft + 'px';
		this.tearAway.dom.style.top = aTop + 'px';
	}
	
	this.show = function () {
	
		if (aSidebar)
			aSidebar.dom.style.display = 'none';
		
		if (taskbar)
			taskbar.dom.style.display = 'none';
			
		this.blackout.style.display = 'block';	
		this.dom.style.display = 'block';
		
		// set appropriate zIndex
		this.blackout.style.zIndex = ++WindowManager.maxZIndex + 23;
		this.dom.style.zIndex = ++WindowManager.maxZIndex + 24;
		
	}
	
	this.hide = function () {
	
		if (aSidebar)
			aSidebar.dom.style.display = 'block';
		
		if (taskbar)
			taskbar.dom.style.display = 'block';
			
		this.blackout.style.display = 'none';	
		
		this.dom.style.display = 'none';
	
	}

	
	
	// construct
	{
		
		// add window to the document		
		document.body.appendChild (this.dom);
		this.dom.style.position = 'absolute';
	
	}
	
	return this;
	
}

